[![Project Status: Active – The project is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
[![Build status](https://github.com/PetrKryslUCSD/Sparspak.jl/workflows/CI/badge.svg)](https://github.com/PetrKryslUCSD/Sparspak.jl/actions)
[![Code Coverage](https://codecov.io/gh/PetrKryslUCSD/FinEtools.jl/branch/master/graph/badge.svg)](https://app.codecov.io/gh/PetrKryslUCSD/Sparspak.jl)
[![Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://petrkryslucsd.github.io/Sparspak.jl/dev)
[![Codebase Graph](https://img.shields.io/badge/Codebase-graph-green.svg)](https://octo-repo-visualization.vercel.app/?repo=PetrKryslUCSD/Sparspak.jl)

# Sparspak.jl

Translation of the well-known sparse matrix software Sparspak (Waterloo Sparse Matrix Package), solving
large sparse systems of linear algebraic equations. Sparspak is composed of the
subroutines from the book "Computer Solution of Large Sparse Positive Definite
Systems" by Alan George and Joseph Liu. Originally written in Fortran 77, later
rewritten in Fortran 90. Here is the software translated into Julia.

The Julia rewrite is released  under the MIT license with an express permission from the authors (George and Liu). Many thanks!

## News

- 09/18/2022: Jürgen Fuhrmann implemented dispatch to allow for arbitrary-precision floating point numbers and ForwardDiff.Dual to be routed around BLAS routines. This then should allow Automatic Differentiation (AD) of a sparse-matrix solve.
- 09/01/2022: Configuration now allows for both Julia 1.6 (LTS) and the subsequent Julia versions.
- 06/03/2022: The sparse LU solver has been now rewritten and tested.

## Contributing

Check out the list of current issues. You may find [the contributor guidelines](https://opensource.com/life/16/3/contributor-guidelines-template-and-tips) helpful.

## Reference

Alan George, Joseph Liu,
Computer Solution of Large Sparse Positive Definite Systems,
Prentice Hall, 1981,
ISBN: 0131652745,
LC: QA188.G46.

## Additional documents

Some design documents are in the folder `docs`: 
[SIAM paper](docs/Object_Oriented_interface_to_Sparspak.pdf), and the [User guide](docs/guide.pdf). These documents are only for
the Fortran version of the package.

using Test

# @time @testset "Sparse SPD method" begin
#     include("test_spd_sparse_method.jl")
# end

@time @testset "Problem" begin
    include("test_problem.jl")
end

@time @testset "Ordering" begin
    include("test_ordering.jl")
end

@time @testset "Graph" begin
    include("test_graph.jl")
end

@time @testset "ETree" begin
    include("test_etree.jl")
end

@time @testset "Grid" begin
    include("test_grid.jl")
end

@time @testset "Generic LAPACK/BLAS" begin
    include("test_blfragments.jl")
end

@time @testset "Sparse method" begin
    include("test_sparse_method.jl")
end

@time @testset "Generic floating type" begin
    include("test_generic.jl")
end

@time @testset "SparseMatrixCSC Interface" begin
    include("test_cscinterface.jl")
end

@time @testset "Structurally unsymmetric" begin
    include("test_structunsymm.jl")
end

@time @testset "Further tests of small unsymmetric matrices" begin
    include("test_small.jl")
end

# A collection of routines to find an MMD (multiple minimum degree) ordering.
# Written by Erik Demaine, eddemaine@uwaterloo.ca
# Based on a Fortran 77 code written by Joseph Liu.
# For information on the minimum degree algorithm see the articles:
# The evolution of the minimum degree algorithm by Alan George and
# Joseph Liu, SIAM Rev. 31 pp. 1 - 19, 1989.0
# Modification of the minimum degree algorithm by multiple
# elimination, ACM Trans. Math. Soft. 2 pp.141 - 152, 1985

module SpkMmd

using OffsetArrays
using ..SpkOrdering: Ordering
using ..SpkGraph: Graph

"""
    mmd!(g::Graph, order::Ordering)

Multiple minimum degree Ordering algorithm (MMD).

Written by Erik Demaine, eddemaine@uwaterloo.ca
Based on a Fortran 77 code written by Joseph Liu.

For information on the minimum degree algorithm see the articles:

The evolution of the minimum degree algorithm by Alan George and
Joseph Liu, SIAM Rev. 31 pp. 1 - 19, 1989.0

Modification of the minimum degree algorithm by multiple
elimination, ACM Trans. Math. Soft. 2 pp.141 - 152, 1985

Input: 
- `g`: graph

Output:
- `order`: updated ordering. Rows and columns are permuted in the same way.
"""
function mmd!(g::Graph, order::Ordering)
    _generalmmd(g.nv, g.xadj, g.adj, order.rperm, order.rinvp)
    order.cinvp .= order.rinvp
    order.cperm .= order.rperm
end

#=
This routine implements the minimum degree algorithm.  It makes use of the
implicit representation of elimination graphs by quotient graphs, and the
notion of indistinguishable nodes.  It also implements the modifications by
multiple elimination and minimum external degree.

Input parameters -
- n - number of equations
  (xadj, adj) - adjacency structure for the graph.
  delta - tolerance value for multiple elimination. FIX ME: should delta be passed as argument?

Output:
  perm, invp - the minimum degree Ordering.

Working arrays -
  degHead (deg) - points to first node with degree deg, or 0 if there
               are no such nodes.
  degNext (node) - points to the next node in the degree list
               associated with node, or 0 if node was the last in the
               degree list.
  degPrev (node) - points to the previous node in a degree list
               associated with node, or the negative of the degree of
               node (if node was the last in the degree list), or 0
               if the node is not in the degree lists.
  superSIze - the size of the supernodes.
  elimHead - points to the first node eliminated in the current pass
               Using elimNext, one can determine all nodes just
               eliminated.
  elimNext (node) - points to the next node in a eliminated supernode
               or 0 if there are no more after node.
  marker - marker vector.
  mergeParent - the parent map for the merged forest.
    needsUpdate (node) - > 0 iff node needs degree update.(0 otherwise)
=#
function _generalmmd(n::IT, xadj::Vector{IT}, adj::Vector{IT}, perm::Vector{IT}, invp::Vector{IT}) where {IT}
    delta = zero(eltype(xadj))
    maxint = typemax(eltype(xadj))
    #
    #       Copy adjacency structure so that we can modify it.
    #
    adjncy = deepcopy(adj[1:(xadj[n+1]-1)])

    deghead1 = zeros(IT, n)
    deghead = OffsetArray(deghead1, 0:(n-1))

    marker = zeros(IT, n)
    mergeparent = zeros(IT, n)
    needsupdate = zeros(IT, n)
    degnext = zeros(IT, n)
    degprev = zeros(IT, n)
    supersize = zeros(IT, n)
    elimnext = zeros(IT, n)
    #
    #       Initialization for the minimum degree algorithm.
    #
    deghead .= 0
    supersize .= 1
    marker .= 0
    elimnext .= 0
    mergeparent .= 0         # Initially there is no merging
    needsupdate .= 0         # Initially no nodes need a degree update
    #
    #       Initialize the degree doubly linked lists.
    #
    for node in 1:n
        ndeg = xadj[node+1] - xadj[node]; fnode = deghead[ndeg]
        deghead[ndeg] = node; degnext[node] = fnode
        if (fnode > 0)
            degprev[fnode] = node
        end
        degprev[node] = -ndeg
    end
    #
    #       num counts the number of ordered nodes plus 1.0
    #
    num = 1
    #
    #       Eliminate all isolated nodes.
    #
    invp[1:n] .= 0
    mdnode = deghead[0]
    while (mdnode > 0)
        marker[mdnode] = maxint
        invp[mdnode] = num
        num = num + 1
        mdnode = degnext[mdnode]
    end
    deghead[0] = 0
    #
    #       Search for node of the minimum degree.
    #       mindeg is the current minimum degree;
    #       tag is used to facilitate marking nodes.
    #
    tag = 1
    mindeg = 1   # We"ve already eliminated all 0 - degree (isolated) nodes
    while (num <= n)
        while (deghead[mindeg] <= 0)
            mindeg = mindeg + 1
        end
        #  
        # Use value of delta to set up mindegLimit, which governs when a degree
        # update is to be performed.
        #  
        mindeglimit = mindeg + delta
        if (delta < 0)
            mindeglimit = mindeg
        end
        elimhead = 0

        while true
            #  -
            # Find a node of minimum degree, say mdNode.
            #  -
            mdnode = deghead[mindeg]
            while (mdnode <= 0)
                mindeg = mindeg + 1
                if (mindeg > mindeglimit)
                    @goto pass
                end
                mdnode = deghead[mindeg]
            end
            #  -
            # Remove mdNode from the degree structure.
            #  -
            mdnextnode = degnext[mdnode]
            deghead[mindeg] = mdnextnode
            if (mdnextnode > 0)
                degprev[mdnextnode] = -mindeg
            end
            invp[mdnode] = num
            if (num + supersize[mdnode] > n)
                @goto main
            end
            #
            # Eliminate mdNode and perform quotient Graph transformation.  Reset
            # tag value if necessary.
            #
            tag = tag + 1
            if (tag >= maxint)
                tag = 1
                marker[findall(marker .< maxint)] .= 0
            end
            
            _mmdelim(mdnode, xadj, adjncy, deghead, degnext, degprev, supersize, elimnext, marker, tag, mergeparent, needsupdate, invp)
            
            num = num + supersize[mdnode]
            #  -
            # Add mdNode to the list of nodes eliminated in this pass.
            #  -
            elimnext[mdnode] = elimhead
            elimhead = mdnode
        end
        @label pass
        #  -
        #           Update degrees of the nodes involved in the
        #           minimum - degree nodes elimination.
        #  -
        if (num > n)
            @goto main
        end
        mindeg, tag = _mmdupdate(elimhead, n, xadj, adjncy, delta, mindeg, deghead, degnext, degprev, supersize, elimnext, marker, tag, mergeparent, needsupdate, invp)
    end # 
    @label main
    _mmdnumber(n, perm, invp, mergeparent)
    return true
end

#=    Purpose - This routine eliminates the node mdNode of
      minimum degree from the adjacency structure, which
      is stored in the quotient Graph format.  It also
      transforms the quotient Graph representation of the
      elimination Graph.
   Input parameters -
      mdNode - node of minimum degree.
      tag - tag value.
      invp - the inverse of an incomplete minimum degree Ordering.
                (It is zero at positions where the Ordering is unknown.)
   Updated parameters -
      (xadj, adjncy) - updated adjacency structure (xadj is not updated).
      degHead (deg) - points to first node with degree deg, or 0 if there
                   are no such nodes.
      degNext (node) - points to the next node in the degree list
                   associated with node, or 0 if node was the last in the
                   degree list.
      degPrev (node) - points to the previous node in a degree list
                   associated with node, or the negative of the degree of
                   node (if node was the last in the degree list), or 0
                   if the node is not in the degree lists.
      superSIze - the size of the supernodes.
      elimNext (node) - points to the next node in a eliminated supernode
                   or 0 if there are no more after node.
      marker - marker vector.
      mergeParent - the parent map for the merged forest.
       needsUpdate (node) - > 0 iff node needs update. (0 otherwise)
=#
function _mmdelim(mdnode, xadj, adjncy, deghead, degnext, degprev, supersize, elimnext, marker, tag, mergeparent, needsupdate, invp)
    maxint = typemax(eltype(xadj))
# 
#       Find reachable set and place in data structure.
# 
    marker[mdnode] = tag
# 
#       elmnt points to the beginning of the list of eliminated
#       neighbors of mdNode, and rloc gives the storage
#       location for the next reachable node.
# 
    elmnt = 0
    rloc = xadj[mdnode] ; rlmt = xadj[mdnode + 1] - 1
    for i in xadj[mdnode]:(xadj[mdnode + 1] - 1)
        neighbor = adjncy[i]
        if (neighbor == 0) break; end
        if (marker[neighbor] < tag)
            marker[neighbor] = tag
            if (invp[neighbor] == 0)
                adjncy[rloc] = neighbor ; rloc = rloc + 1
            else
                elimnext[neighbor] = elmnt ; elmnt = neighbor
            end
        end
    end
# 
#       Merge with reachable nodes from generalized elements.
# 
    while (elmnt > 0)
        adjncy[rlmt] = - elmnt
        j = xadj[elmnt] ; jstop = xadj[elmnt + 1] ; node = adjncy[j]
        while (node != 0)
            if (node < 0)
                j = xadj[- node] ; jstop = xadj[- node + 1]
            else
                if (marker[node] < tag && degnext[node] >= 0)
                    marker[node] = tag
# 
#                       Use storage from eliminated nodes if necessary.
# 
                    while (rloc >= rlmt)
                        link = - adjncy[rlmt]
                        rloc = xadj[link] ; rlmt = xadj[link + 1] - 1
                    end
                    adjncy[rloc] = node ; rloc = rloc + 1
                end
                j = j + 1
            end
            if (j >= jstop) break; end
            node = adjncy[j]
        end
        elmnt = elimnext[elmnt]
    end 
    if (rloc <= rlmt) adjncy[rloc] = 0; end
# 
#       For each node in the reachable set, do the following ...
# 
    i = xadj[mdnode] ; istop = xadj[mdnode + 1] ; rnode = adjncy[i]
    while (rnode != 0)
        if (rnode < 0)
            i = xadj[- rnode] ; istop = xadj[- rnode + 1]
        else
# 
#               If rnode is in the degree list structure ...
# 
            pvnode = degprev[rnode]
            if (pvnode != 0)
# 
#                   Then remove rnode from the structure.
# 
                nxnode = degnext[rnode]
                if (nxnode > 0) degprev[nxnode] = pvnode; end
                if (pvnode > 0)
                    degnext[pvnode] = nxnode
                else
                    deghead[- pvnode] = nxnode
                end
            end
# 
#               Purge inactive quotient neighbors of rnode.
# 
            xqnbr = xadj[rnode]
            for j in xadj[rnode]:(xadj[rnode + 1] - 1)
                neighbor = adjncy[j]
                if (neighbor == 0) break; end
                if (marker[neighbor] < tag)
                    adjncy[xqnbr] = neighbor ; xqnbr = xqnbr + 1
                end
            end
# 
#               If no active neighbor after the purging ...
# 
            nqnbrs = xqnbr - xadj[rnode]
            if (nqnbrs <= 0)
# 
#                   Then merge rnode with mdNode.
# 
                supersize[mdnode] = supersize[mdnode] + supersize[rnode]
                supersize[rnode] = 0 ; mergeparent[rnode] = mdnode
                marker[rnode] = maxint
            else
# 
#                   Else flag rnode for degree update, and
#                   add mdNode as a neighbor of rnode.
# 
                needsupdate[rnode] = nqnbrs + 1
                adjncy[xqnbr] = mdnode ; xqnbr = xqnbr + 1
                if (xqnbr < xadj[rnode + 1]) adjncy[xqnbr] = 0; end
            end
            degprev[rnode] = 0 ; i = i + 1
        end
        if (i >= istop) break; end
        rnode = adjncy[i]
    end
end

#=    Purpose - This routine updates the degrees of nodes
      after a multiple elimination step.
   Input parameters -
      elimHead - the beginning of the list of eliminated
               nodes (i.e., newly formed elements).
      neqns - number of equations.
      (xadj, adjncy) - adjacency structure.
      delta - tolerance value for multiple elimination.
      invp - the inverse of an incomplete minimum degree Ordering.
               (It is zero at positions where the Ordering is unknown.)
   Updated parameters -
      mindeg - new minimum degree after degree update.
      degHead (deg) - points to first node with degree deg, or 0 if there
                   are no such nodes.
      degNext (node) - points to the next node in the degree list
                   associated with node, or 0 if node was the last in the
                   degree list.
      degPrev (node) - points to the previous node in a degree list
                   associated with node, or the negative of the degree of
                   node (if node was the last in the degree list), or 0
                   if the node is not in the degree lists.
      superSIze - the size of the supernodes.
      elimNext (node) - points to the next node in a eliminated supernode
                   or 0 if there are no more after node.
      marker - marker vector for degree update.
      tag - tag value.
      mergeParent - the parent map for the merged forest.
       needsUpdate (node) - > 0 iff node needs update. (0 otherwise)
=#
function _mmdupdate(elimhead, neqns, xadj, adjncy, delta, mindeg, deghead, degnext, degprev, supersize, elimnext, marker, tag, mergeparent, needsupdate, invp)
    maxint = typemax(eltype(xadj))
#
    mindeglimit = mindeg + delta

    deg = zero(eltype(xadj))
    enode = zero(eltype(xadj))

# -
#       For each of the newly formed element, do the following.
# -
    elimnode = elimhead
    while (elimnode > 0)
# -
#           (Reset tag value if necessary.)
# -
        mtag = tag + mindeglimit
        if (mtag >= maxint)
            tag = 1 ; mtag = tag + mindeglimit
            marker[findall(marker .< maxint)] .= 0
        end
# -
#           Create two linked lists from nodes associated with elimNode: one
#           with two neighbors (q2head) in adjacency structure, and the other
#           with more than two neighbors (qxhead).  Also compute elimsize,
#           the number of nodes in this element.
# -
        q2head = 0 ; qxhead = 0 ; elimsize = 0
        i = xadj[elimnode] ; istop = xadj[elimnode + 1] ; enode = adjncy[i]
        while (enode != 0)
            if (enode < 0)
                i = xadj[- enode] ; istop = xadj[- enode + 1]
            else
                if (supersize[enode] != 0)
                    elimsize = elimsize + supersize[enode] ;
                    marker[enode] = mtag
# -
#                       If enode requires a degree update,
#                        do the following.
# -
                    if (needsupdate[enode] > 0)
# -
#                           Place either in qxhead or q2head lists.
# -
                        if (needsupdate[enode] != 2)
                            elimnext[enode] = qxhead ; qxhead = enode
                        else
                            elimnext[enode] = q2head ; q2head = enode
                        end
                    end
                end
                i = i + 1
            end
            if (i >= istop) break; end
            enode = adjncy[i]
        end
# -
#           For each enode in q2 list, do the following.
# -
        enode = q2head
        while (enode > 0)
            if (needsupdate[enode] > 0)
                tag = tag + 1 ; deg = elimsize
# -
#                   Identify the other adjacent element neighbor.
# -
                istart = xadj[enode] ; neighbor = adjncy[istart]
                if (neighbor == elimnode) neighbor = adjncy[istart + 1]; end
# -
#                   If neighbor is uneliminated, increase degree count.
# -
                if (invp[neighbor] == 0)
                    deg = deg + supersize[neighbor]
                else
# - -
#                       Otherwise, for each node in the 2nd element,
#                       do the following.
# -
                    i = xadj[neighbor] ; istop = xadj[neighbor + 1] ;
                    node = adjncy[i]
                    while (node != 0)
                        if (node < 0)
                            i = xadj[- node] ; istop = xadj[- node + 1]
                        else
                            if (node != enode && supersize[node] != 0)
# 
#                                   Case when node is not yet considered.
# 
                                if (marker[node] < tag)
                                    marker[node] = tag ;
                                    deg = deg + supersize[node]
# -
#                                       Case when node is indistinguishable
#                                       Merge them into new supernode.
# -
                                elseif (needsupdate[node] > 0)
                                    if (needsupdate[node] == 2)
# -
#                                           Case when node is not outmatched
# -
                                        supersize[enode] = supersize[enode] + supersize[node]
                                        supersize[node] = 0
                                        marker[node] = maxint
                                        mergeparent[node] = enode
                                    end
                                    needsupdate[node] = 0
                                    degprev[node] = 0
                                end
                            end
                            i = i + 1
                        end
                        if (i >= istop) break ; end
                        node = adjncy[i]
                    end
                end
                deg, mindeg = __updateexternaldegree(deg, mindeg, enode, supersize, deghead, degnext, degprev, needsupdate)
            end # if
            enode = elimnext[enode]
        end # while
# -
#           For each enode in the qx list, do the following.
# -
        enode = qxhead
        while (enode > 0)
            if (needsupdate[enode] > 0)
                tag = tag + 1 ; deg = elimsize
# -
#                   For each unmarked neighbor of enode, do the following.
# -
                for i in xadj[enode]:(xadj[enode + 1] - 1)
                    neighbor = adjncy[i]
                    if (neighbor == 0) break; end
                    if (marker[neighbor] < tag)
                        marker[neighbor] = tag
# - -
#                           If uneliminated, include it in deg count.
# - -
                        if (invp[neighbor] == 0)
                            deg = deg + supersize[neighbor]
                        else
# -
#                               If eliminated, include unmarked nodes
#                               in this element into the degree count.
# -
                            j = xadj[neighbor] ; jstop = xadj[neighbor + 1]
                            node = adjncy[j]
                            while (node != 0)
                                if (node < 0)
                                    j = xadj[- node]; jstop = xadj[- node + 1]
                                else
                                    if (marker[node] < tag)
                                        marker[node] = tag ;
                                        deg = deg + supersize[node]
                                    end
                                    j = j + 1
                                end
                                if (j >= jstop) break; end
                                node = adjncy[j]
                            end
                        end
                    end
                end
                deg, mindeg = __updateexternaldegree(deg, mindeg, enode, supersize, deghead, degnext, degprev, needsupdate)
            end
# -
#               Get next enode in current element.
# -
            enode = elimnext[enode]
        end
# -
#           Get next element in the list.
# -
        tag = mtag ; elimnode = elimnext[elimnode]
    end
    return mindeg, tag
end


function __updateexternaldegree(deg, mindeg, enode, supersize, deghead, degnext, degprev, needsupdate)
    deg = deg - supersize[enode] ; firstnode = deghead[deg]
    deghead[deg] = enode ; degnext[enode] = firstnode
    degprev[enode] = - deg ; needsupdate[enode] = 0
    if (firstnode > 0) degprev[firstnode] = enode; end
    if (deg < mindeg) mindeg = deg; end
    return deg, mindeg
end

#       Purpose - This routine performs the final step in
#       producing the permutation and inverse permutation
#       vectors in the multiple elimination version of the
#       minimum degree Ordering algorithm.
#       No parameters are in fact used, since this is a routine within
#       genmmd, but we list any modifications.
#       Input parameters -
#       neqns - number of equations.
#       Output parameters -
#       perm - the minimum degree Ordering.
#       Updated parameters -
#       invp - On input, new number for roots in merged forest.
#       On output, this plus remaining inverse of perm.
#       mergeParent - the parent map for the merged forest (compressed).
#       Working arrays -
#       mergeLastnum (r) - last number used for a merged tree rooted at r.
#       
function _mmdnumber(neqns, perm, invp, mergeparent)
    
# ----------------------------------------
#           Initially, no nodes except roots in the
#           merged forest have been numbered.
# ----------------------------------------
    mergelastnum = zeros(eltype(perm), neqns)
    ix = findall(mergeparent .== 0)
    mergelastnum[ix] = invp[ix]
# -------------------------------------------------------
#           For each node which has been merged, do the following.
# -------------------------------------------------------
    for node in 1:neqns
        parent = mergeparent[node]
        if (parent > 0)
# ------------------------------------------
#                   Trace the merged tree until one which has
#                   not been merged is found, it root.
# ------------------------------------------
            root = 0
            while (parent > 0)
                root = parent ; parent = mergeparent[parent]
            end
            @assert root > 0
# -----------------------------------------
#                   Number node after those already numbered
#                   in merged subtree rooted at root.
# -----------------------------------------
            num = mergelastnum[root] + 1
            invp[node] = num ; mergelastnum[root] = num
# ------------------------------------
#                   Compress the path just traversed so
#                   that future queries are faster.
# ------------------------------------
            node2 = node
            while (node2 != root)
                parent = mergeparent[node2]
                mergeparent[node2] = root ; node2 = parent
            end
        end
    end
# ------------------------------
#           Inverse invp to compute perm.
# ------------------------------
    perm[invp[1:neqns]] = 1:neqns
end


end

#
# """ This module contains a collection of subroutines for performing symbolic
#  factorization and related functions.
# """
#
module SpkSymfct

using OffsetArrays

#     This subroutine determines the column counts in
#     the Cholesky factor.  It uses an algorithm due to Joseph Liu
#     found in SIMAX 11, 1990, pages 144 - 145.0

# Input parameters:
#     (i) n - number of equations.
#     (i) xadj - array of length n + 1, containing pointers
#                         to the adjacency structure.
#     (i) adj - array of length xadj(n + 1) - 1, containing
#                         the adjacency structure.
#     (i) perm - array of length n, containing the
#                         postordering.
#     (i) invp - array of length n, containing the
#                         inverse of the postordering.
#     (i) parent - array of length n, containing the
#                         elimination tree of the postordered matrix.

# Output parameters:
#     (i) colcnt - array of length n, containing the number
#                         of nonzeros in each column of the factor,
#                         including the diagonal entry.
#     (i) nlnz - number of nonzeros in the factor, including
#                         the diagonal entries.

# Work parameters:
#     (i) marker - array of length n used to mark the
#                          vertices visited in each row subtree.
function _findcolumncounts!(n, xadj, adj, perm, invp, parent, colcnt, nlnz)
#
    marker = zeros(eltype(xadj), n)
    nlnz = n
#-  -  -
#       for each row subtree ...
#-  -  -
    for i in 1:n
        marker[i] = i;   colcnt[i] = 1
#-  -  -  -  -  -  -  -  -  -  -  -  -  -
#           for each nonzero in the lower triangle ...
#-  -  -  -  -  -  -  -  -  -  -  -  -  -
        for k = xadj[perm[i]]:(xadj[perm[i] + 1] - 1)
            j = invp[adj[k]]
            if (j < i)
                while (marker[j] != i)
                    colcnt[j] = colcnt[j] + 1;   nlnz = nlnz + 1
                    marker[j] = i;   j = parent[j]
                end
            end
        end
    end
end


#     This routine performs supernodal symbolic
#     factorization on a reordered linear system.
#     This is essentially a Fortran 90 translation of a code written
#     by Esmond Ng and Barry Peyton.

# Input parameters:
#     (i) n - number of equations
#     (i) xadj - array of length n + 1 containing pointers
#                         to the adjacency structure.
#     (i) adj - array of length xadj(n + 1) - 1 containing
#                         the adjacency structure.
#     (i) perm - array of length n containing the
#                         postordering.
#     (i) invp - array of length n containing the
#                         inverse of the postordering.
#     (i) colcnt - array of length n, containing the number
#                         of nonzeros (non - empty rows) in each
#                         column of the factor,
#                         including the diagonal entry.
#     (i) nsuper - number of supernodes.
#     (i) xsuper - array of length nsuper + 1, containing the
#                         first column of each supernode.
#     (i) snode - array of length n for recording
#                         supernode membership.
#     (i) nofsub - number of subscripts to be stored in
#                         lindx.

# Output parameters:
#     (i) xlindx - array of length n + 1, containing pointers
#                         into the subscript vector.
#     (i) lindx - array of length maxsub, containing the
#                         compressed subscripts.
#     (i) xlnz - column pointers for l.

# Working parameters:
#     (i) mrglnk - array of length nsuper, containing the
#                         children of each supernode as a linked list.
#     (i) rchlnk - array of length n + 1, containing the
#                         current linked list of merged indices (the
#                         "reach" set).
#     (i) marker - array of length n used to mark indices
#                         as they are introduced into each supernode"s
#                         index set.
function _symbolicfact!(n, xadj, adj, perm, invp, colcnt, nsuper, xsuper, snode, nofsub, xlindx, lindx)
        # integer :: n, nsuper, nofsub
        # integer :: xadj(*), adj(*), perm(*), invp(*), xsuper(*)
        # integer :: colcnt(*), snode(*), xlindx(*), lindx(*)
        # integer :: mrglnk(nsuper), marker(n), rchlnk(0:n)
        # integer :: fstcol, head, i, jnzbeg, jnzend, jptr, jsup, jwidth
        # integer :: knz, knzbeg, knzend, kptr, ksup, lngth, lstcol, newi
        # integer :: nexti, node, nzbeg, nzend, pcol, psup, point, tail, width
#
#       initializations ...
#       nzend  : points to the last used slot in lindx.
#       tail   : end of list indicator (in rchlnk(*), not mrglnk(*)).
#       mrglnk : create empty lists.
#       marker : "unmark" the indices.
    marker = zeros(eltype(xadj), n)
    mrglnk = zeros(eltype(xadj), nsuper)
    rchlnk1 = zeros(eltype(xadj), n+1)
    rchlnk = OffsetArray(rchlnk1, 0:n)
# 
    nzend = 0;   head = 0;   tail = n + 1;   point = 1;
        # for jcol in 1:n
        #    marker(jcol) = 0
        # end

    for ksup = 1: nsuper
        mrglnk[ksup] = 0; fstcol = xsuper[ksup]
        xlindx[ksup] = point; point = point + colcnt[fstcol]
    end
    xlindx[nsuper + 1] = point
# -  
#       for each supernode ksup ...
# 

    for ksup in 1:nsuper
# 
#           initializations ...
#           fstcol : first column of supernode ksup.
#           lstcol : last column of supernode ksup.
#           knz    : will count the nonzeros of l in column kcol.
#           rchlnk : initialize empty index list for kcol.
# 
        fstcol = xsuper[ksup];   lstcol = xsuper[ksup + 1] - 1
        width = lstcol - fstcol + 1;   lngth = colcnt[fstcol]
        knz = 0;   rchlnk[head] = tail;   jsup = mrglnk[ksup]
# 
#           if ksup has children in the supernodal e - tree ...
# 
        if (jsup > 0)
#-  -  -  -  -  -  -  -  -  -  -  -
#               copy the indices of the first child jsup into the
#               linked list, and mark each with the value ksup.
#-  -  -  -  -  -  -  -  -  -  -  -
            jwidth = xsuper[jsup + 1] - xsuper[jsup]
            jnzbeg = xlindx[jsup] + jwidth; jnzend = xlindx[jsup + 1] - 1
            for jptr in jnzend:-1:jnzbeg
                newi = lindx[jptr];   knz = knz + 1
                marker[newi] = ksup;   rchlnk[newi] = rchlnk[head]
                rchlnk[head] = newi
            end
#-  -  -  -  -  -  -  -  -
#               for each subsequent child jsup of ksup ...
#-  -  -  -  -  -  -  -  -
            jsup = mrglnk[jsup]
            while (jsup != 0 && knz<lngth)
#-  -  -  -  -  -  -
#                   merge the indices of jsup into the list,
#                   and mark new indices with value ksup.
#-  -  -  -  -  -  -
                jwidth = xsuper[jsup + 1] - xsuper[jsup]
                jnzbeg = xlindx[jsup] + jwidth
                jnzend = xlindx[jsup + 1] - 1;   nexti = head
                for jptr in jnzbeg:jnzend
                    newi = lindx[jptr];   i = nexti;   nexti = rchlnk[i]
                    while(newi > nexti)
                        i = nexti;   nexti = rchlnk[i]
                    end 
                    if (newi < nexti)
                        knz = knz + 1;   rchlnk[i] = newi
                        rchlnk[newi] = nexti;   marker[newi] = ksup
                        nexti = newi
                    end
                end
                jsup = mrglnk[jsup]
            end
        end
# -  --  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#           structure of a(* , fstcol) has not been examined yet.
#           "sort" its structure into the linked list,
#           inserting only those indices not already in the list.
# -  --  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
        if (knz < lngth)
            node = perm[fstcol]
            knzbeg = xadj[node];   knzend = xadj[node + 1] - 1
            for kptr in knzbeg:knzend
                newi = adj[kptr];   newi = invp[newi]
                if (newi > fstcol && marker[newi] != ksup)
# -  -  -  -  -  -  --  -
#                       position and insert newi in list
#                       and mark it with kcol.
# -  -  -  -  -  -  - -  -
                    nexti = head;   i = nexti;   nexti = rchlnk[i]
                    while (newi > nexti)
                        i = nexti;   nexti = rchlnk[i]
                    end
                    knz = knz + 1;   
                    rchlnk[i] = newi
                    rchlnk[newi] = nexti;   
                    marker[newi] = ksup
                end
            end
        end
# 
#           if ksup has no children, insert fstcol into the linked list.
# 
        if (rchlnk[head] != fstcol)
            rchlnk[fstcol] = rchlnk[head]
            rchlnk[head] = fstcol;   knz = knz + 1
        end
#-  -  -  -  -  -  -  -  -  -
#           copy indices from linked list into lindx(*).
# -  -  -  -  -  -  -  -  -  -  -
        nzbeg = nzend + 1;   nzend = nzend + knz
        if (nzend + 1 != xlindx[ksup + 1])
            error("Inconsistency in data structure.")
            return false
        end
        
        i = head 
        for kptr in nzbeg:nzend
            i = rchlnk[i];   lindx[kptr] = i 
        end
# - -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#           if ksup has a parent, insert ksup into its parent"s
#           "merge" list.
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
        if (lngth > width)
            pcol = lindx[xlindx[ksup] + width];   psup = snode[pcol]
            mrglnk[ksup] = mrglnk[psup];   mrglnk[psup] = ksup
        end
    end
    return true
end

#     This routine computes the total number of supernode modifications
#     that will be performed, as well as the elements of the array
#     nmod. The array nmod is of length nsuper; nmod(i) contains the
#     number of supernode modifications to be made to supernode i.
#
# Input parameters:
#     (i) nsuper - number of supernodes.
#     (i) xsuper - array of length nsuper + 1, containing the
#                         first column of each supernode.
#     (i) snode - array of length n for recording
#                         supernode membership.
#     (i) xlindx - array of length n + 1, containing pointers
#                         into the subscript vector.
#     (i) lindx - array of length maxsub, containing the
#                         compressed subscripts.
#
# Output parameters:
#     (i) total - total number of supernode modifications to
#                         be performed.
#     (i) nmod - array containing the number of supernode
#                         modifications made to each supernode.
#
#
#         integer lindx(*), xlindx(*), snode(*), xsuper(*), nmod(*)
#         integer j, jsup, jnode, nsuper, prvsup, supsiz, total
# 
function findnumberofsupermods(nsuper, xsuper, snode, xlindx, lindx, total, nmod)
    nmod .= 0;   total = 0

    for jsup in 1:nsuper
        supsiz = xsuper[jsup + 1] - xsuper[jsup];   prvsup = 0

        for j = xlindx[jsup] + supsiz: xlindx[jsup + 1] - 1
            jnode = snode[lindx[j]]

            if  (jnode != prvsup)
                prvsup = jnode;   total = total + 1
                nmod[jnode] = nmod[jnode] + 1
            end
        end
    end
end

# this routine determines a bottom - up ordering for the
#          vertices of the supernodal elimination tree, and puts that
#          ordering in the array schedule. For information on
#          elimination trees and their representation, see the
#          comments in the module SpkETree and the literature
#          references contained there.
#          For serial computation, the best order is simply the
#          "natural order", with schedule(i) = i for i = 1, 2, ..., nsuper.
#
# Input parameters:
#     (i) nsuper - number of supernodes.
#     (i) xsuper - array of length nsuper + 1, containing the
#                         first column of each supernode.
#     (i) snode - array of length n for recording
#                         supernode membership.
#     (i) xlindx - array of length n + 1, containing pointers
#                         into the subscript vector.
#     (i) lindx - array of length maxsub, containing the
#                         compressed subscripts.
#
# Output parameters:
#     (i) schedule - array containing the order in which the
#                         supernodes are to be computed.
        # integer nsuper, lindx(*), xlindx(*), snode(*), xsuper(*), schedule(*)
        # integer parent(nsuper), count(nsuper)
        # integer k, par, current, col

function _findschedule!(nsuper, xsuper, snode, xlindx, lindx, schedule)
    count = zeros(IT, nsuper)
    parent = zeros(IT, nsuper)

    _findsupernodetree!(nsuper, xsuper, snode, xlindx, lindx, parent)

    count = 0; current = 0
    for k in 1:nsuper
        par = parent[k]
        if (par != 0) count[par] = count[par] + 1; end
        if (count[k] == 0)
            current = current + 1; schedule[current] = k
        end
    end

    for k in 1:nsuper
        col = schedule[k]; par = parent[col]
        if (par != 0)
            count[par] = count[par] - 1
            if (count[par] == 0)
                current = current + 1; schedule[current] = par
            end
        end
    end

end

# this routine determines the parent vector representation of
#          the supernodal elimination tree, and puts the result
#          in the array parent. For information on
#          elimination trees and their representation, see the
#          comments in the module SpkETree and the literature
#          references contained there.
#
# Input parameters:
#     (i) nsuper - number of supernodes.
#     (i) xsuper - array of length nsuper + 1, containing the
#                         first column of each supernode.
#     (i) snode - array of length n for recording
#                         supernode membership.
#     (i) xlindx - array of length n + 1, containing pointers
#                         into the subscript vector.
#     (i) lindx - array of length maxsub, containing the
#                         compressed subscripts.
#
# Output parameter:
#     (i) parent - array containing the the parent supernode
#                         of each supernode
#
#
#
# integer lindx(*), xlindx(*), snode(*), xsuper(*), parent(*)
# integer j, jsup, nsuper
#
function _findsupernodetree!(nsuper, xsuper, snode, xlindx, lindx, parent)
    parent[nsuper] = 0

    for jsup = 1: (nsuper - 1)
        j = xlindx[jsup] + xsuper[jsup + 1] - xsuper[jsup]
        parent[jsup] = snode[lindx[j]]
    end

end


#     This routine uses the elimination tree and the factor column
#     counts to compute the supernode partition; it assumes a
#     postordering of the elimination tree.
#     For more information on supernodes, see the article by
#     Liu, Ng and Peyton: On finding supernodes for sparse matrix
#     computations, SIMAX 14 pp. 242 - 252, 1993.0
#
#     For information on elimination trees, see the article by
#     Liu: The role of elimination trees in sparse factorization,
#     SIMAX 11 pp.134 - 172, 1990.0
#
#     In order to improve multiprocessor utilization, it is
#     helpful to split the larger supernodes into smaller ones.
#     This is done by introducing artificial supernodes.
#     The input parameter maxSize governs this process; no
#     supernode will have more than maxSize columns.
##
# Input parameters:
#     (i) n - number of equations.
#     (i) maxSize - limit on supernode size
#     (i) parent - array of length n, containing the
#                          elimination tree of the postordered matrix.
#     (i) colcnt - array of length n, containing the
#                          factor column counts: i.e., the number of
#                          nonzero entries in each column of L
#                          (including the diagonal entry).
# Output parameters:
#     (i) nofsub - number of subscripts.
#     (i) nsuper - number of supernodes
#     (i) xsuper - beginning of each supernode
#     (i) snode - array of length n for recording
#                           supernode membership.
function _findsupernodes!(n, parent, colcnt, nofsub, nsuper, xsuper, snode, maxsize)
        # integer :: n, nofsub, nsuper, kcol, jsup, k, maxsize, marker(n)
        # integer :: parent(*), colcnt(*), xsuper(*), snode(*)
        # integer :: limit, index
        # real    :: delta, supsize
    marker = zeros(eltype(parent), n)
#
#       compute the fundamental supernode partition.
#-  -  -  -  -  -  -  -  -  -  -
    nsuper = 1; xsuper[1] = 1; 
    for kcol = 2:n
        if (parent[kcol - 1] == kcol && colcnt[kcol - 1] == colcnt[kcol] + 1) continue; end
        nsuper = nsuper + 1; xsuper[nsuper] = kcol
    end
    xsuper[nsuper + 1] = n + 1

# 
#       Determine where to split the supernodes using marker.
# 
    for jsup in 1:nsuper
        supsize = xsuper[jsup + 1] - xsuper[jsup]
        if (supsize > maxsize)
            delta = supsize / (1.0 + supsize / maxsize);
            limit = Int(floor(xsuper[jsup + 1] - delta / 2.0))
            k = 1; index = Int(floor(xsuper[jsup] + delta))
            while (index < limit)
                marker[index] = 1
                k = k + 1; index = Int(floor(xsuper[jsup] + k * delta))
            end
        end
    end
# 
#       Now determine the refined (final) supernode partitioning.
# 
    nsuper = 1; snode[1] = 1; nofsub = colcnt[1]
    for kcol in 2:n
        if (marker[kcol] != 1)
            if (parent[kcol - 1] == kcol)
                if (colcnt[kcol - 1] == colcnt[kcol] + 1)
                    snode[kcol] = nsuper; continue
                end
            end
        end
        nsuper = nsuper + 1; snode[kcol] = nsuper
        xsuper[nsuper] = kcol; nofsub = nofsub + colcnt[kcol]
    end
    xsuper[nsuper + 1] = n + 1

    return nofsub, nsuper
end

end 

# using Pkg;
# Pkg.activate()
# Pkg.instantiate()

# using Pkg
# pkg"add https://github.com/PetrKryslUCSD/Sparspak.jl.git#main"

using Documenter, Sparspak

makedocs(
	modules = [Sparspak],
	doctest = false, clean = true,
	format = Documenter.HTML(prettyurls = true, assets = ["assets/custom.css"], ),
	authors = "Petr Krysl",
	sitename = "Sparspak.jl",
	pages = Any[
	"Home" => "index.md",
	"How to" => "howto/howto.md",
	"Tutorials" => "tutorials/tutorials.md",
    "Concepts" => "concepts/concepts.md",
    "Reference" => "man/man.md",
        ]
	)

deploydocs(
    repo = "github.com/PetrKryslUCSD/Sparspak.jl.git",
)

using Test

module morde001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering

function _test()
    M, N = 15, 15
    order = SpkOrdering.Ordering(M, N)
    @test order.rperm == collect(1:M)
    order = SpkOrdering.Ordering(M)
    @test order.rperm == collect(1:M)
    return true
end

_test()
end # module

module Sparspak

include("Utilities/SpkUtilities.jl")
include("Utilities/GenericBlasLapackFragments.jl")
include("Grid/SpkGrid.jl")
include("Problem/SpkProblem.jl")
include("Ordering/SpkOrdering.jl")
include("Graph/SpkGraph.jl")
include("ETree/SpkETree.jl")
include("SparseSpdMethod/SpkMMD.jl")
include("SparseSpdMethod/SpkSymFct.jl")
include("SparseSpdMethod/SpkSpdMMOps.jl")
include("SparseSpdMethod/SpkLDLtFactor.jl")
include("SparseMethod/SpkLUFactor.jl")
include("SparseMethod/SpkSparseBase.jl")
include("SparseSpdMethod/SpkSparseSpdBase.jl")
include("SparseSpdMethod/SpkSparseSpdSolver.jl")
include("SparseMethod/SpkSparseSolver.jl")

using .SpkProblem
"""
    const Problem = SpkProblem

The module that defines the Sparspak problem.
"""
const Problem = SpkProblem

using .SpkSparseSolver
"""
    const SparseSolver = SpkSparseSolver

The module that defines a sparse-matrix LU solver.
"""
const SparseSolver = SpkSparseSolver


include("SparseCSCInterface/SparseCSCInterface.jl")
import .SparseCSCInterface: sparspaklu, sparspaklu!
export sparspaklu, sparspaklu!

end # module

# This is the `Problem` class -- a major module of Sparspak90.

# The variable `nrows`
# - number of rows in the matrix
# - number of elements in a row permutation
# The variable `ncols`
# - number of columns in the matrix
# - number of elements in a column permutation
# Other variables:

# NOTE: a user can input (i, j, v), indicating that position
# (i, j) in the matrix contains the value v.
# Or, a user can input (i, j), indicating that position
# (i, j) is nonzero, but not specifying a value there.
# Hence the distinction between "nonzeros" and
# "nonzero values" below.

# nnz - number of nonzero * values * in the matrix.
# dnz - number of nonzero * values * on the diagonal of the matrix.
# nedges - number of nonzeros in the matrix.
# dedges - number of nonzeros on the diagonal of the matrix.

# The elements of the matrix are stored by columns using three ``parallel""
# arrays:(link, rowSubs, values). The first element of column i stored is
# found in values(head(i)). The row subscript of the element is
# rowSubs(head(i)). The next element in the column is values(link(head(i)))
# and so on. A zero value for link marks the end of the column.

# NOTE: the elements in each column are stored in increasing
# order of row subscript. Some algorithms used in the
# package depend on this fact.

# The right hand side of the matrix equation is stored in rhs,
# and the solution (when provided or computed) is stored in the array x.
# The size of the arrays is extended as required, and their lengths
# for not generally correspond to the number of nonzeros in the matrix:
# or the number of columns in the matrix.


# The user can improve efficiency by providing an estimate of the
# number of nonzeros in the matrix -  - this is done via the optional
# keyword parameter "NNZ" in the subroutine Construct.

# Similarly, the user can improve efficiency by providing
# estimates for the number of rows and columns in the matrix via the
# optional keyword parameters "nRows" and "nCols".


module SpkProblem

using SparseArrays
using ..SpkUtilities: _BIGGY, __extend
using ..SpkGrid: Grid

"""
    Problem{IT, FT}

Type of a sparse-matrix coupled linear algebraic equations problem.

Fields 
- `nrows`: 
    * number of rows in the matrix
    * number of elements in a row permutation
- `ncols`:
    * number of columns in the matrix
    * number of elements in a column permutation

Other variables:

NOTE: a user can input `(i, j, v)`, indicating that position `(i, j)` in the
matrix contains the value `v`. Or, a user can input `(i, j)`, indicating that
position `(i, j)` is nonzero, but not specifying a value there. Hence the
distinction between "nonzeros" and "nonzero values" below.

- `nnz` - number of nonzero * values * in the matrix.
- `dnz` - number of nonzero * values * on the diagonal of the matrix.
- `nedges` - number of nonzeros in the matrix.
- `dedges` - number of nonzeros on the diagonal of the matrix.

The elements of the matrix are stored by columns using three "parallel"
arrays: (`link`, `rowsubs`, `values`). The first element of column `i` stored is
found in `values[head[i]]`. The row subscript of the element is
`rowsubs[head[i]]`. The next element in the column is `values[link[head[i]]]`
and so on. A zero value for `link` marks the end of the column.

NOTE: the elements in each column are stored in increasing order of row
subscript. Some algorithms used in the package depend on this fact.

The right hand side of the matrix equation is stored in `rhs`,
and the solution (when provided or computed) is stored in the array `x`.
The size of the arrays is extended as required, and their lengths
for not generally correspond to the number of nonzeros in the matrix:
or the number of columns in the matrix.
    

The user can improve efficiency by providing an estimate of the number of
nonzeros in the matrix -  - this is done via the optional keyword
parameter `nnz`.
    
Similarly, the user can improve efficiency by providing estimates for the number
of rows and columns in the matrix via the optional keyword parameters `nrows`
and `ncols`.
"""
mutable struct Problem{IT<:Integer, FT}
    info::String
    # `lenhead` is the current length of the arrays `head` and `x`.
    lenhead::IT
    # `lenlink` is the current length of the arrays `link`, `rowsubs`, `values`.
    lenlink::IT
    # `lenrhs`  is the current length of the array `rhs`.
    lenrhs::IT
    # `lastused` is the last position in `values` and `link` that is occupied.
    lastused::IT
    head::Vector{IT}
    link::Vector{IT}
    rowsubs::Vector{IT}
    # The variable `nrows`
    # - number of rows in the matrix
    # - number of elements in a row permutation
    nrows::IT
    # The variable `ncols`
    # - number of columns in the matrix
    # - number of elements in a column permutation
    ncols::IT
    # nnz - number of nonzero * values * in the matrix.
    nnz::IT
    # dnz - number of nonzero * values * on the diagonal of the matrix.
    dnz::IT
    # nedges - number of nonzeros in the matrix.
    nedges::IT
    # dedges - number of nonzeros on the diagonal of the matrix.
    dedges::IT
    values::Vector{FT}
    rscales::Vector{FT}
    cscales::Vector{FT}
    x::Vector{FT}
    rhs::Vector{FT}
end

"""
    Problem(nrows::IT, ncols::IT, nnz::IT=2500, z::FT=0.0, info = "") where {IT, FT}

Construct a problem.
"""
function Problem(nrows::IT, ncols::IT, nnz::IT=2500, z::FT=0.0, info = "") where {IT<:Integer, FT}
    lenlink = nnz
    lenhead = ncols
    lenrhs = nrows

    lastused = zero(IT)
    nedges = zero(IT)
    dnz = zero(IT)
    dedges = zero(IT)
    
    head = zeros(IT, lenhead)
    rhs = zeros(FT, lenrhs)
    x = zeros(FT, lenhead)
    link = zeros(IT, lenlink)
    rowsubs = zeros(IT, lenlink)
    values = fill!(Vector{FT}(undef, lenlink), _BIGGY())
    rscales = FT[]
    cscales = FT[]
    
    return Problem{IT,FT}(info, lenhead, lenlink, lenrhs, lastused, head,
        link, rowsubs, nrows, ncols, nnz, dnz, nedges, dedges, values,
        rscales, cscales, x, rhs)
end

"""
    inaij!(p::Problem{IT,FT}, rnum, cnum, aij=zero(FT)) where {IT,FT}

Input a matrix coefficient. 

The value is *added* to the existing contents.
"""
function inaij!(p::Problem{IT,FT}, rnum, cnum, aij=zero(FT)) where {IT<:Integer, FT}
    if (rnum < 1 || cnum < 1)
        @warn "$(@__FILE__): invalid matrix subscripts $(rnum), $(cnum): input ignored"
        return false
    end

    if (p.lastused > p.lenlink - 1)
        p.lenlink = max(2 * p.lenlink, 3 * p.ncols)
        p.link = __extend(p.link, p.lenlink)
        p.rowsubs = __extend(p.rowsubs, p.lenlink)
        p.values = __extend(p.values, p.lenlink, _BIGGY())
    end

    p.nrows = max(rnum, p.nrows)
    p.ncols = max(p.ncols, cnum)

    if (p.ncols > p.lenhead)
        p.lenhead = 2 * p.ncols
        p.head = __extend(p.head, p.lenhead)
        p.x = __extend(p.x, p.lenhead)
    end

    if (p.nrows > p.lenrhs)
        p.lenrhs = 2 * p.nrows
        p.rhs = __extend(p.rhs, p.lenrhs)
    end

    ptr = p.head[cnum]    # ^ * check if rnum is in the row list.
    lastptr = 0
    while (ptr > 0)
        if (p.rowsubs[ptr] > rnum)
            break
        end
        if (p.rowsubs[ptr] == rnum)
            if (p.values[ptr] == _BIGGY())
                p.nnz = p.nnz + 1
                p.values[ptr] = aij
                if (rnum == cnum)
                    p.dnz = p.dnz + 1
                end
            else
                p.values[ptr] = p.values[ptr] + aij
            end
            return
        end
        lastptr = ptr
        ptr = p.link[ptr]
    end                 # not there; add to column

    p.lastused = p.lastused + 1
    p.nedges = p.nedges + 1
    p.rowsubs[p.lastused] = rnum

    if (rnum == cnum)
        p.dedges = p.dedges + 1
    end

    if (lastptr == 0)         # first element in the list end
        p.link[p.lastused] = p.head[cnum]
        p.head[cnum] = p.lastused
    elseif (ptr == 0)          # add to the end of the list end
        p.link[lastptr] = p.lastused
        p.link[p.lastused] = 0
    else                       # insert in the middle of the list.
        p.link[lastptr] = p.lastused
        p.link[p.lastused] = ptr
    end

    p.values[p.lastused] = aij
    p.nnz = p.nnz + 1
    if (rnum == cnum)
        p.dnz = p.dnz + 1
    end
    return true
end 

"""
    inbi!(p::Problem{IT, FT}, rnum::IT, bi::FT) where {IT, FT}

Input an entry of the right-hand side vector.
"""
function inbi!(p::Problem{IT, FT}, rnum::IT, bi::FT) where {IT<:Integer, FT}
    if (rnum < 1)
        error("Invalid rhs subscript $(rnum).")
        return false
    end

    p.nrows = max(rnum, p.nrows)
    if (p.nrows > p.lenrhs)
        p.lenrhs = 2 * p.nrows; p.rhs = __extend(p.rhs, p.lenrhs) 
    end

    p.rhs[rnum] = p.rhs[rnum] + bi 
    return true
end

"""
    insparse!(p::Problem{IT,FT}, spm) where {IT,FT}

Input sparse matrix.

Build a problem from a sparse matrix.
"""
function insparse!(p::Problem{IT,FT}, spm) where {IT<:Integer, FT}
    I, J, V = findnz(spm)
    return insparse!(p, I, J, V)
end

"""
    insparse!(p::Problem{IT,FT}, I::Vector{IT}, J::Vector{IT}, V::Vector{FT}) where 
    {IT,FT}

Build a problem from a sparse matrix in the COO format.
"""
function insparse!(p::Problem{IT,FT}, I::Vector{IT}, J::Vector{IT}, V::Vector{FT}) where {IT<:Integer, FT}
    for i in eachindex(I)
        if ! inaij!(p, I[i], J[i], V[i])
            return false 
        end
    end
    return true
end

"""
    outsparse(p::Problem{IT,FT})  where {IT,FT}

Output the sparse matrix.
"""
function outsparse(p::Problem{IT,FT})  where {IT<:Integer, FT}
    if (p.nrows == 0 && p.ncols == 0) 
        return spzeros(p.nrows, p.ncols)
    end
    nr = p.nrows;  nc = p.ncols
    I = IT[]
    J = IT[]
    V = FT[]
    for i in 1:nc
        ptr = p.head[i]
        while (ptr > 0)
            r = p.rowsubs[ptr]
            if (r <= nr)
                push!(J, i)
                push!(I, r)
                push!(V, p.values[ptr])
            end
            ptr = p.link[ptr]
        end
    end
    return sparse(I, J, V, nr, nc)
end


"""
    makegridproblem(g::Grid{IT}) where {IT}

This routine fills in a problem object using a given grid.

Input:
- `g` - the `Grid` to be used to fill a `Problem` matrix

Output:
- `p` - the Problem object to be filled
"""
function makegridproblem(g::Grid{IT}) where {IT<:Integer}
    M1 = -1.0; FOUR = 4.0
    n = g.h * g.k
    p = Problem(n, n)

    for i in 1:g.h
        for j in 1:g.k
            inaij!(p, g.v[i, j], g.v[i, j], FOUR)
            if (i > 1) inaij!(p, g.v[i, j], g.v[i - 1, j], M1); end
            if (j > 1) inaij!(p, g.v[i, j], g.v[i, j - 1], M1); end
        end
    end 

    for i in 1:g.h
        for j in 1:g.k
            inaij!(p, g.v[i, j], g.v[i, j], FOUR)
            if (i>1 && j>1)   inaij!(p, g.v[i, j], g.v[i - 1, j - 1], M1); end
            if (j<g.k && i>1) inaij!(p, g.v[i, j], g.v[i - 1, j + 1], M1); end
        end
    end

    return p
end
    
"""
    makegridproblem(h::IT, k::IT) where {IT}

Construct a problem object based on a grid.

Input:
- `h` - the number of rows in the Grid
- `k` - the number of columns in the Grid

Output:
- `p` - the Problem object to be filled
"""
function makegridproblem(h::IT, k::IT) where {IT<:Integer}
    g = Grid(h, k)
    return makegridproblem(g)
end

"""
    makerhs!(p::Problem, x::Vector{FT} = FT[], mtype = "T") where {FT}

This routine constructs the RHS of a problem given an `x` for the
equation `Ax = rhs`. The `x` must have the same number of elements
as the problem (represented by A above) has columns.
If `x` is not present,  a right hand side is contructed so that
the solution is 1, 2, 3, ...m.

Input Parameter:
  x - the vector in the equation ``Ax = rhs""
  mType - matrix type (optional). If the matrix is symmetric and only
            the lower or upper triangle is present, the user must let
            the routine know this by setting mType to one of:
                "L" or "l" - when only the lower triangle is present
                "U" or "u" - when only the upper triangle is present
                "T" or "t" - when either the lower or upper triangle is
                             present.
Updated Parameter:
   p - the problem for which the RHS is being constructed.
"""
function makerhs!(p::Problem, x::Vector{FT}, mtype = "T") where {FT}
    if (p.nnz == 0)
        error("Matrix is NULL. The rhs cannot be computed.")
        return p
    end

    if (!isempty(x) )  
        p.x .= x
    else
        p.x .= FT.(1:p.ncols)
    end

    p.rhs .= 0.0
    res = deepcopy(p.rhs)

    computeresidual(p, res, p.x, mtype)

    p.rhs .= -res
    p.x .= 0.0

    return p
end


"""
    computeresidual(p::Problem, res::Vector{FT}, xin::Vector{FT} = FT[], mtype = "T") where {FT}

Compute the residual of a problem.

Given a vector `x`, this routine calculates the difference between the RHS of
the given Problem and `A*x` and places this in `res`.

Input:
- `p` - the `Problem` used to calculate `res`, using `xin`
- `xin` - the input "solution" vector used to compute the residual
- `mtype` - matrix type (optional). If the matrix is symmetric and only
            the lower or upper triangle is present, the user must let
            the routine know this by setting mType to one of:
                "L" or "l" - when only the lower triangle is present
                "U" or "u" - when only the upper triangle is present
                "T" or "t" - when either the lower or upper triangle is
                             present.

Output:
- `res` - the calculated residual
"""
function computeresidual(p::Problem, res::Vector{FT}, xin::Vector{FT} = FT[], mtype = "T") where {FT}
        # type (problem) :: p
        # real (double), dimension(:), intent(out) :: res
        # real (double) :: x(p.ncols)

#       real (doubledouble) :: t, temp, r(p.nrows), u#       
        # real (double) :: t, temp, r(p.nrows), u

        # real (double), dimension(:), optional :: xin
        # integer :: rnum, cnum, ptr, flag
        # character (len = *), optional :: mtype
        # character (len = *), parameter :: fname = "computeresidualproblem:"

    flag = 0
    if (lowercase(mtype) == "t" || lowercase(mtype) == "l" || lowercase(mtype) == "u")
        flag = 1
    else
        error("Invalid value for mtype, $mtype.")
        return false
    end

    x = deepcopy(res)
    if (isempty(xin))
        @. x = xin
    else
        @. x = p.x
    end

    r = deepcopy(p.rhs)
    @. r = p.rhs

    for cnum in 1:p.ncols
        ptr = p.head[cnum]; t = x[cnum]
        while (ptr > 0)
            rnum = p.rowsubs[ptr];  temp = p.values[ptr]
            if (temp != _BIGGY())
                r[rnum] -= t * temp
                if (rnum != cnum && flag == 1)
                    u = x[rnum]
                    r[cnum] -= u * temp
                end
            end
            ptr = p.link[ptr]
        end
    end

    @. res = r
    return true
end

"""
    infullrhs!(p::Problem{IT,FT}, rhs)  where {IT,FT}

Add a vector of values, rhs, to the current right hand
side of a problem object.

Input:
- `rhs` - the source right-hand side. It *must* be of length at least
        `p.nrows` and if it is greater than `p.nrows`, only the first
        `p.nrows` are used.

Updated:
- `p` - the problem in which rhs is to be inserted.
"""
function infullrhs!(p::Problem{IT,FT}, rhs)  where {IT<:Integer, FT}
    for i in p.nrows:-1:1
        inbi!(p, i, FT(rhs[i]))
    end
    return p
end

"""
    zerorhs!(p::Problem{IT,FT})  where {IT<:Integer, FT}

Zero out the right hand side vector.
"""
function zerorhs!(p::Problem{IT,FT})  where {IT<:Integer, FT}
    p.rhs[:] .= zero(FT)
    return p
end

"""
    isstructuresymmetric(p::Problem{IT,FT})  where {IT<:Integer, FT}

Is the problem structurally symmetric?
"""
function isstructuresymmetric(p::Problem{IT,FT})  where {IT<:Integer, FT}
    for cnum  in  1:p.ncols
        ptr = p.head[cnum]
        while ( ptr > 0 )
            if ( p.rowsubs[ptr] != cnum && !ijpresent(p, cnum, p.rowSubs[ptr] ) )   
                return false
            end
            ptr = p.link(ptr)
        end 
    end   
    return true
end

"""
    ijpresent(p::Problem{IT,FT} rnum, cnum) where {IT<:Integer, FT}

Check to see if the entry (rnum, cnum) is present.
If it is, the routine returns .true., otherwise .false. is returned.
"""
function ijpresent(p::Problem{IT,FT}, rnum, cnum) where {IT<:Integer, FT}
    ptr = p.head[cnum]
    while ( ptr > 0 )
        if ( p.rowSubs[ptr] > rnum ) 
            return false
        end
        if ( p.rowSubs[ptr]  ==  rnum ) 
            return true
        end 
        ptr = p.link[ptr]
    end 
    return false
end
    

end # module 

using Test

module mgrap001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    graph = SpkGraph.Graph(p)
    @test graph.xadj == [1, 3, 6, 8, 9, 11, 13]
    @test graph.adj == [2, 6, 1, 3, 4, 2, 5, 2, 3, 6, 1, 5]
    return true
end

_test()
end # module

module mgrap002
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    graph = SpkGraph.Graph(p)
    @test SpkGraph.isstructuresymmetric(graph)
    return true
end

_test()
end # module

module mgrap003
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3, with an element (5, 3) missing, hence unsymmetric.
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    graph = SpkGraph.Graph(p)
    @test !SpkGraph.isstructuresymmetric(graph)
    return true
end

_test()
end # module


module mgrap004
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3, with an element (5, 3) missing, hence unsymmetric.
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    graph = SpkGraph.Graph(p)
    SpkGraph.makestructuresymmetric(graph)
    @test SpkGraph.isstructuresymmetric(graph)
    @test graph.xadj == [1, 3, 6, 8, 9, 11, 13]
    @test graph.adj == [2, 6, 1, 3, 4, 2, 5, 2, 3, 6, 1, 5]
    return true
end

_test()
end # module

# Grid objects contain a representation of an h by k rectangular grid.
# h - the number of rows ("height")
# k is the number of columns ("kolumns").
#  v is an h by k integer array

module  SpkGrid

mutable struct Grid{IT}
    h::IT
    k::IT
    v::Matrix{IT}
end

"""
    Grid(h::IT, k::IT) where {IT}

Construct a grid with a given number of spacings.
"""
function Grid(h::IT, k::IT) where {IT}
    n = h * k; 
    v = zeros(IT, h, k)
    for i in 1:h
        for j in 1:k
            v[i, j] = k * (i - 1) + j
        end
    end
    return Grid(h, k, v)
end

end 

using Test

module csc_mgrap001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    graph = SpkGraph.Graph(spm)
    @test graph.xadj == [1, 3, 6, 8, 9, 11, 13]
    @test graph.adj == [2, 6, 1, 3, 4, 2, 5, 2, 3, 6, 1, 5]
    return true
end

_test()
end # module

module csc_mgrap002
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    graph = SpkGraph.Graph(spm)
    @test SpkGraph.isstructuresymmetric(graph)
    return true
end

_test()
end # module

module csc_mgrap003
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3, with an element (5, 3) missing, hence unsymmetric.
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    graph = SpkGraph.Graph(spm)
    @test !SpkGraph.isstructuresymmetric(graph)
    return true
end

_test()
end # module


module csc_mgrap004
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkGraph

function _test()
    # Matrix from Figure 3.1.3, with an element (5, 3) missing, hence unsymmetric.
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    graph = SpkGraph.Graph(spm)
    SpkGraph.makestructuresymmetric(graph)
    @test SpkGraph.isstructuresymmetric(graph)
    @test graph.xadj == [1, 3, 6, 8, 9, 11, 13]
    @test graph.adj == [2, 6, 1, 3, 4, 2, 5, 2, 3, 6, 1, 5]
    return true
end

_test()
end # module

module csc_msolver001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkSparseSolver: SparseSolver, solve!



function _test(T=Float64, n=20)
    spm = sprand(T, n, n, 1/n)
    spm = -spm - spm' + 40 * LinearAlgebra.I
    slv = SparseSolver(spm)
    exsol = ones(T,n)
    rhs = spm*exsol
    solve!(slv,rhs)

    @test rhs≈exsol
end


_test()
end


module csc_msolver002
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Random
using MultiFloats, ForwardDiff
Random.rand(rng::AbstractRNG, ::Random.SamplerType{ForwardDiff.Dual{T,V,N}}) where {T,V,N} = ForwardDiff.Dual{T,V,N}(rand(rng,T))



function _test(T=Float64, n=20)
    spm = sprand(T, n, n, 1/n)
    spm = -spm - spm' + 40 * LinearAlgebra.I

    
    exsol = ones(T,n)
    rhs = spm*exsol
    lu=sparspaklu(spm)
    sol=lu\rhs
    @test sol≈exsol

    spm.nzval.-=0.1
    rhs = spm*exsol
    sparspaklu!(lu,spm)
    sol=lu\rhs
    @test sol≈exsol

    # create a matrix with different sparsity pattern
    spm2 = spm + sprand(T, n, n, 1/n)
    rhs = spm2*exsol

    # test fails attempting to reuse factorisation lu
    @test_throws ErrorException sparspaklu!(lu,spm2; allow_pattern_change=false)

    # test with default allow_pattern_change == true
    sparspaklu!(lu,spm2)
    sol=lu\rhs
    @test sol≈exsol
    
end


_test(Float64)
_test(Float64x2)
_test(ForwardDiff.Dual{Float64,Float64,1})


function _test_asymmetric(T=Float64, n=20)
    spm = sprand(T, n, n, 1/n)
    spm = -spm + 40 * LinearAlgebra.I

    
    exsol = ones(T,n)
    rhs = spm*exsol
    lu=sparspaklu(spm)
    sol=lu\rhs
    @test sol≈exsol

    spm.nzval.-=0.1
    rhs = spm*exsol
    sparspaklu!(lu,spm)
    sol=lu\rhs
    @test sol≈exsol

    # create a matrix with different sparsity pattern
    spm2 = spm + sprand(T, n, n, 1/n)
    rhs = spm2*exsol

    # test fails attempting to reuse factorisation lu
    @test_throws ErrorException sparspaklu!(lu,spm2; allow_pattern_change=false)

    # test with default allow_pattern_change=true (will redo symbolic factorization)
    sparspaklu!(lu,spm2)
    sol=lu\rhs
    @test sol≈exsol

    # test with uninitialized lu 
    lu_nofact = sparspaklu(spzeros(1, 1); factorize=false)
    sparspaklu!(lu_nofact,spm2; allow_pattern_change=false) # always allow update of unfactorized lu
    sol=lu_nofact\rhs
    @test sol≈exsol

end

_test_asymmetric(Float64)

end


# Int32-indexed CSC matrices.  Sparspak historically required the index integer
# type to equal `BlasInt` (Int64) so a `SparseMatrixCSC{Float64,Int32}` failed
# in the constructors of `Graph` / `_SparseBase` / `Ordering` / `SparseSolver`
# (mismatched scalar/array element types) and in the LU factorization path
# (BLAS-typed scalars expected throughout). Exercise both index types here so
# the matrix builds, factors, and solves without copying to Int64.
module csc_int32_solver
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Random

function _test(T, IT, n=8)
    Random.seed!(42)
    spm_default = sprand(T, n, n, 0.4)
    spm_default = spm_default + n * LinearAlgebra.I
    spm = SparseMatrixCSC{T, IT}(spm_default)
    @test typeof(spm) === SparseMatrixCSC{T, IT}

    # Solver constructed without factorization (the path LinearSolve.jl uses
    # during init_cacheval — this must not throw even if a downstream BLAS
    # call would not yet support `IT`).
    lu_nofact = sparspaklu(spm; factorize=false)
    @test lu_nofact isa Sparspak.SpkSparseSolver.SparseSolver{IT, T}

    # Full factor-and-solve.
    exsol = ones(T, n)
    rhs = spm * exsol
    lu = sparspaklu(spm)
    sol = lu \ rhs
    @test sol ≈ exsol

    # Update values only (same pattern) and re-solve.
    spm.nzval .-= T(0.1)
    rhs = spm * exsol
    sparspaklu!(lu, spm)
    sol = lu \ rhs
    @test sol ≈ exsol
end

for IT in (Int32, Int64)
    for T in (Float64, Float32, ComplexF64, ComplexF32)
        _test(T, IT)
    end
end

end

""" 
This module contains a collection of subroutines for finding and manipulating
elimination trees, finding (weighted) postorderings of them, and related
functions.
"""

module SpkETree

using ..SpkOrdering: Ordering
using ..SpkGraph: Graph

"""
    ETree{IT}

Elimination Tree type.

Used for finding and manipulating elimination trees, finding
(weighted) postorderings of them, and more.
"""
mutable struct ETree{IT}
    nv::IT
    parent::Vector{IT}
end

"""
    ETree(nv::IT) where {IT}

Construct elimination tree.
"""
function ETree(nv::IT) where {IT}
    parent = zeros(IT, nv)
    return ETree(nv, parent)
end

"""
    _getetree!(g::Graph, order::Ordering, t::ETree)

Given a graph and an ordering, find the corresponding elimination tree. 

Input Parameter:
- `g` - the graph whose elimination tree is to be found.
- `order` - the ordering for g

Updated Parameters:
- `t` - the elimination tree.
"""
function _getetree!(g::Graph, order::Ordering, t::ETree)
    _findetree!(g.nv, g.xadj, g.adj, order.rperm, order.rinvp, t.parent)
end


#   To determine the elimination tree from a given ordering and the
#   adjacency structure. The parent vector is returned.
# Input Parameters:
#   n - number of equations.
#   (xadj, adj) - the adjacency structure.
#   (rPerm, rInvp) - permutation and inverse permutation vectors
# Output Parameters:
#   parent - the parent vector of the elimination tree.
# Working Storage:
#    ancestor - the ancestor vector.
function _findetree!(n, xadj, adj, rperm, rinvp, parent)
#
    ancestor = zeros(eltype(xadj), n)
    for i in 1:n
        parent[i] = 0; ancestor[i] = 0; vertex = rperm[i]
        for j = xadj[vertex]:(xadj[vertex + 1] - 1)
            nbr = rinvp[adj[j]]
            if (nbr < i)
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#                   For each nbr, find the root of its current
#                   elimination tree.  Perform path compression
#                   as the subtree is traversed.
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                while(ancestor[nbr] != 0 && ancestor[nbr] != i)
                    next = ancestor[nbr]; ancestor[nbr] = i; nbr = next
                end
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#                   Now nbr is the root of the subtree.  Make i
#                   the parent vertex of this root.
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                if (ancestor[nbr] == 0)
                    parent[nbr] = i; ancestor[nbr] = i
                end
            end
        end
    end
end

"""
    _getpostorder!(t::ETree{IT}, order::Ordering, weight) where {IT}

Find a postordering of elimination tree t. The resulting ordering is returned in
the object `order`. The vector argument `weight` is optional. If it is present,
the postordering will be one where the child vertices are ordered in increasing
order of their weights. The elimination tree is reordered according to the
postordering.

Input Parameters:
- `t` - the e - tree for which the postordering is found.
- `weight` - an optional weighting on the tree

Updated Parameters:
- `order` - the required ordering
"""
function _getpostorder!(t::ETree{IT}, order::Ordering, weight) where {IT}
    firstson = zeros(IT, t.nv)
    brother = zeros(IT, t.nv)
    stack = zeros(IT, t.nv)
    invpos = zeros(IT, t.nv)

    _weightedbinarytree!(t.nv, t.parent, weight, firstson, brother)

    _postordertree!(t.nv, firstson, brother, invpos, t.parent, stack)

    stack[invpos[1:t.nv]] = weight[1:t.nv]
    weight[1:t.nv] = stack[1:t.nv]

    stack[1:t.nv] = invpos[order.rinvp[1:t.nv]]
    order.rinvp[1:t.nv] = stack[1:t.nv]
    order.rperm[order.rinvp[1:t.nv]] = 1:t.nv
    order.cperm = order.rperm; order.cinvp = order.rinvp
end

function _getpostorder!(t::ETree{IT}, order::Ordering) where {IT}
    firstson = zeros(IT, t.nv)
    brother = zeros(IT, t.nv)
    stack = zeros(IT, t.nv)
    invpos = zeros(IT, t.nv)

    _binarytree!(t.nv, t.parent, firstson, brother)

    _postordertree!(t.nv, firstson, brother, invpos, t.parent, stack)

    stack[1:t.nv] = invpos[order.rinvp[1:t.nv]]
    order.rinvp[1:t.nv] = stack[1:t.nv]
    order.rperm[order.rinvp[1:t.nv]] = 1:t.nv
    order.cperm = order.rperm; order.cinvp = order.rinvp
end


#   To determine the binary tree representation of the elimination
#   tree given by the parent vector.  The returned representation
#   will be given by the first - son and brother vectors.  The root
#   of the binary tree is always n.
# Input Parameters:
#   n - number of equations.
#   parent - the parent vector of the elimination tree.
#             It is assumed that parent(i) > i except for the roots.
# Output Parameters:
#   fson - the first son vector.
#    brother - the brother vector.
function _binarytree!(n, parent, fson, brother)
    fson .= zero(eltype(parent)); brother .= zero(eltype(parent)); lroot = n
# --
#       for each vertex : = n - 1 step - 1 downto 1, do the following.
# --
    for vertex = (n - 1):-1:1
        vpar = parent[vertex]
        if (vpar <= 0 || vpar == vertex)
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#               vertex has no parent.  Given structure is a forest.
#               Set vertex to be one of the roots of the trees.
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
            brother[lroot] = vertex; lroot = vertex
        else
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#               otherwise, becomes first son of its parent.
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
            brother[vertex] = fson[vpar]; fson[vpar] = vertex
        end
    end
    brother[lroot] = 0
end


#   Based on the binary representation (first - son, brother) of the
#   elimination tree, a postordering is determined. The corresponding
#   parent vector is also modified to reflect the reordering.
# Input Parameters:
#   root - root of the elimination tree (usually n).
#   fson - the first son vector.
#   brother - the brother vector.
# Updated Parameters:
#   parent - the parent vector.
# Output Parameters:
#   rInvpos - inverse permutation for the postordering.
# Working Parameters:
# stack - the stack for postorder traversal of the tree.
function _postordertree!(root, fson, brother, rinvpos, parent, stack)
    num = 0; top = 0; vertex = root
# --
#       traverse along the first sons pointer and push the tree vertices
#       along the traversal into the stack.
# -  --
    while(vertex > 0)

        while(vertex > 0)
            top = top + 1; stack[top] = vertex; vertex = fson[vertex]
        end

        while(vertex <= 0 && top > 0)
            vertex = stack[top]; top = top - 1
            num = num + 1; rinvpos[vertex] = num
#
#               then, traverse to its younger brother if it has one.
#
            vertex = brother[vertex]
        end

    end

    for vertex in 1:num
        nuvertex = rinvpos[vertex]; vpar = parent[vertex]
        if (vpar > 0) vpar = rinvpos[vpar]; end
        brother[nuvertex] = vpar
    end

    parent .= brother
end



#   To determine a binary tree representation of the elimination
#   tree, for which every "last child" has the maximum possible
#   column nonzero count in the factor.  The returned representation
#   will be given by the first - son and brother vectors.  The root of
#   the binary tree is always n.
# Input Parameters:
#   n - number of equations.
#   parent - the parent vector of the elimination tree.
#             It is assumed that parent(i) > i except for the roots.
#   weight - a weighting on the tree.
# Output Parameters:
#   fson - the first son vector.
#   brother - the brother vector.
# Working Storage:
#    lson - last son vector.
function _weightedbinarytree!(n, parent, weight, fson, brother)
#
    lson = zeros(eltype(fson), n)
    fson .= zero(eltype(fson)); brother .= zero(eltype(fson)); 
    lson .= zero(eltype(fson)); lroot = n
# --
#       for each vertex : = n - 1 step - 1 downto 1, do the following.
# --
    for vertex in (n - 1):-1:1
        vpar = parent[vertex]
        if (vpar <= 0 || vpar == vertex)
#
#               vertex has no parent.  Given structure is a forest.
#               set vertex to be one of the roots of the trees.
# 
            brother[lroot] = vertex; lroot = vertex
        else
# 
#               otherwise, becomes first son of its parent.
# 
            vlastson = lson[vpar]
            if (vlastson != 0)
                if (weight[vertex] >= weight[vlastson])
                    brother[vertex] = fson[vpar]; fson[vpar] = vertex
                else
                    brother[vlastson] = vertex; lson[vpar] = vertex
                end
            else
                fson[vpar] = vertex; lson[vpar] = vertex
            end
        end
    end

    brother[lroot] = 0

end

end

#
# Test the generic blas/lapack  code against blas calls in Sparspak
#

module test_blfragments
using Test
using LinearAlgebra
using Random
using LinearAlgebra.BLAS: BlasInt

# These will be called for Float64, calling back to BLAS
using Sparspak.SpkSpdMMops:  _gemm!,_gemv!,_getrf!,_trsm!,_laswp!

# These are the Julia based replacements which are explicitely called.
using Sparspak.GenericBlasLapackFragments:  ggemm!,ggemv!,ggetrf!,gtrsm!,glaswp!

#
# Two potentialy useful extensions for numeber types to be tested
#
using ForwardDiff
using MultiFloats




#
# Relax rtol test of equality for computation results
# by this factor: Float64 and other data types may have
# some subtle differences in their arithmetics.
# Besides some random exceptions, a factor of 100 should work,
# we now seed the rng  in order to avoid such situations.
const rtolfactor=100.0

#
# Struct to allow strided reshape in the case where
# length(v)<lda*n, but length(v) is still large enough to hold all columns
# of the mxn submatrix
#
struct StridedReshape{T} <: AbstractMatrix{T}
    v::Union{Vector{T},SubArray{T, 1, Vector{T}, Tuple{UnitRange{Int64}}, true}}
    lda::BlasInt
    m::BlasInt
    n::BlasInt
end

@inline idx(A::StridedReshape, i,j)= (j-1)*A.lda+i
Base.size(A::StridedReshape)=(A.m, A.n)
Base.getindex(A::StridedReshape,i,j)= @inbounds A.v[idx(A,i,j)]
Base.setindex!(A::StridedReshape,v,i,j)= @inbounds A.v[idx(A,i,j)]=v

#
# Reshape matrix with leading dimension lda>=m, taking into account the
# (for standard blas entirely legal)
# possibility that for the largest column only m elements are stored (instead of lda)



function strided_reshape(A::AbstractVector{T},lda,m,n)::Union{StridedReshape{T},SubArray{T, 2, Base.ReshapedArray{T, 2, SubArray{T, 1, Vector{T}, Tuple{UnitRange{Int64}}, true}, Tuple{}}, Tuple{UnitRange{Int64}, UnitRange{Int64}}, false},Base.ReshapedArray{T, 2, SubArray{T, 1, Vector{T}, Tuple{UnitRange{Int64}}, true}, Tuple{}}} where T
    if lda == m
        #
        # In this case we can assume that the A buffer is large enough to hold
        # all elements of the reshaped matrix:
        #
        x=reshape(view(A,1:lda*n),m,n)
    else
        if length(A)>=lda*n
            #
            # Also, in this case we can assume that the A buffer is large enough to hold
            # all elements of the reshaped matrix:
            #
            vA=view(A,1:lda*n)
            # But we will only work with the mxn submatrix
            view(reshape(vA,lda,n),1:m,1:n)
        else
            # In the (rare) case where there is not enough
            # memory to hold the last column of reshape(vA,lda,n)
            # As the occurance may be rare, we probably can live with the current performance
            # hits.
            StridedReshape(A,lda,m,n)
        end
    end
end

#
# Random number generation for duals
#
Random.rand(rng::AbstractRNG, ::Random.SamplerType{ForwardDiff.Dual{T,V,N}}) where {T,V,N} = ForwardDiff.Dual{T,V,N}(rand(rng,T))

#
# Map eps for duals and complex to underlying FP type
#
Base.eps(::Type{ForwardDiff.Dual{T,V,N}}) where {T,V,N}= Base.eps(T)
Base.eps(::Type{Complex{T}}) where {T}= Base.eps(T)


#
# Conversion to Standard FP from dual etc.
#
f64(V::AbstractVector{T}) where T=[Float64(ForwardDiff.value(V[i])) for i=1:length(V)]
f64(V::AbstractMatrix{T}) where T=[Float64(ForwardDiff.value(V[i,j])) for i=1:size(V,1), j=1:size(V,2)]
f64(x::ForwardDiff.Dual{T}) where T=Float64(ForwardDiff.value(x))
f64(x)=Float64(x)

#
# In the complex case, we keep the  complex numbers
#
f64(V::AbstractVector{Complex{T}}) where T =[Complex{Float64}(ForwardDiff.value(V[i])) for i=1:length(V)]
f64(V::AbstractMatrix{Complex{T}}) where T =[Complex{Float64}(ForwardDiff.value(V[i,j])) for i=1:size(V,1), j=1:size(V,2)]
f64(x::Complex{T}) where T = Complex{Float64}(x)

r(x)=round(x,digits=3)

#
# Verify f64 conversion
#
function tf64()
    for n in rand(1:50,15)
        for m in rand(1:50, 15)
            A=rand(n,m)
            v=rand(m)
            @assert A==f64(A)
            @assert v==f64(v)
        end
    end
    true
end

function buflayout(m,n,mode)
    if mode==:contiguous
        lda=m
        la=m*n
    elseif mode==:strided
        lda=m+rand(1:5)
        la=lda*n
    elseif mode==:strided_chopped
        lda=m+rand(1:5)
        la=lda*n - rand(1:lda-m)
    elseif mode==:mixed
        lda=m+rand(0:5)
        la=lda*n - rand(0:lda-m)
    else
        error("Wrong buflayout mode: $(mode)")
    end
    la,lda
end


#
# Test ggemm! for a couple of random data,
# compare timing between generic and blas  implementations.
# 
#
function _tgemm(T=Float64;N=15,mode=:random)
    tblas=0.0
    tgnrc=0.0
    for m in rand(1:50,N)
        for n in rand(1:50,N)
            for k in rand(1:50,N)
                for transA in ['n','t']
                    for transB in ['n','t']

                        if transA=='n'
                            la,lda=buflayout(m,k,mode)
                        else
                            la,lda=buflayout(k,m,mode)
                        end
                        A=rand(T,la)
                        
                        if transB=='n'
                            lb,ldb=buflayout(k,n,mode)
                        else
                            lb,ldb=buflayout(n,k,mode)
                        end
                        B=rand(T,lb)

                        lc,ldc=buflayout(m,n,mode)
                        C=rand(T,lc)


                        α=-one(T)
                        β=one(T)
                        
                        
                        A64=f64(A)
                        C64=f64(C)
                        B64=f64(B)

                        α64=f64(α)
                        β64=f64(β)
                        
                        
                        
                        tblas+=@elapsed _gemm!(transA,transB, m,n,k, α64 ,A64, lda ,B64,ldb, β64,C64,ldc)
                        tgnrc+=@elapsed ggemm!(transA,transB, m,n,k, α ,A, lda ,B,ldb, β,C,ldc)
                        if ! isapprox(f64(C),C64,rtol=rtolfactor*max(eps(T),eps(Float64)))
                            error("error in $transA-$transB ($n, $m, $k), rtol=$(norm(f64(C)-C64)/norm(C64))")
                        end
                    end
                end
            end
        end
    end
    tgnrc,tblas
end

const N_compile=10
function tgemm(T=Float64)
    _tgemm(T,N=N_compile,mode=:mixed)
    ctgnrc,ctblas=_tgemm(T,N=15,mode=:contiguous)
    stgnrc,stblas=_tgemm(T,N=15,mode=:strided)
    sctgnrc,sctblas=_tgemm(T,N=15,mode=:strided_chopped)
    @info "gemm:  tgnrc/tblas: contig: $(ctgnrc/ctblas |>r) strided: $(stgnrc/stblas |>r) StridedReshape: $(sctgnrc/sctblas|>r)"
    true
end

#
# Test ggemv! for a couple of random data,
# compare timing between generic and blas  implementations
#
function _tgemv(T=Float64;N=15,mode=:mixed)
    tblas=0.0
    tgnrc=0.0
    for m in rand(1:50,N)
        for n in rand(1:50,N)
            for transA in ['n','t']
                
                if transA=='n'
                    la,lda=buflayout(m,n,mode)
                else
                    la,lda=buflayout(n,m,mode)
                end
                A=rand(T,la)
   
                α=rand(T)
                β=rand(T)
                
                A64=f64(A)
                   
                α64=f64(α)
                β64=f64(β)
                
                if transA=='n'
                    X=rand(T,n)
                    Y=rand(T,m)
                else
                    X=rand(T,m)
                    Y=rand(T,n)
                end
                X64=f64(X)
                Y64=f64(Y)
                tblas+=@elapsed _gemv!(transA, m,n, α64 ,A64, m ,X64, β64,Y64)
                tgnrc+=@elapsed ggemv!(transA, m,n, α ,A, m ,X, β,Y)
                if ! isapprox(f64(Y),Y64,rtol=rtolfactor*max(eps(T),eps(Float64)))
                    error("error in $transA ($n, $m), rtol=$(norm(f64(Y)-Y64)/norm(Y64))")
                end
            end
        end
    end
    tgnrc,tblas
end

function tgemv(T=Float64)
    _tgemv(T,N=N_compile,mode=:mixed)
    ctgnrc,ctblas=_tgemv(T,N=30,mode=:contiguous)
    stgnrc,stblas=_tgemv(T,N=30,mode=:strided)
    sctgnrc,sctblas=_tgemv(T,N=30,mode=:strided_chopped)
    @info "gemv:  tgnrc/tblas: contig: $(ctgnrc/ctblas |>r) strided: $(stgnrc/stblas |>r) StridedReshape: $(sctgnrc/sctblas|>r)"
    true
end



#
# Test ggetrf! for a couple of random data,
# compare timing between generic and blas  implementations
#
function _tgetrf(T=Float64;N=25, mode=:mixed)
    tblas=0.0
    tgnrc=0.0
    for n in rand(1:100,N)
        m=n
        la,lda=buflayout(m,n,mode)
        A=-rand(T,la)
        rA=strided_reshape(A,lda,m,m)
        for i=1:n
            rA[i,i]=2.0*max(m,n)  
        end
        
        ipiv=zeros(BlasInt,min(m,n))
        ipiv64=zeros(BlasInt,min(m,n))
        
        A64=f64(A)

        tblas+=@elapsed Alu64=_getrf!(m,n,A64,lda,ipiv64)
        tgnrc+=@elapsed Alu=ggetrf!(m,n,A,lda,ipiv)
        if ! isapprox(f64(A),A64,rtol=rtolfactor*max(eps(T),eps(Float64)))
            error("error: ($m,$n), rtol=$(norm(f64(A)-A64)/norm(A64))")
        end
    end
    tgnrc,tblas
end

function tgetrf(T=Float64)
    _tgetrf(T,N=N_compile,mode=:mixed)
    ctgnrc,ctblas=_tgetrf(T,N=15,mode=:contiguous)
    stgnrc,stblas=_tgetrf(T,N=15,mode=:strided)
    sctgnrc,sctblas=_tgetrf(T,N=15,mode=:strided_chopped)
    @info "getrf: tgnrc/tblas: contig: $(ctgnrc/ctblas |>r) strided: $(stgnrc/stblas |>r) StridedReshape: $(sctgnrc/sctblas|>r)"
    true
end

#
# Test gtrsm! for a couple of random data,
# compare timing between generic and blas  implementations
#
function _ttrsm(T=Float64;N=15,mode=:mixed)
    tblas=0.0
    tgnrc=0.0
    ldx()=rand(0:5)
    for m in rand(1:50,N)
        for n in rand(1:50,N)
            for side in ['r','l']
                for uplo  in ['l','u']
                    for transa in ['t','n']
                        for diag  in ['u','n']

                            k= side=='l' ? m : n
#                            lda=ldx()+k
#                            A=-rand(T,lda*k)

                            la,lda=buflayout(k,k,mode)
                            A=-rand(T,la)
                            rA=strided_reshape(A,lda,k,k)
                            for i=1:k
                                rA[i,i]=10.0 #Diagonal(10I,size(A[1,1],1))
                            end

#                            ldb= ldx()+m
#                            B=rand(T,ldb*n)

                        
                            lb,ldb=buflayout(m,n,mode)
                            B=rand(T,lb)
                            
                            alpha=rand(T)
                            alpha64=f64(alpha)
                            B64=f64(B)
                            A64=f64(A)

                            tblas += @elapsed _trsm!(side, uplo, transa, diag, m,n, alpha64, A64, lda, B64,ldb)
                            tgnrc += @elapsed gtrsm!(side, uplo, transa, diag, m,n, alpha, A, lda, B,ldb)
                            if ! isapprox(f64(B),B64,rtol=rtolfactor*max(eps(T),eps(Float64)))
                                error(" error for side $side, uplo $uplo, transa $transa diag $diag $n, $m, rtol=$(norm(f64(B)-B64)/norm(B64))")
                            end
                        end
                    end
                end
            end
        end
    end
    tgnrc,tblas
end

function ttrsm(T=Float64)
    _ttrsm(T,N=N_compile,mode=:mixed)
    ctgnrc,ctblas=_ttrsm(T,N=15,mode=:contiguous)
    stgnrc,stblas=_ttrsm(T,N=15,mode=:strided)
    sctgnrc,sctblas=_ttrsm(T,N=15,mode=:strided_chopped)
    @info "trsm:  tgnrc/tblas: contig: $(ctgnrc/ctblas |>r) strided: $(stgnrc/stblas |>r) StridedReshape: $(sctgnrc/sctblas|>r)"
    true
end

#
# Test glaswp! for a couple of random data,
# compare timing between generic and blas  implementations
#
function _tlaswp(T=Float64;N=15)
    tblas=0.0
    tgnrc=0.0
    for n in rand(1:50,N)
        ipiv=shuffle(1:n)
        A=rand(T,n)
        A64=f64(A)
        tblas += @elapsed _laswp!(A64,n,1,n,ipiv)
        tgnrc += @elapsed glaswp!(A,n,1,n,ipiv)
        if ! (f64(A)≈ A64)
            error("laswp failed for $n, rtol=$(norm(f64(A)-A64)/norm(A64))")
        end
    end
    tgnrc,tblas
end


function tlaswp(T=Float64)
    _tlaswp(T,N=N_compile)
    tgnrc,tblas=_tlaswp(T,N=15)
    @info "laswp:  tgnrc/tblas=$(tgnrc/tblas |>r)"
    true
end

#
# Run all tests for type T
#
function test_all_T(T=Float64)
    @info "$T:"
    @testset "test $(T)" begin
        @test tgemm(T)
        @test tgemv(T)
        @test tgetrf(T)
        @test ttrsm(T)
        @test tlaswp(T)
    end
end

#
# Run tests for selected types
#
function test_all(; seed=9876)

    # Julia manual:
    # Reseed the random number generator: 
    # rng will give a reproducible sequence of numbers 
    # if and only if a seed is provided.
    Random.seed!(seed)

    @testset "setup" begin
        @test tf64()
    end
    test_all_T(Float64)
    test_all_T(Float32)
    test_all_T(ComplexF64)
    test_all_T(ComplexF32)
    test_all_T(ForwardDiff.Dual{Float64,Float64,1})
    test_all_T(ForwardDiff.Dual{Float64,Float64,2})
    test_all_T(MultiFloats.Float64x1)
    test_all_T(MultiFloats.Float64x2)
end

_test()=test_all()

_test()

end

using Test
using Logging: disable_logging, global_logger, ConsoleLogger, BelowMinLevel, min_enabled_level

# disable_logging(BelowMinLevel)
# global_logger(ConsoleLogger(stderr, BelowMinLevel))

# @show min_enabled_level(global_logger())

module msprs001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkSparseBase

function _test()
    # Matrix from Figure 3.1.3
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    s = SpkSparseBase._SparseBase(p)
    return true
end

_test()
end # module

module msprs002
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkSparseSolver

function _test()
    # Matrix from Figure 3.1.3
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    s = SpkSparseSolver.SparseSolver(p)
    return true
end

_test()
end # module

module msprs003
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!

function maketridiagproblem(n)
    p = SpkProblem.Problem(n, n)
    for i in 1:(n-1)
        inaij!(p, i + 1, i, -1.0)
        inaij!(p, i, i, 4.0)
        inaij!(p, i, i + 1, -1.0)
        inbi!(p, i, 2.0 * i)
    end
    inaij!(p, n, n, 4.0)
    inbi!(p, n, 3.0 * n + 1.0)

    return p
end

function _test()
    p = maketridiagproblem(11)
    
    s = SparseSolver(p)
    findorder!(s)
    o =  s.slvr.order
    @test o.nrows == 11
    @test o.ncols == 11
    
    @test o.rperm == vec([11   1  10   2   9   3   8   4   7   5   6])
    @test o.rinvp == vec([2   4   6   8  10  11   9   7   5   3   1])
    @test o.cperm == vec([11   1  10   2   9   3   8   4   7   5   6])
    @test o.cinvp == vec([2   4   6   8  10  11   9   7   5   3   1])
    return true
end

_test()
end # module

module msprs004
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!

function maketridiagproblem(n)
    p = SpkProblem.Problem(n, n)
    for i in 1:(n-1)
        inaij!(p, i + 1, i, -1.0)
        inaij!(p, i, i, 4.0)
        inaij!(p, i, i + 1, -1.0)
        inbi!(p, i, 2.0 * i)
    end
    inaij!(p, n, n, 4.0)
    inbi!(p, n, 3.0 * n + 1.0)

    return p
end

function _test()
    p = maketridiagproblem(11)
    # @show outsparse(p)
    s = SparseSolver(p)
    findorder!(s)
    symbolicfactor!(s)

    @test s.slvr.xlnz == [1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21, 23]    
    @test s.slvr.xunz == [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10] 
    
    @test s.slvr.xlindx == [1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21]
    @test s.slvr.lindx == [1, 2, 2, 3, 3, 4, 4, 5, 5, 11, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11]
      
    return true
end

_test()
end # module


module msprs005
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!
using MultiFloats

function maketridiagproblem(n,T=Float64)
    p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
    for i in 1:(n-1)
        inaij!(p, i + 1, i, T(-1.0))
        inaij!(p, i, i, T(4.0))
        inaij!(p, i, i + 1, T(-1.0))
        inbi!(p, i, T(2.0 * i))
    end
    inaij!(p, n, n, T(4.0))
    inbi!(p, n, 3.0 * n + T(1.0))

    return p
end

function _test(T=Float64)
    p = maketridiagproblem(11,T)
    # @show outsparse(p)
    s = SparseSolver(p)
    findorder!(s)
    symbolicfactor!(s)
    inmatrix!(s)
    
   @test s.slvr.unz  == vec(T[-1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0])
   @test s.slvr.lnz  == vec(T[4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0, -1.0,  4.0])
   @test s.slvr.xunz == vec([1           2           3           4        5           6           7           8           9          10          10            10])                       
     @test s.slvr.xlnz == vec([1           3           5           7           9          11          13          15          17          19          21          23])
    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module


module msprs006
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!

using MultiFloats

function maketridiagproblem(n,T=Float64)
    p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
    for i in 1:(n-1)
        inaij!(p, i + 1, i, T(-1.0))
        inaij!(p, i, i, T(4.0))
        inaij!(p, i, i + 1, T(-1.0))
        inbi!(p, i, T(2.0 * i))
    end
    inaij!(p, n, n, T(4.0))
    inbi!(p, n, 3.0 * n + T(1.0))

    return p
end


function _test(T=Float64)
    p = maketridiagproblem(11,T)
    # @show outsparse(p)
    s = SparseSolver(p)
    findorder!(s)
    symbolicfactor!(s)
    inmatrix!(s)
    factor!(s)
    s_xlnz = vec([ 1           3           5           7           9          11          13          15          17          19          21          23])                                 
    s_xunz = vec([ 1           2           3           4           5           6           7           8           9          10          10          10 ])
    @test s.slvr.xlnz == s_xlnz
    @test s.slvr.xunz == s_xunz
    s_lnz  = T[  4.0, -0.25000000000000000, 3.7500000000000000, -0.26666666666666666, 3.7333333333333334, -0.26785714285714285, 3.7321428571428572 
, -0.26794258373205743, 3.7320574162679425, -0.26794871794871794, 4.0, -0.25000000000000000, 3.7500000000000000, -0.26666666666666666, 3.7333333333333334, -0.26785714285714285, 3.7321428571428572, -0.26794258373205743, 3.7320574162679425, -0.26794871794871794, -1.0000000000000000, 3.4641025641025642     ]
    s_unz = T[ -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0]
    @test norm(s.slvr.lnz - s_lnz) / norm(s_lnz) < 1e-6
    @test norm(s.slvr.unz - s_unz) / norm(s_unz) < 1e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module


module msprs007
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!

using MultiFloats

function maketridiagproblem(n,T=Float64)
    p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
    for i in 1:(n-1)
        inaij!(p, i + 1, i, T(-1.0))
        inaij!(p, i, i, T(4.0))
        inaij!(p, i, i + 1, T(-1.0))
        inbi!(p, i, T(2.0 * i))
    end
    inaij!(p, n, n, T(4.0))
    inbi!(p, n, 3.0 * n + T(1.0))

    return p
end


function _test(T=Float64)
    p = maketridiagproblem(11,T)
    
    s = SparseSolver(p)
    findorder!(s)
    symbolicfactor!(s)
    inmatrix!(s)
    factor!(s)
    solve!(s)
    A = Float64.(outsparse(p)) # no generic method for sparse...
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module


module msprs008
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!

using MultiFloats
function maketridiagproblem(n,T=Float64)
    p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
    for i in 1:(n-1)
        inaij!(p, i + 1, i, T(-1.0))
        inaij!(p, i, i, T(4.0))
        inaij!(p, i, i + 1, T(-1.0))
        inbi!(p, i, T(2.0 * i))
    end
    inaij!(p, n, n, T(4.0))
    inbi!(p, n, 3.0 * n + T(1.0))

    return p
end

function _test(T=Float64)
    p = maketridiagproblem(11000,T)
    
    s = SparseSolver(p)
    findorder!(s)
    symbolicfactor!(s)
    inmatrix!(s)
    factor!(s)
    # before  LULSolve 
    # rhs = 34.0, 20.0, 18.0, 16.0, 14.0, 2.00, 4.00, 6.00, 8.00, 10.0, 12.0              
    # after  LULSolve  
    # rhs = 34.0, 28.5, 25.6, 22.857142857142858, 20.124401913875598, 2.00, 4.50, 7.2, 9.9285714285714288, 12.660287081339714, 20.784615384615385  
    solve!(s)
    A = Float64.(outsparse(p))
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module


module msprs009
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver,  solve!

using MultiFloats

function maketridiagproblem(n,T=Float64)
    p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
    for i in 1:(n-1)
        inaij!(p, i + 1, i, T(-1.0))
        inaij!(p, i, i, T(4.0))
        inaij!(p, i, i + 1, T(-1.0))
        inbi!(p, i, T(2.0 * i))
    end
    inaij!(p, n, n, T(4.0))
    inbi!(p, n, 3.0 * n + T(1.0))

    return p
end

function _test(T=Float64)
    p = maketridiagproblem(1101)
    
    s = SparseSolver(p)
    solve!(s)
    A = Float64.(outsparse(p))
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module


module msprs010
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.SpkProblem: insparse!, outsparse, infullrhs!
using Sparspak.SpkSparseSolver: SparseSolver, solve!

using MultiFloats

function makerandomproblem(n,T=Float64)
    
    spm = sparse([1, 2, 10, 25, 27, 3, 18, 29, 4, 5, 27, 4, 5, 10, 6, 22, 7, 8, 
    20, 9, 16, 19, 2, 5, 10, 16, 22, 26, 11, 21, 12, 28, 13, 31, 14, 15, 14, 15, 9, 10, 16, 22, 17, 21, 23, 24, 3, 18, 23, 25, 9, 19, 8, 20, 11, 17, 21, 31, 6, 10, 16, 22, 23, 17, 18, 22, 23, 17, 24, 26, 27, 2, 18, 25, 28, 10, 24, 26, 2, 4, 24, 27, 12, 25, 28, 29, 3, 28, 29, 30, 29, 30, 13, 21, 31], [1, 2, 
    2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 7, 8, 8, 9, 9, 9, 10, 10, 10, 10, 
    10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 16, 16, 17, 17, 17, 
    17, 18, 18, 18, 18, 19, 19, 20, 20, 21, 21, 21, 21, 22, 22, 22, 22, 22, 23, 
    23, 23, 23, 24, 24, 24, 24, 25, 25, 25, 25, 26, 26, 26, 27, 27, 27, 27, 28, 
    28, 28, 28, 29, 29, 29, 29, 30, 30, 31, 31, 31], T[20.0, 20.0, -0.47048158392539896, -0.40373736633011315, -0.29904858543128643, 20.0, -0.8929708555328307, -0.25537381390842373, 20.0, -0.517204141985797, -0.4252150843692021, -0.517204141985797, 20.0, -0.007891864303108176, 20.0, -0.11187965399280864, 20.0, 20.0, -0.8431376173205444, 20.0, -0.867243409546438, -0.4387621276975887, -0.47048158392539896, -0.007891864303108176, 20.0, -0.5439984352593679, -0.7864685314415719, -0.6207822487609463, 20.0, -0.6015829471856056, 20.0, -0.958084621680583, 20.0, -0.21766891770662522, 20.0, -0.5616538599777784, -0.5616538599777784, 20.0, -0.867243409546438, -0.5439984352593679, 20.0, -0.48381531848154047, 20.0, -0.9600900246453297, -0.6481282913652262, -0.4940551331266394, -0.8929708555328307, 20.0, -0.6974069191376576, -0.9476414447186581, -0.4387621276975887, 20.0, -0.8431376173205444, 20.0, -0.6015829471856056, 
    -0.9600900246453297, 20.0, -0.9160515550545547, -0.11187965399280864, -0.7864685314415719, -0.48381531848154047, 20.0, -0.47566304294326156, -0.6481282913652262, -0.6974069191376576, -0.47566304294326156, 20.0, -0.4940551331266394, 20.0, -0.5220628570371777, -0.6929780200563616, -0.40373736633011315, -0.9476414447186581, 20.0, -0.013202153574752407, -0.6207822487609463, -0.5220628570371777, 20.0, -0.29904858543128643, -0.4252150843692021, -0.6929780200563616, 20.0, -0.958084621680583, -0.013202153574752407, 20.0, -0.14134601702703786, -0.25537381390842373, -0.14134601702703786, 20.0, -0.43870135287699785, -0.43870135287699785, 20.0, -0.21766891770662522, -0.9160515550545547, 
    20.0], 31, 31)  
    
    p = Sparspak.SpkProblem.Problem(n, n, nnz(spm))
    Sparspak.SpkProblem.insparse!(p, spm);
    Sparspak.SpkProblem.infullrhs!(p, 1:n)
    return p
end

function _test(T=Float64)
    p = makerandomproblem(31)
    
    s = SparseSolver(p)
    solve!(s)
    
    A = Matrix(outsparse(p))
    
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module

module msprs011
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.SpkProblem: insparse!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver
using MultiFloats

function _test(T=Float64)
    n = 31
    spm = sprand(T, n, n, 1/n)
    spm = -spm - spm' + 20 * LinearAlgebra.I
    
    p = Sparspak.SpkProblem.Problem(n, n, nnz(spm), zero(T))
    Sparspak.SpkProblem.insparse!(p, spm);
    A = outsparse(p)
    @test A - spm == sparse(Int64[], Int64[], T[], 31, 31) 
    

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module


module msprs012
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.SpkProblem: insparse!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, solve!
using MultiFloats

function makerandomproblem(n,T=Float64)
    spm = sprand(T, n, n, 1/n)
    spm = -spm - spm' + n * LinearAlgebra.I
    
    p = Sparspak.SpkProblem.Problem(n, n,nnz(spm), zero(T))
    Sparspak.SpkProblem.insparse!(p, spm);
    Sparspak.SpkProblem.infullrhs!(p, 1:n);
    return p
end

function _test(T=Float64)

    p = makerandomproblem(301,T)

    s = SparseSolver(p)
    solve!(s)
    A = Matrix(outsparse(p))
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module


# module msprs013
# using Test
# using LinearAlgebra
# using SparseArrays
# using DataDrop
# using Sparspak
# using Sparspak.Problem: Problem, insparse, outsparse
# using Sparspak.SparseSolver: SparseSolver, findorder, symbolicfactor, inmatrix, factor, solve
# # using ProfileView
# # using InteractiveUtils

# function _test()
#     K = DataDrop.retrieve_matrix("K63070.h5")
#     # K = DataDrop.retrieve_matrix("K28782.h5")
#     @show size(K)
#     I, J, V = findnz(K)     

#     p = Problem(size(K)...)
#     insparse(p, I, J, V);
#     s = Sparspak.SpkSparseSolver.SparseSolver(p);
#     @time findorder(s)
#     symbolicfactor(s)
#     inmatrix(s, p)
#     @time factor(s)
#     # @time factor(s)
#     # @profview factor(s)
#     @time solve(s, p);

#     @info "$(@__FILE__): Now lu"
#     @time lu(K)

#     @info "$(@__FILE__): Now cholesky"
#     @time cholesky(K)

#     return true
# end

# _test()
# end # module


# module msprs014
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak
# using Sparspak.SpkProblem: insparse, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, findorder, symbolicfactor, inmatrix, factor, solve
# using Printf

# function makerandomproblem(n)
#     p = Sparspak.SpkProblem.Problem(n, n)
#     spm = sprand(n, n, 1/n)
#     spm = -spm - spm' + 20 * LinearAlgebra.I
    
#     Sparspak.SpkProblem.insparse(p, spm);
#     Sparspak.SpkProblem.infullrhs(p, 1:n);

#     matrix = "matrix$(n).txt"
#     I, J, V = findnz(spm)     
#     @show 

#     f = open(matrix, "w")
#     @printf(f, "%d %d\n", size(spm, 1), size(spm, 2))
#     @printf(f, "%d\n", length(I))
#     for i in eachindex(I)
#         @printf(f, "%d\n", I[i])
#     end
#     for i in eachindex(J)
#         @printf(f, "%d\n", J[i])
#     end
#     for i in eachindex(V)
#         @printf(f, "%f\n", V[i])
#     end
#     close(f)

#     return p
# end

# function _test()
#     p = makerandomproblem(11)
    
#     s = SparseSolver(p)
#     solve(s, p)
#     A = outsparse(p)
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# end # module


module msprs015
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.Problem: Problem, insparse!, outsparse, infullrhs!
using Sparspak.SparseSolver: SparseSolver, solve!

using MultiFloats
function _test(T=Float64)
    n = 357
    A = sprand(T, n, n, 1/n)
    A = -A - A' + 20 * LinearAlgebra.I
    
    p = Problem(n, n, nnz(A), zero(T))
    insparse!(p, A);
    infullrhs!(p, 1:n);
    
    s = SparseSolver(p)
    solve!(s)
    A = Float64.(outsparse(p))
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module

module msprs016
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.Problem: Problem, insparse!, outsparse, infullrhs!
using Sparspak.SparseSolver: SparseSolver, solve!

using MultiFloats
function _test(T=Float64)
    n = 1357
    A = sprand(T, n, n, 1/n)
    A = -A - A' + 20 * LinearAlgebra.I
    
    p = Problem(n, n, nnz(A), zero(T))
    insparse!(p, A);
    infullrhs!(p, 1:n);
    
    s = SparseSolver(p)
    solve!(s)
    A = Float64.(outsparse(p))
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
_test(Float64x1)
_test(Float64x2)
end # module

module msprs017
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.SpkProblem: outsparse, makegridproblem, infullrhs!
using Sparspak.SpkSparseSolver: SparseSolver, solve!
using Printf

function _test()
    p = makegridproblem(5, 3)
    infullrhs!(p, 1:p.nrows);
    
    s = SparseSolver(p)
    A = outsparse(p)
    solve!(s)
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
end # module

module msprs018
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.SpkProblem: outsparse, makegridproblem, makerhs!
using Sparspak.SpkSparseSolver: SparseSolver, solve!
using Printf

function _test()
    p = makegridproblem(5, 3)
    makerhs!(p, Float64[]);
    
    s = SparseSolver(p)
    A = outsparse(p)
    solve!(s)
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
end # module

module msprs019
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!,  triangularsolve!

function maketridiagproblem(n)
    p = SpkProblem.Problem(n, n)
    for i in 1:(n-1)
        inaij!(p, i + 1, i, -1.0)
        inaij!(p, i, i, 4.0)
        inaij!(p, i, i + 1, -1.0)
        inbi!(p, i, 2.0 * i)
    end
    inaij!(p, n, n, 4.0)
    inbi!(p, n, 3.0 * n + 1.0)

    return p
end

function _test()
    p = maketridiagproblem(11)
    
    s = SparseSolver(p)
    # The actions are purposefully mixed up
    @test_throws ErrorException symbolicfactor!(s) == false # ordering not done
    
    
    findorder!(s) 
    @test_throws ErrorException inmatrix!(s) == false

    findorder!(s) 
    symbolicfactor!(s)
    @test_throws ErrorException factor!(s) == false

    findorder!(s) 
    symbolicfactor!(s)
    inmatrix!(s)
    @test_throws ErrorException triangularsolve!(s) == false
    
    solve!(s)

    A = outsparse(p)
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
end # module

module SparseCSCInterface
import SparseArrays, LinearAlgebra
import ..SpkGraph: Graph
using ..SpkOrdering: Ordering
using ..SpkETree: ETree
import ..SpkSparseBase: _SparseBase
using ..SpkSparseSolver: findorder!,symbolicfactor!,inmatrix!,factor!,triangularsolve!
import ..SpkSparseSolver: SparseSolver, solve!
import ..SpkSparseBase: _inmatrix!


function Graph(m::SparseArrays.SparseMatrixCSC{FT,IT}, diagonal=false) where {FT,IT}
    nv = convert(IT, size(m, 1))
    nrows = convert(IT, size(m, 2))
    ncols = convert(IT, size(m, 1))
    colptr = SparseArrays.getcolptr(m)
    rowval = SparseArrays.getrowval(m)


    if (diagonal)
        nedges = convert(IT, SparseArrays.nnz(m))
    else
        dedges = zero(IT)
        for i in 1:ncols
            for iptr in colptr[i]:colptr[i+one(IT)]-one(IT)
                if  rowval[iptr]==i
                    dedges+=one(IT)
                    continue
                end
            end
        end
        nedges = convert(IT, SparseArrays.nnz(m)) - dedges
    end

    #jf if diagonal == true, we possibly can just use colptr & rowval
    #jf and skip the loop

    xadj = zeros(IT, nv + one(IT))
    adj = zeros(IT, nedges)

    k = one(IT)
    for i in 1:ncols
        xadj[i] = k
        for iptr in colptr[i]:colptr[i+one(IT)]-one(IT)
            j = rowval[iptr]
            if (i != j || diagonal)
                adj[k] = j
                k = k + one(IT)
            end
        end
    end

    xadj[ncols+one(IT)] = k

    return Graph(nv, nedges, nrows, ncols, xadj, adj)
end


function _SparseBase(m::SparseArrays.SparseMatrixCSC{FT,IT}) where {IT,FT}
    maxblocksize = convert(IT, 30)   # This can be set by the user

    tempsizeneed = zero(IT)
    n = convert(IT, size(m, 2))
    nnz = convert(IT, SparseArrays.nnz(m))
    nnzl = zero(IT)
    nsub = zero(IT)

    nsuper = zero(IT)
    if (n > zero(IT))
        nsuper = one(IT)
    end

    factorops = zero(FT)
    solveops = zero(FT)
    realstore = zero(FT)
    integerstore = zero(FT)
    errflag = zero(IT)

    order = Ordering(n)   # ordering object for the solver
    g = Graph(m)
    t = ETree(n)

    colcnt = IT[]
    snode = IT[]
    xsuper = IT[]
    xlindx = IT[]
    lindx = IT[]
    xlnz = IT[]
    xunz = IT[]
    ipiv = IT[]
    lnz = FT[]
    unz = FT[]

    return _SparseBase(order, t, g, errflag, n, nnz, nnzl, nsub, nsuper, maxblocksize,
        tempsizeneed, factorops, solveops, realstore, integerstore,
        colcnt, snode, xsuper, xlindx, lindx, xlnz, xunz, ipiv,
        lnz, unz)
end


function _inmatrix!(s::_SparseBase{IT, FT}, m::SparseArrays.SparseMatrixCSC{FT,IT}) where {IT, FT}
    if (s.n == 0)
        error("An empty problem. No matrix.")
        return false
    end

    s.lnz .= zero(FT)
    s.unz .= zero(FT)
    s.ipiv .= zero(IT)

    function doit(ncols, colptr, rowval, cinvp, rinvp, snode, xsuper, xlindx, lindx, nzval, xlnz, lnz, xunz, unz)
        for i in 1:ncols
            for iptr in colptr[i]:colptr[i+one(IT)]-one(IT)
                inew = rinvp[rowval[iptr]];
                jnew = cinvp[i]
                value = nzval[iptr]
## jf: all of this could go into  a function, so we can keep things synced                
                if (inew >= xsuper[snode[jnew]])
#               Lies in L.  get pointers and lengths needed to search
#               column jnew of L for location l(inew, jnew).
                    jsup = snode[jnew];
                    fstcol = xsuper[jsup]
                    fstsub = xlindx[jsup]
                    lstsub = xlindx[jsup + one(IT)] - one(IT)
                    nnzloc = zero(IT);
                    for nxtsub in fstsub:lstsub
                        irow = lindx[nxtsub]
                        if  (irow > inew)
                            error("No space for matrix element ($(inew), $(jnew)).")
                            return false
                        end
                        if  (irow == inew)
#                       find a proper offset into lnz and increment by value
                            _p = xlnz[jnew] + nnzloc
                            lnz[_p] += value
                            break
                        end
                        nnzloc = nnzloc + one(IT)
                    end
                else
#               Lies in U
                    jsup = snode[inew]
                    fstcol = xsuper[jsup]
                    lstcol = xsuper[jsup + one(IT)] - one(IT)
                    width = lstcol - fstcol + one(IT)
                    lstsub = xlindx[jsup + one(IT)] - one(IT)
                    fstsub = xlindx[jsup] + width
                    nnzloc = zero(IT);
                    for nxtsub in fstsub:lstsub
                        irow = lindx[nxtsub]
                        if  (irow > jnew)
                            error("No space for matrix element ($(inew), $(jnew)).")
                            return false
                        end
                        if  (irow == jnew)
#                       find a proper offset into unz and increment by value
                            _p = xunz[inew] + nnzloc
                            unz[_p] += value
                            break
                        end
                        nnzloc = nnzloc + one(IT)
                    end
                end
            end
        end
        return true
    end
    return doit(size(m,1), m.colptr, m.rowval, s.order.rinvp, s.order.cinvp, s.snode, s.xsuper, s.xlindx, s.lindx, m.nzval, s.xlnz, s.lnz, s.xunz, s.unz)
end

function SparseSolver(m::SparseArrays.SparseMatrixCSC{FT,IT}) where {FT,IT}
    ma = convert(IT, size(m, 2))
    na = convert(IT, size(m, 1))
    mc = zero(IT)
    nc = zero(IT)
    n = ma
    slvr = _SparseBase(m)
    _orderdone = false
    _symbolicdone = false
    _inmatrixdone = true
    _factordone = false
    _trisolvedone = false
    _refinedone = false
    _condestdone = false
    return SparseSolver(m, slvr, n, ma, na, mc, nc, _inmatrixdone, _orderdone, _symbolicdone, _factordone, _trisolvedone, _refinedone, _condestdone)
end


"""
    solve!(s,rhs)

Solves linear system defined with sparse solver and provides the solution in rhs.
"""
function solve!(s::SparseSolver{IT,FT}, rhs) where {IT,FT}
    findorder!(s) || error("Finding Order.")
    symbolicfactor!(s) || error("Symbolic Factorization.")
    inmatrix!(s) || error("Matrix input.")
    factor!(s) || error("Numerical Factorization.")
    triangularsolve!(s,rhs) || error("Triangular Solve.")
    return true
end

#########################################################################
# SparspakLU

"""
    sparspaklu(m::SparseMatrixCSC; factorize=true) -> lu::SparseSolver

If `factorize==true`, calculate LU factorization using Sparspak. Steps
are `findorder`, `symbolicfactor`, `factor`.

If   `factorize==false`,   ordering,    symbolic   factorization   and
factorization are delayed to a subsequent call to `sparspaklu!`.

Returns  a  `SparseSolver` instance in the respective state, 
which has methods for `LinearAlgebra.ldiv!` and "backslash".
"""
function sparspaklu(m::SparseArrays.SparseMatrixCSC{FT,IT};factorize=true) where {FT,IT}
    lu=SparseSolver(m)
    if factorize
        findorder!(lu) || error("Finding Order.")
        symbolicfactor!(lu) || error("Symbolic Factorization.")
        inmatrix!(lu) || error("Matrix input.")
        factor!(lu) || error("Numerical Factorization.")
    end
    lu
end


"""
    sparspaklu!(lu::SparseSolver, m::SparseMatrixCSC; allow_pattern_change=true) -> lu::SparseSolver

Calculate LU factorization of a sparse matrix `m`, reusing ordering and symbolic
factorization `lu`, if that was previously calculated.

If `allow_pattern_change = true` (the default) the sparse matrix `m` may have a nonzero pattern
different to that of the matrix used to create the LU factorization `lu`, in which case the ordering
and symbolic factorization are updated.

If `allow_pattern_change = false` an error is thrown if the nonzero pattern of `m` is different to that 
of the matrix used to create the LU factorization `lu`.

If `lu` has not been factorized (ie it has just been created with option `factorize = false`) then 
`lu` is always updated from `m` and `allow_pattern_change` is ignored.

"""
function sparspaklu!(lu::SparseSolver{IT,FT}, m::SparseArrays.SparseMatrixCSC{FT,IT}; allow_pattern_change=true) where {FT,IT}
   
    pattern_changed = (SparseArrays.getcolptr(m) != SparseArrays.getcolptr(lu.p)) || (SparseArrays.getrowval(m) != SparseArrays.getrowval(lu.p))

    if pattern_changed
        if allow_pattern_change || !lu._symbolicdone
            copy!(lu, SparseSolver(m))
        else
            error("'allow_pattern_change=false', but sparsity pattern of matrix 'm' does not match that used to create 'lu'")
        end
    end
   
    lu.p=m
    lu._orderdone    || ( findorder!(lu)      || error("Finding Order.") )
    lu._symbolicdone || ( symbolicfactor!(lu) || error("Symbolic Factorization.") )
    lu._inmatrixdone = false
    lu._factordone = false
    lu._trisolvedone = false
    inmatrix!(lu) || error("Matrix input.")
    factor!(lu) || error("Numerical Factorization.")
    lu
end

"""
    ldiv!(u, lu::SparseSolver{IT,FT}, v) where {IT,FT}

Left division for SparseSolver.

The solution is returned in `u`. The right hand side vector is `v`.
"""
function LinearAlgebra.ldiv!(u, lu::SparseSolver{IT,FT}, v) where {IT,FT}
    u.=v
    return LinearAlgebra.ldiv!(lu, u)
end

"""
    ldiv!(lu::SparseSolver{IT,FT}, v) where {IT,FT}

Overwriting left division for SparseSolver.

The solution is returned in `v`, which is also the right hand side vector.
"""
function LinearAlgebra.ldiv!(lu::SparseSolver{IT,FT}, v) where {IT,FT}
    solve!(lu, v) || error("Triangular Solve.")
    lu._trisolvedone = false
    v
end

"""
    \\(lu::SparseSolver,v)

"Backslash" operator for sparse solver
"""
Base.:\(lu::SparseSolver{IT,FT}, v) where {IT,FT}=LinearAlgebra.ldiv!(lu,copy(v))

end

using Test

module metre001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkETree

function _test()
    # Matrix from Figure 3.1.3
    M, N = 6, 6
    I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
    J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
    V = [1.0 for _ in I]
    spm = sparse(I, J, V, M, N)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    t = SpkETree.ETree(M)
    @test t.parent == [0, 0, 0, 0, 0, 0] 
    return true
end

_test()
end # module

""" SparseSpdBase class:
This class contains the variables for the data structure for the
SparseSpdSolver.

The Cholesky factor of the matrix is stored column by column.
Only the nonzeros of the matrix are stored, in an efficient way by
exploiting supernode structure. A supernode is simply a set of
consecutive columns, say columns i, i + 1, i + 2, ... i + s - 1, all of which
have essentially identical structure. Column i and columns i + 1
have nonzeros in identical rows, except that element (i, i + 1) is
zero (of course). If one stores the subscripts of the nonzero
elements for column i,  one can easily determine the subscripts of
the nonzeros in the other columns of the supernode.

n - the number of rows and columns in the matrix.

nnzl - the number of nonzeros in the Cholesky factor L.

nsub - the number of row subscripts stored. This is also the
              length of the array lindx, and equal to xlindx(n + 1) - 1.0

nsuper - the number of supernodes in the Cholesky factor

xsuper - the supernode structure. The i - th supernode consists
              of columns xsuper(i), xsuper(i) + 1, ... xsuper(i + 1) - 1.0
              ie.  maps a supernode to it"s first column

errflag - an error flag. If a zero diagonal element is detected
              during the factorization, errflag is set to - 1.0
              If no errors are detected, errflag will be 0.0

(xlindx, lindx) - a pair of arrays containing the row subscripts of
              the first columns of the supernodes. The row subscripts
              of the nonzeros in the i - th supernode (including the
              diagonal element) are given by lindx(xlindx(i)),
              lindx(xlindx(i) + 1), ..., lindx(xlindx(i + 1) - 1)
              Note that lindx is of length nsub. The array
              xlindx is of length nsuper + 1, with xlindx(nsuper + 1)
              equal to nsub + 1.0

(xlnz, lnz) - the nonzero elements of the Cholesky factor. The nonzero
              elements in the k - th column of L are given by
              lnz(xlnz(k)), lnz(xlnz(k) + 1), ..., lnz(xlnz(k + 1) - 1).

colcnt - array of length neqns, containing the number
              of nonzeros in each column of the factor,

The algorithm employed is a so - called "left - looking" scheme; each
supernode is computed by applying modifications from other supernodes
to its left.

snode - This is an array which makes it convenient to quickly
              determine in which supernode a column resides.
              snode(i) = k means column i is in supernode k.


maxBlockSize - in order to improve multiprocessor utilization, it is
              helpful to split the larger supernodes into smaller ones.
              This is done by introducing artificial supernodes.
              The variable maxBlockSize governs this process; no
              supernode will have more than maxBlockSize columns.
              At present, this is fixed at 60 columns, as it seems
              to be optimal for problems upto 700^2

For more details on the algorithm and storage scheme used in this solver
class, please refer to Chapter 5 of the book "Computer Solution of Large
Sparse Positive Definite Systems" by Alan George and Joseph Liu published
by Prentice - Hall, 1981.0


"""
module SpkSparseSpdBase

using ..SpkOrdering: Ordering
using ..SpkGraph: Graph, makestructuresymmetric
using ..SpkETree: ETree, _getetree!, _getpostorder!
using ..SpkMmd: mmd!
using ..SpkProblem: Problem
using ..SpkSymfct: _findcolumncounts!, _symbolicfact!, _findsupernodes!
using ..SpkUtilities: __extend
using ..SpkLDLtFactor: _ldltfactor!, _ldltsolve!

mutable struct _SparseSpdBase{IT, FT}
    order::Ordering
    t::ETree
    g::Graph
    errflag::IT
    n::IT
    nnz::IT
    nnzl::IT
    nsub::IT
    nsuper::IT
    maxblocksize::IT
    factorops::FT
    solveops::FT
    realstore::FT
    integerstore::FT
    colcnt::Vector{IT}
    snode::Vector{IT}
    xsuper::Vector{IT}
    xlindx::Vector{IT}
    lindx::Vector{IT}
    xlnz::Vector{IT}
    lnz::Vector{FT}
end

"""
"""
function _SparseSpdBase(p::Problem{IT,FT}) where {IT,FT}
    maxblocksize = 60;   # This can be set by the user

    n = p.nrows; nnz = p.nnz; nnzl = zero(IT)
    nsub = zero(IT);

    if (n > 0)
        nsuper = zero(IT) + 1
    else
        nsuper = zero(IT)
    end

    factorops = zero(FT); solveops = zero(FT); realstore = zero(FT); integerstore = zero(FT)
    errflag = zero(IT)

    order = Ordering(n)   # ordering object for the solver
    g = Graph(p)
    t = ETree(n)

    colcnt = IT[]
    snode = IT[]
    xsuper = IT[]
    xlindx = IT[]
    lindx = IT[]
    xlnz = IT[]
    ipiv = IT[]
    lnz = FT[]

    return _SparseSpdBase(order, t, g, errflag, n, nnz, nnzl, nsub, nsuper, maxblocksize, factorops, solveops, realstore, integerstore, colcnt, snode, xsuper, xlindx, lindx, xlnz, lnz)
end

function _findorder!(s::_SparseSpdBase{IT}, orderfunction::F) where {IT, F}
    if (s.n == 0)
        error("An empty problem, no ordering found.")
        return false
    end
    makestructuresymmetric(s.g)     # Make it symmetric
    orderfunction(s.g, s.order)   # Default ordering function
    return true
end

function _findorder!(s::_SparseSpdBase{IT}) where {IT}
    return _findorder!(s, mmd!)
end

# function SparseSpdBasefindorderperm(s, perm)
#         type (SparseSpdBase)  ::  s
#         integer :: perm(*)
#         character (len = *), parameter :: fname = "SparseSpdBasefindorderperm:"
#         integer :: i

#         trace (fname, "object name is", s.objectname)

#         if (s.n == 0)
#             warning(fname, "this solver object is derived from")
#             warning("an empty problem. no ordering to be found.")
#             return
#         end

#         makestructuresymmetric(s.g)     # Make it symmetric

#         s.order.rperm(1:s.n) = perm(1:s.n)
#         s.order.cperm(1:s.n) = perm(1:s.n)
#         s.order.rinvp(s.order.rperm(1:s.n)) = (/ (i, i = 1, s.n) /)
#         s.order.cinvp(s.order.cperm(1:s.n)) = (/ (i, i = 1, s.n) /)

#     end

function _symbolicfactor!(s::_SparseSpdBase{IT, FT}) where {IT, FT}

    if (s.n == 0)
        error("An empty problem. No symbolic factorization done.")
        return false
    end

    s.colcnt = zeros(IT, s.n)
    s.snode = zeros(IT, s.n)
    s.xsuper = zeros(IT, s.n + 1)

# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#       Compute elimination tree
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    _getetree!(s.g, s.order, s.t)
    _getpostorder!(s.t, s.order)

# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#       Compute row and column factor nonzero counts.
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    _findcolumncounts!(s.g.nv, s.g.xadj, s.g.adj, s.order.rperm, s.order.rinvp, s.t.parent, s.colcnt, s.nnzl)
    _getpostorder!(s.t, s.order, s.colcnt)

#-
#       Find supernodes. Split them so none are larger than maxBlockSize
#-
    s.nsub, s.nsuper = _findsupernodes!(s.g.nv, s.t.parent, s.colcnt, s.nsub, s.nsuper, s.xsuper, s.snode, s.maxblocksize)
    s.xsuper = __extend(s.xsuper, s.nsuper + 1)

    s.lindx = zeros(IT, s.nsub)
    s.xlindx = zeros(IT, s.nsuper + 1)

#-
#       NEXT LINE CHANGED SINCE LNZ NOW CONTAINS RECTANGULAR SUPERNODES,
#       NOT TRAPEZOIDAL, ie. some 0 elements are going to be stored
#-
    s.xlnz = zeros(IT, s.n + 1)

# -  -  -  -  -  -  -
#       Set up the data structure for the Cholesky factor.
# -
    _findnonzeroindexs!(s.n, s.colcnt, s.nsuper, s.xsuper, s.xlnz)

    _symbolicfact!(s.g.nv, s.g.xadj, s.g.adj, s.order.rperm, s.order.rinvp, s.colcnt, s.nsuper, s.xsuper, s.snode, s.nsub, s.xlindx, s.lindx)

# -  -  -  -  -  - -
#       We now know how many elements we need, so allocate for it.
#-
    s.lnz = zeros(FT, s.xlnz[s.n + 1])


    s.lnz[1:s.xlnz[s.n + 1]] .= zero(FT)

    return true
end

function _inmatrix!(s::_SparseSpdBase{IT, FT}, p::Problem{IT, FT}) where {IT, FT}
# """
#     This subroutine retrieves a matrix from a problem object p and
#     inserts its elements into the data structure for the Cholesky
#     factor L. The data structure involves the arrays xlindx, lindx,
#     xlnz, and lnz as described in the comments at the beginning of
#     this module. The components of the problem object are
#     decribed in the comments at the beginning of the SpkProblem
#     module. Note that the Cholesky factor L corresponds to the
#     matrix problem after it has had its rows and columns permuted.
#     Thus, a reordering is applied to its elements before they are
#     inserted into the data structure.
##
# Input parameters: problem and solver objects
#
# The "output" is the modified solver object.
##
# Working Parameters:
#     supcol - Will stores which column of its supernode a particular
#                  column will reside in.
#
#
# """
        # type (SparseSpdBase)  ::  s
        # type (problem)  ::  p
        # type (ordering) ::  order
        # character (len = *), parameter :: fname = "SparseSpdBaseinmatrix:"
        # integer :: rnum, cnum, i, k, ptr, nnzloc, nxtsub, irow
        # integer :: inew, jnew, itemp, jsup, fstcol, fstsub, lstsub
        # integer :: supcol, lnzoff
        # real (double) :: value

    if (s.n == 0)
        error("An empty problem. No matrix.")
        return false
    end

    s.lnz[1:s.xlnz[s.n + 1] - 1] .= zero(FT)


    for i  in 1:p.ncols           #   Only the lower triangle of p is used.
        ptr = p.head[i]
        while (ptr > 0)  # scan column i ....
            if (p.rowsubs[ptr] >= i)
                inew = s.order.rinvp[p.rowsubs[ptr]];
                value = p.values[ptr]; jnew = s.order.cinvp[i]
                if  (inew < jnew)
                    itemp = inew; inew = jnew; jnew = itemp
                end
#             get pointers and lengths needed to search column jnew
#                   of L for location l(inew, jnew).
                jsup = s.snode[jnew]; fstcol = s.xsuper[jsup]
                fstsub = s.xlindx[jsup] + jnew - fstcol
                lstsub = s.xlindx[jsup + 1] - 1
#           search for row subscript inew in jnew's subscript list.
                for nxtsub  in  fstsub: lstsub
                    irow = s.lindx[nxtsub]
                    if  (irow > inew)
                        error("No space for matrix element ($(inew), $(jnew)).")
                        return false
                    end

                    if  (irow == inew)
#                   find a proper offset into lnz.  lnz new stores
#                     rectangular columns, not trapezoidal columns
                        supcol = jnew - s.xsuper[s.snode[jnew]]
                        nnzloc = s.xlnz[jnew] + (nxtsub - fstsub) + supcol

                        s.lnz[nnzloc] = s.lnz[nnzloc] + value
                        break
                    end
                end
            end
            ptr = p.link[ptr]
        end
    end
    return true
end

function _factor!(s::_SparseSpdBase{IT, FT}) where {IT, FT}
    # """
    # This routine calls the lower - level routine LDLtFactor which
    # computes and L D L^T factorization of the matrix stored in the
    # solver object s. The components of the solver object are described
    #  in the comments at the beginning of this module.
    # """
    if (s.n == 0)
        error("An empty problem. No matrix.")
        return false
    end

    s.errflag = _ldltfactor!(s.n, s.nsuper, s.xsuper, s.snode, s.xlindx, s.lindx, s.xlnz, s.lnz)

    if (s.errflag != 0)
        error("An empty problem. No matrix.")
        return false
    end
    return true
end

function _triangularsolve!(s::_SparseSpdBase{IT, FT}, solution::AbstractVector{FT}) where {IT, FT}

# This routine calls the lower - level routine LDLtSolve which
# solves L D L^T x = rhs, given L, D and rhs. The solution is placed in
# the array rhs. Note that the factorization is of a permuted form of
# the problem, and it is assumed that the user provides the rhs in
# the original order. Thus, the permutation "hidden" in the solver
#  object is applied as appropriate.

    if (s.n == 0)
        error("An empty problem. No solution.")
        return false
    end

    rhs = deepcopy(solution)
    rhs .= solution[s.order.rperm]

    _ldltsolve!(s.nsuper, s.xsuper, s.xlindx, s.lindx, s.xlnz, s.lnz, rhs)

    solution .= rhs[s.order.rinvp]

    return true
end


    function _findnonzeroindexs!(n, colcnt, nsuper, xsuper, xlnz)
# """
#    This routine inserts the index offsets for the arrays xlnz and xunz.
# """

        point = 1
        for ksup  in  1: nsuper
            fstcol = xsuper[ksup];   lstcol = xsuper[ksup + 1] - 1
            for jcol  in  fstcol: lstcol
                xlnz[jcol] = point
                point = point + colcnt[fstcol]
            end
        end

        xlnz[n + 1] = point
        nothing
    end
#
end # module spkSparseSpdBase

module structurally_unsymmetric
using Test
using Sparspak
using Random, SparseArrays, LinearAlgebra
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkSparseSolver


#
# Used to fail in issymmetric, SpkGraph.jl:336
#
function simpletest1(;n=4)
    A = sparse(Diagonal(ones(n)))
    A[2,1]=-0.1
    pr = SpkProblem.Problem(n,n)
    SpkProblem.insparse!(pr, A)
    s = SpkSparseSolver.SparseSolver(pr)
    @test SpkSparseSolver.findorder!(s)
end

#
# Used to fail in SpkLUFactor.jl:245
#
function simpletest2()
    A=[1.21883    0.0  0.0      0.942235;
       0.0243952  1.0  0.0      0.0;
       0.0        0.0  1.53656  0.0;
       0.340938   0.0  0.0      1.0]

    A=sparse(A)
    pr = SpkProblem.Problem(4,4)
    SpkProblem.insparse!(pr, A)
    s = SpkSparseSolver.SparseSolver(pr)
    SpkSparseSolver.findorder!(s)
    SpkSparseSolver.symbolicfactor!(s)
    SpkSparseSolver.inmatrix!(s)
    @test SpkSparseSolver.factor!(s)
end

#
# Used to fail in  SpkSparseBase.jl:390
#
function simpletest3()
    A=[   1.0       0.0       0.0      0.0;
          0.0       1.45565   0.0      0.0;
          0.0       0.0       1.11667  0.0;
          0.511585  0.159678  0.0      1.0]
    A=sparse(A)
    pr = SpkProblem.Problem(4,4)
    SpkProblem.insparse!(pr, A)
    s = SpkSparseSolver.SparseSolver(pr)
    SpkSparseSolver.findorder!(s)
    SpkSparseSolver.symbolicfactor!(s)
    SpkSparseSolver.inmatrix!(s)
    @test SpkSparseSolver.factor!(s)
end


function ttsparspak(;n=4,p=0.3)
    for i=1:1000
        A = sprand(n, n, p) + I
        b = rand(n)
        
        pr = SpkProblem.Problem(n,n)
        SpkProblem.insparse!(pr, A)
        Sparspak.SpkProblem.infullrhs!(pr, b)
        s = SpkSparseSolver.SparseSolver(pr)
        SpkSparseSolver.findorder!(s)
        SpkSparseSolver.symbolicfactor!(s)
        SpkSparseSolver.inmatrix!(s)
        SpkSparseSolver.factor!(s)
        SpkSparseSolver.solve!(s)
        @assert norm(pr.x - A\b)<1.0e-9
    end
    @test true
end


function ttsparspaklu(;n=4,p=0.3)
    for i=1:1000
        # println(i)
        A = sprand(n, n, p) + I
        b = rand(n)
        # display(Matrix(A))
        x=sparspaklu(A)\b
        @assert norm(x - A\b)<1.0e-9
    end
    @test true
end



simpletest1()
simpletest2()
simpletest3()
ttsparspak()
ttsparspaklu()

end

module SpkLUFactor

using ..SpkSpdMMops: _mmpyi!, _assmb!, _luswap!, _ldindx!, _igathr!, _gemm!, _trsm!, _getrf!, _laswp!, _gemv!


#      this subroutine computes an LU factorization of a sparse
#      matrix with symmetric structure.  the computation is
#      organized around kernels that perform supernode - to - supernode
#      updates.  level - 3 blas routines used whenever possible.
#      each supernode is a dense trapezoidal submatrix stored in
#      a rectangular array.
# #
#  input parameters:
#      nsuper - number of supernode.
#      xsuper - supernode partition.
#      snode - maps each column to the supernode containing it.
#      (xlindx, lindx) - row indices for each supernode (including
#                          the diagonal elements).
#      (xlnz, lnz) - on input, contains the lower half of the matrix
#                          to be factored and the diagonal block.
#      (xunz, unz) - on input, contains the upper half of the matrix
#                          to be factored.
# #
#  output parameters:
#      lnz - on output, contains the lower half of the
#                          cholesky factor.
#      unz - on output, contains the upper half of the
#                          cholesky factor.
#      iflag - error flag.
#                              0: successful factorization.
# - 1: nonpositive diagonal encountered,
#                                 matrix is not positive definite.
# - 2: insufficient working storage
#                                 [temp(*)].
#      ipvt - row pivoting information.
# #
#  local variables:
#      link - a linked list that stores the supernode
#                          that are ready to modify jsup.
#                          if link(jsup) = k,  supernodes k,
#                          link(k), link(link(k)), ... all modify
#                          supernode jsup.
#      length - length of the active portion of each supernode.
#                          ie. the length that hasn"t effected a diagonal
#                          block yet.
#      map - vector of size n into which the global
#                          indices are scattered.  This array holds the
#                          distance of row k from the bottom of the
#                          supernode if it were compressed.
#      relind - maps locations in the updating columns to
#                          the corresponding locations in the updated
#                          columns.  (relind is gathered from map).
#                          more specifically, this is an array of length
#                          lenght(ksup), and only stores the elements
#                          from map coresponding to union of row indexes
#                          of jsup and ksup.
#      temp - real vector for accumulating updates.  must
#                           accomodate all columns of a supernode.

function _lufactor!(n::IT, nsuper::IT, xsuper::Vector{IT}, snode::Vector{IT}, xlindx::Vector{IT}, lindx::Vector{IT}, xlnz::Vector{IT}, lnz::Vector{FT}, xunz::Vector{IT}, unz::Vector{FT}, ipvt::Vector{IT}) where {IT, FT}
    @assert length(xsuper) == (nsuper + 1)
    @assert length(snode) == n
    @assert length(xlindx) == (nsuper + 1)
    @assert length(xlnz) == (n + 1)
    @assert length(xunz) == (n + 1)
    @assert length(ipvt) == n

    ONE = one(FT)
    
    link = zeros(IT, nsuper)
    lngth = zeros(IT, nsuper)
#
    iflag = zero(IT);   tmpsiz = zero(IT)
#   Initialization
    for i in 1:nsuper
        link[i] = 0
        lngth[i] = xlindx[i + 1] - xlindx[i]
        width = xsuper[i + 1] - xsuper[i]
        need = width * (xlnz[xsuper[i] + 1] - xlnz[xsuper[i]])
        if (need > tmpsiz) tmpsiz = need; end
    end

    map = zeros(IT, n)
    relind = zeros(IT, n)
    temp = zeros(FT, tmpsiz)
    vtemp = view(temp, 1:length(temp))

#   For each supernode jsup ...
    for jj in 1:nsuper
        jsup = jj
        # fj     ...  first row / column of jsup.
        # lj     ...  last row / column of jsup.
        # nj     ...  number of rows / columns in jsup.
        # jlen   ...  lngth of jsup.
        # jxpnt  ...  pointer to index of first nonzero in
        #             jsup.
        # jlpnt  ...  pointer to location of first nonzero
        #             in column fj.
        # jupnt  ...  pointer to location of first nonzero
        #             in row fj.
        fj    = xsuper[jsup]
        lj    = xsuper[jsup + 1] - 1
        nj    = lj - fj + 1
        jlen  = xlnz[fj + 1] - xlnz[fj]
        jxpnt = xlindx[jsup]
        jlpnt = xlnz[fj]
        jupnt = xunz[fj]
#       Set up map(*) to map the entries in update columns to their
#       corresponding positions in updated columns, relative to the bottom of
#       each updated column.
        _ldindx!(jlen, view(lindx, jxpnt:length(lindx)), map)
#       For every supernode ksup in row(jsup) ...
        while (true)
#           Wait for something to appear in the list, or stop if there can"t be
#           anything more

#           Take out the first item in the list.  MUST BE DONE atomically
            ksup = link[jsup]
            if (ksup != 0)
#               Remove the head of the list.
                link[jsup] = link[ksup]
                link[ksup] = 0
            end
            if (ksup == 0) break; end
#             get info about the cmod(jsup, ksup) update.
#
#             fk     ...  first row / column of ksup.
#             nk     ...  number of rows / columns in ksup.
#             ksuplen  ...  lngth of ksup.
#             klen   ...  lngth of active portion of ksup.
#             kxpnt  ...  pointer to index of first nonzero in
#                         active portion of ksup.
#             klpnt  ...  pointer to location of first nonzero in
#                         active portion of column fk.
#             kupnt  ...  pointer to location of first nonzero in
#                         active portion of row fk.
            fk  = xsuper[ksup]
            lk  = xsuper[ksup + 1] - 1
            nk = lk - fk + 1
            ksuplen  = xlnz[fk + 1] - xlnz[fk]
            klen   = lngth[ksup]
            kxpnt  = xlindx[ksup + 1] - klen
            klpnt = xlnz[fk + 1] - klen
            kupnt = xunz[fk + 1] - klen
#           Perform cmod(jsup, ksup), with special cases handled differently.
#
#           Each cmod is broken up into two stages: first perform cmod on the
#           columns, perform cmod on the rows.
#           nups  ...  number of rows / columns updated.
            if  (klen == jlen)
#               Dense cmod(jsup, ksup). jsup and ksup have identical structure.
                _gemm!('n', 't', jlen, nj, nk, -ONE, view(lnz, klpnt:length(lnz)), ksuplen, view(unz, kupnt:length(unz)), ksuplen - nk, ONE, view(lnz, jlpnt:length(lnz)), jlen)
                if  (jlen > nj)
                    _gemm!('n', 't', jlen - nj, nj, nk, -ONE, view(unz, (kupnt + nj):length(unz)), ksuplen - nk, view(lnz, klpnt:length(lnz)), ksuplen, ONE, view(unz, jupnt:length(unz)), jlen - nj)
                end
                nups = nj
                if  (klen > nj)
                    nxt = lindx[jxpnt + nj]
                end
            else
#               Sparse cmod(jsup, ksup). Determine the number of rows / columns
#               to be updated.
                nups = klen
                for i in 0:1:(klen - 1)
                    nxt = lindx[kxpnt + i]
                    if  (nxt > lj)
                        nups = i
                        break
                    end
                end  
                if (nk == 1)
#                   Updating target supernode by a trivial supernode (with one
#                   column).
                    _mmpyi!(klen, nups, view(lindx, kxpnt:length(lindx)), view(lindx, kxpnt:length(lindx)), view(lnz, klpnt:length(lnz)), view(unz, kupnt:length(unz)), xlnz, lnz, map)

                    _mmpyi!(klen - nups, nups, view(lindx, (kxpnt + nups):length(lindx)), view(lindx, kxpnt:length(lindx)), view(unz, (kupnt + nups):length(unz)), view(lnz, klpnt:length(lnz)), xunz, unz, map)
                 else
#                   kfirst ...  first index of active portion of
#                                supernode ksup (first column to be
#                                updated).
#                   klast  ...  last index of active portion of
#                                supernode ksup.
                    kfirst = lindx[kxpnt]
                    klast  = lindx[kxpnt + klen - 1]
                    inddif = map[kfirst] - map[klast]
                    if (inddif < klen)
#                       Dense cmod(jsup, ksup). ilpnt  ...  pointer to first
#                       nonzero in column kfirst.
                        ilpnt = xlnz[kfirst] + (kfirst - fj)
                        _gemm!('n', 't', klen, nups, nk, -ONE, view(lnz, klpnt:length(lnz)), ksuplen, view(unz, kupnt:length(unz)), ksuplen - nk, ONE, view(lnz, ilpnt:length(lnz)), jlen)
                        iupnt = xunz[kfirst]
                        if  (klen > nups)
                            _gemm!('n', 't', klen - nups, nups, nk, -ONE, view(unz, (kupnt + nups):length(unz)), ksuplen - nk, view(lnz, klpnt:length(lnz)), ksuplen, ONE, view(unz, iupnt:length(unz)), jlen - nj)
                        end
                    else
#                       General sparse cmod(jsup, ksup). compute cmod
#                       (jsup, ksup) update in work storage.
                        store = klen * nups
                        if  (store > tmpsiz)
                            iflag = - 2
                        end
#                       Gather indices of ksup relative to jsup.
                        _igathr!(klen, view(lindx, kxpnt:length(lindx)), map, relind)
                        _gemm!('n', 't', klen, nups, nk, -ONE, view(lnz, klpnt:length(lnz)), ksuplen, view(unz, kupnt:length(unz)), ksuplen - nk, zero(FT), vtemp, klen)
#                       Incorporate the cmod(jsup, ksup) block update into the
#                       appropriate columns of L.
                        _assmb!(klen, nups, temp, view(relind, 1:length(relind)), view(relind, 1:length(relind)), view(xlnz, fj:length(xlnz)), lnz, jlen)
                        if  (klen > nups)
                            _gemm!('n', 't', klen - nups, nups, nk, -ONE, view(unz, (kupnt + nups):length(unz)), ksuplen - nk, view(lnz, klpnt:length(lnz)), ksuplen, zero(FT), vtemp, klen - nups)
#                           incorporate the cmod(jsup, ksup) block update into
#                           the appropriate rows of u.
                            _assmb!(klen - nups, nups, temp, view(relind, 1:length(relind)), view(relind, (nups + 1):length(relind)), view(xunz, fj:length(xunz)), unz, jlen)
                        end
                    end
                end
            end
#           Link ksup into linked list of the next supernode it will update and
#           decrement ksup"s active lngth. 
            if  (klen > nups)
                nxtsup = snode[nxt]
                link[ksup] = link[nxtsup]
                link[nxtsup] = ksup
                lngth[ksup] = klen - nups
            else
                lngth[ksup] = 0
            end
#           Next updating supernode (ksup).
        end
#       Apply partial lu to the diagonal block.
        iflag = _getrf!(nj, nj, view(lnz, jlpnt:length(lnz)), jlen, view(ipvt, fj:length(ipvt)))
        if  (iflag != 0)
            iflag = - 1
        end
#       Update columns.
        _trsm!('r', 'u', 'n', 'n', jlen - nj, nj, ONE, view(lnz, jlpnt:length(lnz)), jlen, view(lnz, (jlpnt + nj):length(lnz)), jlen)
#       Apply permutation to rows.
        if  (jlen > nj)
            _luswap!(jlen - nj, nj, view(unz, jupnt:length(unz)), jlen - nj, view(ipvt, fj:length(ipvt)))
#           Update rows.
            _trsm!('r', 'l', 't', 'u', jlen - nj, nj, ONE, view(lnz, jlpnt:length(lnz)), jlen, view(unz, jupnt:length(unz)), jlen - nj)
        end
#       Insert jsup into linked list of first supernode it will update.
        if  (jlen > nj)
            nxt = lindx[jxpnt + nj]
            nxtsup = snode[nxt]
            link[jsup] = link[nxtsup]
            link[nxtsup] = jsup
            lngth[jsup] = jlen - nj
        else
            lngth[jsup] = 0
        end
    end

    return iflag
end


 #     Given the L U factorization of a sparse structurally symmetric
 #     positive definite matrix, this subroutine performs the
 #     triangular solution.  It uses output from LUFactor.
 # Input parameters:
 #     nsuper - number of supernodes.
 #     xsuper - supernode partition.
 #     (xlindx, lindx) - row indices for each supernode.
 #     (xlnz, lnz) - Cholesky factor.
 # Updated parameters:
 #     rhs - on input, contains the right hand side.  on
 #                          output, contains the solution.
function _lulsolve!(nsuper::IT, xsuper::Vector{IT}, xlindx::Vector{IT}, lindx::Vector{IT}, xlnz::Vector{IT}, lnz::Vector{FT}, ipiv::Vector{IT}, rhs::Vector{FT}) where {IT, FT}
     # integer :: nsuper
     # integer :: lindx(*), ipiv(*), xsuper(*), xlindx(*), xlnz(*)
     # real(double) :: lnz(*), rhs(*)

     # integer :: fj, isub, j, jj, jlen, jlpnt, jsup, jxpnt, nj
     # integer :: length, maxlength
     # real(double), dimension(:), allocatable :: temp

# -  -  -  -  -  -  -  -  -  -
#    constants.
# -  -  -  -  -  -  -  -  -  -
    ONE = one(FT)
    ZERO = zero(FT)

    if  (nsuper <= 0)  return false; end

    lngth = 0; maxlngth = 0
    for j in 1:nsuper
        lngth = xlindx[j + 1] - xlindx[j]
        maxlngth = max(lngth, maxlngth)
    end

    temp = zeros(FT,maxlngth)

# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#    forward substitution ...
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    for jsup in 1:nsuper

        fj    = xsuper[jsup]
        nj    = xsuper[jsup + 1] - fj
        jlen  = xlnz[fj + 1] - xlnz[fj]
        jxpnt = xlindx[jsup]
        jlpnt = xlnz[fj]

# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#       pivot rows of RHS to match pivoting of L and U.
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
        _laswp!(view(rhs, fj:length(rhs)), nj, 1, nj, view(ipiv, fj:length(ipiv)))

        _trsm!('l', 'l', 'n', 'u', nj, 1, ONE, view(lnz, jlpnt:length(lnz)), jlen, view(rhs, fj:length(rhs)), nj)

        _gemv!('n', jlen - nj, nj, -ONE, view(lnz, (jlpnt + nj):length(lnz)), jlen, view(rhs, fj:length(rhs)), ZERO, view(temp, 1:length(temp)))

        jj = jxpnt + nj - 1
        for  j in 1:(jlen - nj)
            jj = jj + 1
            isub = lindx[jj]
            rhs[isub] += temp[j]
            temp[j] = ZERO
        end
    end
    return true
end

function _luusolve!(n::IT, nsuper::IT, xsuper::Vector{IT}, xlindx::Vector{IT}, lindx::Vector{IT}, xlnz::Vector{IT}, lnz::Vector{FT}, xunz::Vector{IT}, unz::Vector{FT}, rhs::Vector{FT}) where {IT, FT}
# integer :: nsuper, n
# integer :: lindx(*), xsuper(*), xlindx(*), xlnz(*), xunz(*)
# real(double) :: lnz(*), rhs(*), unz(*)

# integer :: fj, isub, j, jj, jlen, jlpnt, jsup, jupnt, jxpnt, nj
# integer :: length, maxlength
# real(double), dimension(:), allocatable :: temp

    ONE = one(FT)
    ZERO = zero(FT)

    if  (nsuper <= 0)  return; end

    lngth = 0; maxlngth = 0
    for j in 1:nsuper
        lngth = xlindx[j + 1] - xlindx[j]
        maxlngth = max(lngth, maxlngth)
    end

    temp = zeros(FT, maxlngth)

# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#    backward substitution ...
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    for jsup in nsuper:-1:1

        fj    = xsuper[jsup]
        nj    = xsuper[jsup + 1] - fj
        jlen  = xlnz[fj + 1] - xlnz[fj]
        jxpnt = xlindx[jsup]
        jlpnt = xlnz[fj]
        jupnt = xunz[fj]

        jj = jxpnt + nj - 1
        for j in 1:(jlen - nj)
            jj = jj + 1
            isub = lindx[jj]
            if (isub > n)
                error("Index $(isub) out of bounds in rhs.")
                return false
            end
            temp[j] = rhs[isub]
        end  
        if (jlen > nj)
            _gemv!('t', jlen - nj, nj, -ONE, view(unz, jupnt:length(unz)), jlen - nj, view(temp, 1:length(temp)), ONE, view(rhs, fj:length(rhs)))
        end

        _trsm!('l', 'u', 'n', 'n', nj, 1, ONE, view(lnz, jlpnt:length(lnz)), jlen, view(rhs, fj:length(rhs)), nj)

    end
    return true
end

end  # module

using Test

module mgrid001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkGrid

function _test()
    M, N = 6, 6
    g = SpkGrid.Grid(M, N)
    @test g.h == M
    @test g.k == N
    @test g.v == [1 2 3 4 5 6; 7 8 9 10 11 12; 13 14 15 16 17 18; 19 20 21 22 23 24; 25 26 27 28 29 30; 31 32 33 34 35 36] 
    return true
end

_test()
end # module

#
# Run generic tests for a larger number of problems
#
module generic001
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.SpkProblem: insparse!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, solve!
using Random
using MultiFloats, ForwardDiff

f64(x::ForwardDiff.Dual{T}) where T=Float64(ForwardDiff.value(x))
f64(x::MultiFloat)=Float64(x)

Random.rand(rng::AbstractRNG, ::Random.SamplerType{ForwardDiff.Dual{T,V,N}}) where {T,V,N} = ForwardDiff.Dual{T,V,N}(rand(rng,T))

function makerandomproblem(T, n)
    spm = sprand(T, n, n, 1/n)
    spm = -spm - spm' + 40 * LinearAlgebra.I
    
    p = Sparspak.SpkProblem.Problem(n, n, nnz(spm), zero(T))
    Sparspak.SpkProblem.insparse!(p, spm);
    Sparspak.SpkProblem.infullrhs!(p, rand(T,n));
    return p
end

function _test(T)
    for n in rand(100:100:10000,10)
        p = makerandomproblem(T,301)
        A=outsparse(p)
        s = SparseSolver(p)
        solve!(s)
        x = f64.(A) \ f64.(p.rhs)
        @test norm(f64.(p.x) - x) / norm(x) < 1.0e-6
    end
    return true
end

_test(MultiFloats.Float64x1)
_test(MultiFloats.Float64x2)
_test(ForwardDiff.Dual{Float64,Float64,1})
end # module


#
# Differentiate through sparse solve
#
module generic002
using  Test
using LinearAlgebra
using Sparspak
using SparseArrays
using ForwardDiff


function tridiagonal(p,n)
    T=typeof(p)
    b=T[(p^i) for i=1:n]
    a=T[(-0.1) for i=1:n-1]
    c=T[(-0.1) for i=1:n-1]
    Tridiagonal(a,b,c)
end

# Dense version for comprarison
function f(x)
    p=x[1]
    n=20
    M=Matrix(tridiagonal(p,n))
    f=ones(n)
    sum(M\f)
end

df(x)=ForwardDiff.gradient(f,[x])[1]

# Sparse version
function g(x)
    p=x[1]
    n=20
    M=sparse(tridiagonal(p,n))
    f=ones(n)
    pr = Sparspak.SpkProblem.Problem(n,n,nnz(M),zero(p))
    Sparspak.SpkProblem.insparse!(pr, M)
    Sparspak.SpkProblem.infullrhs!(pr,f)
    s = Sparspak.SparseSolver.SparseSolver(pr)
    Sparspak.SparseSolver.solve!(s)    
    sum(pr.x)
end

dg(x)=ForwardDiff.gradient(g,[x])[1]




function _test()
    X=1:0.1:10
    @test all( x->(df(x)≈dg(x)), 1:0.1:10)
    true
end



_test()
end # module


### Test timing
module generic003
using Test
using LinearAlgebra
using SparseArrays
using Sparspak
using Sparspak.SpkSparseSolver: SparseSolver, solve!
using Sparspak.SpkProblem: insparse!, outsparse
using BenchmarkTools, Random
using ForwardDiff
using MultiFloats
using Printf

Random.rand(rng::AbstractRNG, ::Random.SamplerType{ForwardDiff.Dual{T,V,N}}) where {T,V,N} = ForwardDiff.Dual{T,V,N}(rand(rng,T))


function solve(spm::SparseMatrixCSC{Tv,Ti}, b) where {Tv, Ti}
    n=size(spm,1)
    p = Sparspak.SpkProblem.Problem(n, n, nnz(spm), zero(Tv))
    Sparspak.SpkProblem.insparse!(p, spm);
    Sparspak.SpkProblem.infullrhs!(p, b);
    s = SparseSolver(p)
    solve!(s)
    p.x
end


function _testT(;T=Float64, n=20)
    @printf("%40s:",T)
    spm = sprand(T, n, n, 1/n)
    spm = -spm - spm' + 40 * LinearAlgebra.I
    x=ones(T,n)
    b=spm*x
    @test solve(spm,b)≈x
    @btime solve($spm,$b) seconds=0.1
    nothing
end


function _test(;N=[10,100,1_000])
    Random.seed!(9876)
    for n in N
        println("n=$n:")
        _testT(;T=Float64,n)
        _testT(;T=Float64x1,n)
        _testT(;T=Float64x2,n)
        _testT(;T=ForwardDiff.Dual{Float64,Float64,1},n)
    end
end


_test()
end # module

"""
This module contains the common subroutines for Matrix - Matrix
operations for both the LDLt and LU factorization algorithms.
It also contains the subroutine "LUSwap" which is only used by
the LU factorization.
"""
module SpkSpdMMops


using LinearAlgebra
using LinearAlgebra.BLAS: @blasfunc, BlasInt
using Libdl

import ..GenericBlasLapackFragments:  ggemm!, ggemv!, ggetrf!, gtrsm!, glaswp!


if VERSION < v"1.7"
    const libblas = Base.libblas_name
else
    const libblas = LinearAlgebra.BLAS.libblastrampoline
end

# import LinearAlgebra, OpenBLAS64_jll
# LinearAlgebra.BLAS.lbt_forward(OpenBLAS64_jll.libopenblas_path)

# This routine performs an indexed assembly (i.e., scatter - add)
# operation, assuming data structures used in some of our sparse
# lu codes.

# input parameters:
# tlen - number of rows in temp.
# nj - number of columns in temp.
# temp - block update to be incorporated into factor storage.
# relcol - relative column indices.
# relind - relative indices for mapping the updates onto the target columns.
# xlnz - pointers to the start of each column in the target matrix.
# jlen - the length the matrix to be updated

# output parameters:
# lnz - contains columns modified by the update matrix.
function _assmb!(tlen::Integer, nj::Integer, temp::AbstractVector{FT}, relcol::AbstractVector{<:Integer}, relind::AbstractVector{<:Integer}, xlnz::AbstractVector{<:Integer}, lnz::AbstractVector{FT}, jlen::Integer) where {FT}
    for j in 1:nj
        lbot = xlnz[jlen - relcol[j] + 1] - 1
        @inbounds for k in 1:tlen
            lnz[lbot - relind[k]] += temp[(j-1)*tlen + k]
        end
    end
    return true
end

# This routine computes the second index vector used to implement the
# doubly-indirect saxpy-like loops that allow us to accumulate update columns
# directly into factor storage.

#      input parameters -
#         jlen - length of the first column of the supernode,
#                  including the diagonal entry.
#         lindx - the off - diagonal row indices of the supernode,
#                  i.e., the row indices of the nonzero entries
#                  lying below the diagonal entry of the first
#                  column of the supernode.

#      output parameters -
#         indmap - this index vector maps every global row index
#                  of nonzero entries in the first column of the
#                  supernode to its position in the index list
#                  relative to the last index in the list.  more
#                  precisely, it gives the distance of each index
#                  from the last index in the list.
function _ldindx!(jlen::Integer, lindx, indmap::AbstractVector{<:Integer})
    # indmap[lindx[1:jlen]] .= (jlen - 1):-1:0
    @assert length(lindx) >= jlen
    kk = (jlen - 1)
    @inbounds for j in 1:jlen
        indmap[lindx[j]] = kk
        kk -= 1
    end
    return true
end

# this routine performs a standard integer gather
#               operation.
#
#     input parameters -
#        klen - length of the list of global indices.
#        lindx - list of global indices.
#        indmap - indexed by global indices, it contains the
#                 required relative indices.
#
#     output parameters -
#        relind - list relative indices.
#
# *
function _igathr!(klen::Integer, lindx::AbstractVector{<:Integer}, indmap::AbstractVector{<:Integer}, relind::AbstractVector{<:Integer})
    # relind[1:klen] = indmap[lindx[1:klen]]

    @assert length(relind) >= klen
    @assert length(lindx) >= klen
    @inbounds for j in 1:klen
        relind[j] = indmap[lindx[j]]
    end
end

#     this routine performs a matrix-matrix multiply, z = z + xy,
#     assuming data structures used in some of our sparse cholesky
#     codes.
#
#     matrix x has only 1 column and matrix y has only 1 row. QUESTION: Is this a rank-one update?
# 
# input parameters -
#     m       -   number of rows in x and in z.
#     q       -   number of columns in y and z.
#     zindxr  -   zindxr gives the list of rows in z.
#     zindxc  -   zindxc gives the list of columns in z.
#     x       -   contains the rows of x.
#     y(*)    -   contains the columns of y.
#     iz(*)   -   iz(col) points to the beginning of column col.
#     relind  -   where each subscript should go in z relative to the 
#                 bottom
#     diag    -   the diagonal elements of the column X.  This 
#                 option parameter allows for scaling of the column.

# updated parameters -
#     z       -   on output, z = z + xy.
function _mmpyi!(m::Integer, q::Integer,
    zindxr::AbstractVector{<:Integer},
    zindxc::AbstractVector{<:Integer},
    x::AbstractVector{FT},
    y::AbstractVector{FT},
    iz::AbstractVector{<:Integer},
    z::AbstractVector{FT},
    relind::AbstractVector{<:Integer}, diag = one(FT)) where {FT}
    @assert length(x) >= m
    @assert length(y) >= q
    for k in 1:q
        t = y[k]*diag;  zlast = iz[zindxc[k]+1] - 1
        for j in 1:m
            zi = relind[zindxr[j]]
            z[zlast - zi] -= t * x[j]
        end
    end 
    return true
end

function vswap(m, va, vb)
    for j in 1:m
        t = vb[j]
        vb[j] = va[j]
        va[j] = t
    end
end

# This routine performs row swapping inside the Upper block
# supernodes of the Cholesky factorization.  This operation is
# done to match to the row swapping performed on the diagonal
# blocks of L.

#    input parameters -
#        m - number of rows in the supernode.
#        n - number of columns in the supernode.
#        a - the matrix to have its rows pivoted.
#        lda - the real length of supernode a.
#        ipvt(*) - contains the pivotal information.

#    updated parameters -
#        a - on output, a has its rows swapped according to
#                    a[i, k] = a[ipvt[i], k] (i hope)
function _luswap!(m::Integer, n::Integer, a::AbstractVector{FT}, lda::Integer, ipvt::AbstractVector{<:Integer}) where {FT}
    for k in 1:n
        i = ipvt[k]
        ks = (k - 1)*lda + 1
        is = (i - 1)*lda + 1
        vswap(m, view(a, ks:ks+m-1), view(a, is:is+m-1))
    end
end



#
# Generic BLAS + LAPACK methods
#
# Extend  the _gemm! etc. functions  defined below in Sparspak.SpkSpdMMops
# by generic ones. The methods  are wrappers around ggemm! etc functions
# which call  corresponding implementations  from Julia  linear algebra.
#
# Scalar integer parameters are accepted as `Integer` (not `IT`) so the
# pure-Julia path also works when arithmetic upstream has promoted some
# of these scalars to a wider type than the index integer of the vectors.
# This is important when `IT <: Integer` is narrower than `Int` (e.g.,
# `Int32` index arrays + arithmetic with `Int` literals).
function _gemm!(transA::AbstractChar, transB::AbstractChar, m::Integer, n::Integer, k::Integer,
                alpha::FT,
                A::AbstractVector{FT}, lda::Integer,
                B::AbstractVector{FT}, ldb::Integer,
                beta::FT,
                C::AbstractVector{FT}, ldc::Integer) where {FT}
    ggemm!(transA,transB,m,n,k,alpha,A,lda,B,ldb,beta,C,ldc)
end

function _gemv!(transA::AbstractChar, m::Integer, n::Integer,
                alpha::FT,
                A::AbstractVector{FT}, lda::Integer,
                X::AbstractVector{FT},
                beta::FT,
                Y::AbstractVector{FT}) where {FT}
    ggemv!(transA,m,n,alpha,A,lda,X,beta,Y)
end

function _getrf!(m::Integer, n::Integer, A::AbstractVector{FT}, lda::Integer, ipiv::AbstractVector{IT}) where {IT,FT}
    ggetrf!(m,n,A,lda,ipiv)
end

function _trsm!(side::AbstractChar, uplo::AbstractChar, transa::AbstractChar, diag::AbstractChar, m::Integer, n::Integer, alpha::FT,
    A::AT, lda::Integer,
    B::BT, ldb::Integer) where {FT, AT, BT}
    gtrsm!(side,uplo,transa,diag, m,n,alpha,A, lda, B, ldb)
end

function _laswp!(a::AbstractVector{FT}, lda::Integer, k1::Integer, k2::Integer, ipiv::AbstractVector{IT}) where {IT,FT}
    glaswp!(a,lda,k1,k2,ipiv)
end

#
# BLAS+LAPACK for standard floating point types
#

# BLAS-specialized variants. These require `BlasInt` for every integer scalar
# and (for variants with an `ipiv`) `Vector{BlasInt}` for the pivoting array,
# matching the C BLAS/LAPACK ABI. When the caller's index integer type is
# narrower than `BlasInt` (e.g. `Int32` on a 64-bit system), dispatch falls
# through to the generic `_gemm!` / `_getrf!` / … wrappers above, which call
# the pure-Julia `ggemm!` / `ggetrf!` / … implementations.
for (gemm, FT) in
        ((:dgemm_, :Float64),
         (:sgemm_, :Float32),
         (:zgemm_, :ComplexF64),
         (:cgemm_, :ComplexF32))
@eval begin
function _gemm!(transA::AbstractChar, transB::AbstractChar, m::BlasInt, n::BlasInt, k::BlasInt,
    alpha::$FT,
    A::AbstractVector{$FT}, lda::BlasInt,
    B::AbstractVector{$FT}, ldb::BlasInt,
    beta::$FT,
    C::AbstractVector{$FT}, ldc::BlasInt)
    ccall((@blasfunc($gemm), libblas), Cvoid,
        (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
            Ref{BlasInt}, Ref{$FT}, Ptr{$FT}, Ref{BlasInt},
            Ptr{$FT}, Ref{BlasInt}, Ref{$FT}, Ptr{$FT},
            Ref{BlasInt}, Clong, Clong),
        transA, transB, m, n, k, alpha, A, lda,
        B, ldb, beta, C, ldc, 1, 1)
    C
end
end # @eval begin
end

# SUBROUTINE DGETRF( M, N, A, LDA, IPIV, INFO )
# *     .. Scalar Arguments ..
#       INTEGER            INFO, LDA, M, N
# *     .. Array Arguments ..
#       INTEGER            IPIV( * )
#       DOUBLE PRECISION   A( LDA, * )

for (getrf, FT) in
        ((:dgetrf_, :Float64),
         (:sgetrf_, :Float32),
         (:zgetrf_, :ComplexF64),
         (:cgetrf_, :ComplexF32))
@eval begin
function _getrf!(m::BlasInt, n::BlasInt, A::AbstractVector{$FT}, lda::BlasInt, ipiv::AbstractVector{BlasInt})
    info = Ref{BlasInt}()
    ccall((@blasfunc($getrf), libblas), Cvoid,
        (Ref{BlasInt}, Ref{BlasInt}, Ptr{$FT},
            Ref{BlasInt}, Ptr{BlasInt}, Ptr{BlasInt}),
        m, n, A, lda, ipiv, info)
    return info[] #Error code is stored in LU factorization type
end
end # @eval begin
end

#       SUBROUTINE DTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
# *     .. Scalar Arguments ..
#       DOUBLE PRECISION ALPHA
#       INTEGER LDA,LDB,M,N
#       CHARACTER DIAG,SIDE,TRANSA,UPLO
# *     .. Array Arguments ..
#       DOUBLE PRECISION A(LDA,*),B(LDB,*)
# dtrsm("r", "u", "n", "n", jlen - nj, nj, one(FT), lnz[jlpnt], jlen, lnz[jlpnt + nj], jlen)

for (trsm, FT) in
        ((:dtrsm_, :Float64),
         (:strsm_, :Float32),
         (:ztrsm_, :ComplexF64),
         (:ctrsm_, :ComplexF32))
@eval begin
    function _trsm!(side::AbstractChar, uplo::AbstractChar, transa::AbstractChar, diag::AbstractChar, m::BlasInt, n::BlasInt, alpha::$FT,
                    A::AbstractVector{$FT}, lda::BlasInt,
                    B::AbstractVector{$FT}, ldb::BlasInt)
    ccall((@blasfunc($trsm), libblas), Cvoid,
        (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{UInt8},
            Ref{BlasInt}, Ref{BlasInt}, Ref{$FT}, Ptr{$FT},
            Ref{BlasInt}, Ptr{$FT}, Ref{BlasInt},
            Clong, Clong, Clong, Clong),
        side, uplo, transa, diag,
        m, n, alpha, A, lda, B, ldb,
        1, 1, 1, 1)
    B
end
end # @eval begin
end

# SUBROUTINE DLASWP( N, A, LDA, K1, K2, IPIV, INCX )
#  *
#  *       .. Scalar Arguments ..
#  *       INTEGER            INCX, K1, K2, LDA, N
#  *       ..
#  *       .. Array Arguments ..
#  *       INTEGER            IPIV( * )
#  *       DOUBLE PRECISION   A( LDA, * )
for (laswp, FT) in
        ((:dlaswp_, :Float64),
         (:slaswp_, :Float32),
         (:zlaswp_, :ComplexF64),
         (:claswp_, :ComplexF32))
@eval begin
function _laswp!(a::AbstractVector{$FT}, lda::BlasInt, k1::BlasInt, k2::BlasInt, ipiv::AbstractVector{BlasInt})
    # dlaswp(1, rhs(fj), nj, 1, nj, ipiv(fj), 1)
    ccall((@blasfunc($laswp), libblas), Cvoid,
        (Ref{BlasInt}, Ptr{$FT}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt}),
        1, a, lda, k1, k2, ipiv, 1)
    a
end
end # @eval begin
end

#SUBROUTINE DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
#*     .. Scalar Arguments ..
#      DOUBLE PRECISION ALPHA,BETA
#      INTEGER INCX,INCY,LDA,M,N
#      CHARACTER TRANS
#*     .. Array Arguments ..
#      DOUBLE PRECISION A(LDA,*),X(*),Y(*)
for (gemv, FT) in
        ((:dgemv_, :Float64),
         (:sgemv_, :Float32),
         (:zgemv_, :ComplexF64),
         (:cgemv_, :ComplexF32))
@eval begin
    function _gemv!(trans::AbstractChar, m::BlasInt, n::BlasInt, alpha::$FT,
    A::AbstractVector{$FT}, lda::BlasInt,
    X::AbstractVector{$FT},
    beta::$FT, Y::AbstractVector{$FT})
    ccall((@blasfunc($gemv), libblas), Cvoid,
        (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{$FT},
            Ptr{$FT}, Ref{BlasInt}, Ptr{$FT}, Ref{BlasInt},
            Ref{$FT}, Ptr{$FT}, Ref{BlasInt}, Clong),
        trans, m, n, alpha, A, lda, X, 1, beta, Y, 1,
        1)
    Y
end
end # @eval begin
end

end 

# Ordering class:

# nRows is the number of rows in the matrix
# nCols is the number of columns in the matrix

# Ordering objects contain two permutations and their inverses:

# rPerm is a row permutation: rPerm(i) = k means that the new position of
#     row k is in position i in the new permutation.
# rInvp is a row permutation satisfying rInvp(rPerm(i)) = i. Thus, rInvp(k)
#     provides the position in the new ordering of the original row k.

# cPerm and cInvp are analogous to rPerm and rInvp, except they apply
#     to column permutations of the matrix.

# When the matrix is symmetrically permuted, rPerm = cPerm and rInvp = cInvp.

# xRowBlk  is an array that is sometimes used to contain a partitioning
#     of the rows of the matrix, or both the rows and columns when the
#     matrix is symmetric.

# nRowBlks is the number of blocks in the partitioning; the rows of the
#     i - th partition are xRowBlk(i), xRowBlk(i) + 1 ... xRowBlk(i + 1) - 1.0
#     For convenience, xRowBlk has nRowBlks + 1 elements, with
#     xRowBlk(nRowBlks + 1) = nRows + 1.0

#     When the matrix is not symmetric, and a partitioning of the columns
#      is required as well, the pair (nColBlks, xColBlk) is used.

module SpkOrdering

"""
    Ordering{IT}

Type of ordering of the rows and columns.

- `nrows` is the number of rows in the matrix
- `ncols` is the number of columns in the matrix

Ordering objects contain two permutations and their inverses:

- `rperm` is a row permutation: `rperm[i] = k` means that the new position of
    row `k` is in position `i` in the new permutation.
- `rinvp` is a row permutation satisfying `rinvp[rperm[i]] = i`. Thus, `rinvp[k]`
    provides the position in the new ordering of the original row `k`.

`cperm` and `cinvp` are analogous to `rperm` and `rinvp`, except they apply
    to column permutations of the matrix.

When the matrix is symmetrically permuted, `rperm` = `cperm` and `rinvp` =
`cinvp`.

- `xrowblk`  is an array that is sometimes used to contain a partitioning
    of the rows of the matrix, or both the rows and columns when the
    matrix is symmetric.

- `nrowblks` is the number of blocks in the partitioning; the rows of the
    i - th partition are `xrowblk[i]`, `xrowblk[i] + 1` `...` `xrowblk[i + 1] - 1`.
    For convenience, `xrowblk` has `nrowblks + 1` elements, with
    `xrowblk[nrowblks + 1]` `= nrows + 1`.

When the matrix is not symmetric, and a partitioning of the columns is required
as well, the pair `(ncolblks, xcolblk)` is used.

"""
mutable struct Ordering{IT}
    nrows::IT
    ncols::IT
    nrowblks::IT
    ncolblks::IT
    rperm::Vector{IT}
    rinvp::Vector{IT}
    cperm::Vector{IT}
    cinvp::Vector{IT}
    xrowblk::Vector{IT}
    xcolblk::Vector{IT}
end

"""
    Ordering(nrows::IT) where {IT}

Construct an ordering object. 

Since only one parameter(`nrows`) is supplied, it is assumed that the size of the
row ordering and column ordering are the same. That is, that the matrix is
square.

Input Parameters:
- `nrows` - the number of rows (and columns) in the matrix
  
"""
function Ordering(nrows::IT) where {IT}
    return Ordering(nrows, nrows)
end

"""
    Ordering(nrows::IT, ncols::IT) where {IT}

Construct an ordering object. 

The arrays `rperm`, `cperm`, `rinvp`, `cinvp` are allocated and initialized to
the identity permutation.

Input Parameter:
- `nrows`, `ncols` - the number of rows and columns in the matrix
"""
function Ordering(nrows::IT, ncols::IT) where {IT}
    #       The default is to set nRowBlks and nColBlks to 0.
    nrowblks = zero(IT)
    ncolblks = zero(IT)

    rperm = zeros(IT, nrows)
    rinvp = zeros(IT, nrows)
    cperm = zeros(IT, ncols)
    cinvp = zeros(IT, ncols)

    rperm .= 1:nrows
    rinvp .= rperm

    cperm .= 1:ncols
    cinvp .= cperm
    xrowblk = IT[]
    xcolblk = IT[]

    return Ordering(nrows, ncols, nrowblks, ncolblks, rperm, rinvp, cperm, cinvp, xrowblk, xcolblk)
end

end

# This a the outer layer of software that contains a "solver"
# The main role of this layer is to ensure that subroutines are called in the
# proper order.

module SpkSparseSolver

using ..SpkProblem: Problem
using ..SpkSparseBase: _SparseBase
import ..SpkSparseBase: _findorder!, _symbolicfactor!, _inmatrix!, _factor!, _triangularsolve!
using SparseArrays

"""
    SparseSolver{IT, FT}

Type of LU general sparse solver.
"""
mutable struct SparseSolver{IT, FT}
    p::Union{Problem{IT, FT},SparseMatrixCSC{FT,IT}}
    slvr::_SparseBase{IT, FT}
    n::IT
    ma::IT
    na::IT
    mc::IT
    nc::IT
    _inmatrixdone::Bool
    _orderdone::Bool
    _symbolicdone::Bool
    _factordone::Bool
    _trisolvedone::Bool
    _refinedone::Bool
    _condestdone::Bool
end

function Base.copy!(dst::SparseSolver, src::SparseSolver)
    for f in fieldnames(SparseSolver)
        setfield!(dst, f,  getfield(src, f))
    end
    return dst
end

"""
    SparseSolver(p::Problem)

Create a sparse solver from a problem.

The solver pulls all it needs from the problem.
"""
function SparseSolver(p::Problem{IT,FT}) where {IT,FT}
    ma = p.nrows
    na = p.ncols
    mc = zero(IT)
    nc = zero(IT)
    n = ma
    slvr = _SparseBase(p)
    _orderdone = false
    _symbolicdone = false
    _inmatrixdone = false
    _factordone = false
    _trisolvedone = false
    _refinedone = false
    _condestdone = false
    return SparseSolver(p, slvr, n, ma, na, mc, nc, _inmatrixdone, _orderdone, _symbolicdone, _factordone, _trisolvedone, _refinedone, _condestdone)
end

"""
    solve!(s::SparseSolver{IT}) where {IT}

Execute all the steps of the solution process.

Given a symmetric matrix `A`, the steps are:

1. Reordering of the matrix `A`. 
2. Symbolic factorization of the(reordered) matrix `A`. 
3. Putting numerical values of `A` into the data structures. 
4. Numerical factorization of `A`. 
5. Forward and backward substitution (triangular solution).

The solution can be retrieved as `p.x`.
"""
function solve!(s::SparseSolver{IT}) where {IT}
    findorder!(s) || error("Finding Order.")
    symbolicfactor!(s) || error("Symbolic Factorization.")
    inmatrix!(s) || error("Matrix input.")
    factor!(s) || error("Numerical Factorization.")
    triangularsolve!(s) || error("Triangular Solve.")
    return true
end



"""
    findorder!(s::SparseSolver{IT}, orderfunction::F) where {IT, F}

Find reordering of the coefficient matrix.

- `orderfunction`: ordering function

If ordering has already been done for the solver, nothing happens. Otherwise,
the order function is applied.

Finding the ordering invalidates symbolic factorization.
"""
function findorder!(s::SparseSolver{IT}, orderfunction::F) where {IT, F}
    if (s._orderdone)
        return true 
    end
    _findorder!(s.slvr, orderfunction)
    s._orderdone = true
    s._symbolicdone = false
    return true
end

"""
    findorder!(s::SparseSolver{IT}) where {IT}

Find reordering of the coefficient matrix using the default method.

If ordering has already been done for the solver, nothing happens. Otherwise,
the order function is applied.

Finding the ordering invalidates symbolic factorization.
"""
function findorder!(s::SparseSolver{IT}) where {IT}
    if (s._orderdone)
        return true
    end
    _findorder!(s.slvr)
    s._orderdone = true
    s._symbolicdone = false
    return true
end

"""
    findorderperm!(s::SparseSolver{IT}, perm) where {IT}

Find reordering of the coefficient matrix using a given permutation.

If ordering has already been done for the solver, nothing happens. Otherwise,
the order function is applied.

Finding the ordering invalidates symbolic factorization.
"""
function findorderperm!(s::SparseSolver{IT}, perm) where {IT}
    if (s._orderdone) 
        return true 
    end
    _findorder!(s.slvr, perm)
    s._orderdone = true
    s._symbolicdone = false
    return true
end

"""
    symbolicfactor!(s::SparseSolver{IT})

Symbolic factorization of the(reordered) matrix A.

Create the data structures for the factorization and forward and backward
substitution. 

A symbolic factorization invalidates the input of the matrix.
"""
function symbolicfactor!(s::SparseSolver{IT}) where {IT}
    if (s._symbolicdone) 
        return true
    end
    if ( ! s._orderdone)
        error("Sequence error. Ordering not done yet.")
        return false
    end
    _symbolicfactor!(s.slvr)
    s._symbolicdone = true
    s._inmatrixdone = false
    return true
end

"""
    inmatrix!(s::SparseSolver{IT}) where {IT}

Put numerical values of the matrix stored in the problem into the data
structures of the solver.

If a matrix has been input before, and has not been invalidated by symbolic
factorization, nothing is done.

Input of the numerical values of the matrix invalidates the factorization.
"""
function inmatrix!(s::SparseSolver{IT}) where {IT}
    if (s._inmatrixdone) 
        return true
    end
    if ( ! s._symbolicdone)
        error("Sequence error. Symbolic factor not done yet.")
        return false
    end
    success = _inmatrix!(s.slvr, s.p)
    s._inmatrixdone = true
    s._factordone = false
    return success
end

"""
    factor!(s::SparseSolver{IT}) where {IT}

Numerical factorization of the coefficient matrix.

Numerical factorization invalidates the triangular solve.
"""
function factor!(s::SparseSolver{IT}) where {IT}
    @debug "factor! done? $(s._factordone)"
    if (s._factordone) 
        return true
    end
    if ( ! s._inmatrixdone)
        error("Sequence error. Matrix input not done yet.")
        return false
    end

    s._trisolvedone = false
    _factor!(s.slvr)
    if (s.slvr.errflag == 0) 
        s._factordone = true
        return true
    else
        return false
    end
end

"""
    triangularsolve!(s::SparseSolver{IT}) where {IT}

Forward and backward substitution (triangular solution).

The triangular solve is only done if it hasn't been done before; otherwise
nothing is done and the solution is the one obtained before.
"""
function triangularsolve!(s::SparseSolver{IT}) where {IT}
    if (s._trisolvedone) 
        return true
    end
    if ( ! s._factordone)
        error("Sequence error. Factorization not done yet.")
        return false
    end

    temp = deepcopy(s.p.rhs[1:s.p.nrows])
    @assert length(temp) == s.n

    triangularsolve!(s, temp)

    s.p.x .= temp

    s._trisolvedone = true
    s._refinedone = false
    return true
end

"""
    triangularsolve!(s::SparseSolver{IT, FT}, rhs::Vector{FT}) where {IT, FT}

Forward and backward substitution (triangular solution).

Variant where the right-hand side vector is passed in. This always triggers a
triangular solve.
"""
function triangularsolve!(s::SparseSolver{IT, FT}, rhs::AbstractVector{FT}) where {IT, FT}
    if ( ! s._factordone)
        error("Sequence error. Factorization not done yet.")
        return false
    end
    _triangularsolve!(s.slvr, rhs)
    s._trisolvedone = true
    s._refinedone = false
    return true
end

end

#=
This julia script converts fortran 90 code into julia.
It uses naive regex replacements to do as much as possible,
but the output WILL need further cleanup.
Known conversion problems such as GOTO are commented and marked with FIXME
Most variable declaration lines are entirely deleted, which may or
may not be useful. 
To run from a shell: 
julia fortran-julia.jl filename.f90
Output is written to filename.jl.
=#

import Pkg; Pkg.add("DataStructures")
using DataStructures

function doit()
    stem, ext = splitext(filename)
    outfile = stem * "-auto-translated.jl"

    # Regex/substitution pairs for replace(). Order matters here.
    replacements = OrderedDict(
    # Lowercase everything not commented
    r"^(?!.*!).*"m => lowercase,
    # Lowercase start of lines with comments
    r"^.*!"m => lowercase,
    # Remove '&' multiline continuations
    r"\s*&\s*" => "",
    # Comments use # not !
    "!" => "#",
    # Powers use ^ not **
    "**" => "^",
    # Only double quotes allowed for strings
    "'" => "\"",
    # DO loop to for loop
    r"do (.*),(.*)" => s"for \1:\2",
    # Spaces around math operators
    r"([\*\+\/=])(?=\S)" => s"\1 ",
    r"(?<=\S)([\*\+\/=])" => s" \1",
    # Spaces around - operators, except after e
    # r"([^e][\-])(\S)" => s"\1 \2",
    r"(?<!\W\de)(\h*\-\h*)" => s" - ",
    r"(= =)" => "==",
    # Space after all commas
    r"(,)(\S)" => s"\1 \2",
    # Replace space after all (
    r"(\()(\s*)" => "(",
    # Replace space before all (
    r"(\s*)(\))" => ")",
    # Replace ELSEIF/ELSE IF with elseif 
    r"(\s+)else\s*if" => s"\1elseif",
    # Replace IF followed by ( to if (
    r"(\s+)(elseif|if)\(" => s"\1\2 (",
    # Add end after single line if with an = assignment
    # r"if\s*\((.*?)\)(\s*.*\s*.*=\s*.*)(\n)" => s"if (\1) \2 end\3",
    # Remove THEN
    r"([)\s])then(\s+)" => s"\1\2",
    # Replace END XXXX with end
    r"(\s+)end\s*do" => s"\1end",
    # Replace END XXXX with end
    r"(\s+)end\s*if" => s"\1end",
    # Replace END FUNCTION with end
    r"end function .*" => s"end",
    # Replace END subroutine with end
    r"end subroutine .*" => s"end",
    # Replace allocate
    r"(allocate\((.*)\((.*)\)\))" => s"FIXME \1",
    # Replace exponent function
    # r"(\W)exp\(" => s"\1exp(",
    # Reorganise functions and doc strings. This may be very project specific.
    r"#\^\^+\s*subroutine\s*(\w+)([^)]+\))\s*(.*?)#\^\^\^+"sm => 
    Base.SubstitutionString("\"\"\"\n\\3\"\"\"\nfunction \\1\\2"),
    r"real \(double\) function\s*(\w+)([^)]+\))\s*(.*?)\#\^\^\^+"sm => 
    Base.SubstitutionString("\"\"\"\n\\3\"\"\"\nfunction \\1\\2"),
    # Don't need CALL
    r"(\s*)call(\h+)" => s"\1",
    # Use real math symbols
    #   "gamma" => "Γ",
    #   "theta" => "Θ",
    #   "epsilon" => "ϵ",
    #   "lambda" => "λ",
    #   "alpha" => "α",
    # Swap logical symbols
    ".true." => "true",
    ".false." => "false",
    r"\s*\.or\.\s*" => " || ",
    r"\s*\.and\.\s*" => " && ",
    r"\s*\.not\.\s*" => " ! ",
    r"\s*\.eq\.\s*" => " == ",
    r"\s*\.ne\.\s*" => " != ",
    r"\s*\.le\.\s*" => " <= ",
    r"\s*\.ge\.\s*" => " >= ",
    r"\s*\.gt\.\s*" => " > ",
    r"\s*\.lt\.\s*" => " < ",
    # Remove (expression) brackets after if
    # r"if \((.*)\)(\s*\n)" => s"if \1\2",
    # Format floats as "5.0" not "5."
    r"(\W\d+)\.(\D)" => s"\1.0\2",
    # Tab to 4 spaces
    r"\t" => "    ",
    # Replace component access
    r"%" => ".",
    # Replace doubled !
    r"## " => "#",
    # Replace #^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
    r"#\^*" => "#",
    # # Replace opening and closing of comments
    r"##>" => "# \"\"\"",
    r"##<(\s*.*)" => Base.SubstitutionString("# \\1\\n# \"\"\""),
    r"# \"\"\" Purpose:" => "# \"\"\"",
    # r"##" => "",
    # Replace suberror with error and mark for fixup
    r"(\W)suberror\((.*?),.*?\)" => s"\1 error(\2)",
    # Mark #FIXME the various things this script can't handle
    r"(write|goto|while\s)" => s"FIXME \1",
    )

    # Patterns to remove
    removal = [
    #   # Trailing whitespace
      r"\h*$"m,
    #   # Variable declarations
    #   r"\n\s*real\s.*",
    #   r"\n\s*real, external\s.*",
    #   r"\n\s*integer\s.*",
      r"\n\s*implicit none",
    #   r"\n\s*logical\s.*",
    #   # Import statements
      r"\n\s*use\s.*",
      r"\n\s*contains\s.*",
    ]

    # Load the file from the first command line argument

    code = read(filename,String)

    # Process replacements and removals.
    for (f, r) in replacements
        code = replace(code, f => r)
    end
    for r in removal
        code = replace(code, r => "")
    end
    # println(code)


    # Write the output to a .jl file with the same filename stem.
    
    open(outfile,"w") do f
        write(f, code)
    end

    return nothing    
end

    filename = ARGS[1]
    doit()

"""
This class contains the variables for the data structure for the
SparseSolver.

The Cholesky factor of the matrix is stored column by column.
Only the nonzeros of the matrix are stored, in an efficient way by
exploiting supernode structure. A supernode is simply a set of
consecutive columns, say columns i, i + 1, i + 2, ... i + s - 1, all of which
have essentially identical structure. Column i and columns i + 1
have nonzeros in identical rows, except that element (i, i + 1) is
zero (of course). If one stores the subscripts of the nonzero
elements for column i,  one can easily determine the subscripts of
the nonzeros in the other columns of the supernode.

n - the number of rows and columns in the matrix.

nnzl - the number of nonzeros in the Cholesky factor L.

nsub - the number of row subscripts stored. This is also the
              length of the array lindx, and equal to xlindx(n + 1) - 1.0

nsuper - the number of supernodes in the Cholesky factor

xsuper - the supernode structure. The i - th supernode consists
              of columns xsuper(i), xsuper(i) + 1, ... xsuper(i + 1) - 1.0
              ie.  maps a supernode to it"s first column

errflag - an error flag. If a zero diagonal element is detected
              during the factorization, errflag is set to - 1.0
              If no errors are detected, errflag will be 0.0

(xlindx, lindx) - a pair of arrays containing the row subscripts of
              the first columns of the supernodes. The row subscripts
              of the nonzeros in the i - th supernode (including the
              diagonal element) are given by lindx(xlindx(i)),
              lindx(xlindx(i) + 1), ..., lindx(xlindx(i + 1) - 1)
              Note that lindx is of length nsub. The array
              xlindx is of length nsuper + 1, with xlindx(nsuper + 1)
              equal to nsub + 1.0
              This data structure also contains the column subscripts
              of U; however, they begin at lindx(xlindx(jsup) + width(jsup))
              where width(jsup) = xsuper(jsup + 1) - xsuper(jsup)

(xlnz, lnz) - the nonzero elements of the Cholesky factor. The nonzero
              elements in the k - th column of L are given by
              lnz(xlnz(k)), lnz(xlnz(k) + 1), ...,
              lnz(xlnz(xsuper(snode(k + 1)) - 1).
(xunz, unz) - the nonzero elements of the Cholesky factor. The nonzero
              elements in the k - th row of U are given by
              lnz(xlnz(k)), lnz(xlnz(k + 1), ...,
              lnz(xlnz(xsuper(snode(k) + 1)) - 1)

colcnt - array of length neqns, containing the number
              of nonzeros in each column of the factor,

The algorithm employed is a so - called "left - looking" scheme; each
supernode is computed by applying modifications from other supernodes
to its left.

snode - This is an array which makes it convenient to quickly
              determine in which supernode a column resides.
              snode(i) = k means column i is in supernode k.

maxBlockSize - in order to improve multiprocessor utilization, it is
               helpful to split the larger supernodes into smaller ones.
               This is done by introducing artificial supernodes.
               The variable maxBlockSize governs this process; no
               supernode will have more than maxBlockSize columns.
               At present, this is fixed at 30 columns.

ipiv - This array is used to hold the piviting information
               about the rows of U and the diagonal blocks.
               This information will be needed later to solve the system.

tempSizeNeed - To use the BLAS routines, a temporary array will be
              need to put calculations into.  The maximum size needed
              is the max number of non zero"s in any supernode.
              This calculation is done inside the factorization routine
              and can pretty much be removed from here...
              For whatever reason, the calculations here and in the
              factorization sseem to differ... bummer#

For more details on the algorithm and storage scheme used in this solver
class, please refer to Chapter 5 of the book "Computer Solution of Large
Sparse Positive Definite Systems" by Alan George and Joseph Liu published
by Prentice - Hall, 1981.0
"""
module SpkSparseBase

using ..SpkOrdering: Ordering
using ..SpkGraph: Graph, makestructuresymmetric
using ..SpkETree: ETree, _getetree!, _getpostorder!
using ..SpkSymfct: _findcolumncounts!, _symbolicfact!, _findsupernodes!
using ..SpkLUFactor: _lufactor!, _lulsolve!, _luusolve!
using ..SpkProblem: Problem
using ..SpkUtilities: __extend
using ..SpkMmd: mmd!

mutable struct _SparseBase{IT, FT}
    order::Ordering
    t::ETree
    g::Graph
    errflag::IT
    n::IT
    nnz::IT
    nnzl::IT
    nsub::IT
    nsuper::IT
    maxblocksize::IT
    tempsizeneed::IT
    factorops::FT
    solveops::FT
    realstore::FT
    integerstore::FT
    colcnt::Vector{IT}
    snode::Vector{IT}
    xsuper::Vector{IT}
    xlindx::Vector{IT}
    lindx::Vector{IT}
    xlnz::Vector{IT}
    xunz::Vector{IT}
    ipiv::Vector{IT}
    lnz::Vector{FT}
    unz::Vector{FT}
end


# This routine initializes the solver object s by retrieving some
# information from the problem object p. The solver object contains
# an elimination tree and an ordering object; these are also
#  initialized in this routine.
function _SparseBase(p::Problem{IT,FT}) where {IT,FT}
    maxblocksize = convert(IT, 30)   # This can be set by the user

    tempsizeneed = zero(IT)
    n = p.nrows
    nnz = p.nnz
    nnzl = zero(IT)
    nsub = zero(IT)

    nsuper = zero(IT)
    if (n > zero(IT))
        nsuper = one(IT)
    end

    factorops = zero(FT)
    solveops = zero(FT)
    realstore = zero(FT)
    integerstore = zero(FT)
    errflag = zero(IT)

    order = Ordering(n)   # ordering object for the solver
    g = Graph(p)
    t = ETree(n)

    colcnt = IT[]
    snode = IT[]
    xsuper = IT[]
    xlindx = IT[]
    lindx = IT[]
    xlnz = IT[]
    xunz = IT[]
    ipiv = IT[]
    lnz = FT[]
    unz = FT[]

    return _SparseBase(order, t, g, errflag, n, nnz, nnzl, nsub, nsuper, maxblocksize,
        tempsizeneed, factorops, solveops, realstore, integerstore,
        colcnt, snode, xsuper, xlindx, lindx, xlnz, xunz, ipiv,
        lnz, unz)
end

function _findorder!(s::_SparseBase{IT}, orderfunction::F) where {IT, F}
    if (s.n == 0)
        error("An empty problem, no ordering found.")
        return false
    end
    makestructuresymmetric(s.g)     # Make it symmetric
    orderfunction(s.g, s.order)   # Default ordering function
    return true
end

function _findorder!(s::_SparseBase{IT}) where {IT}
    return _findorder!(s, mmd!)
end

# #     This subroutine computes the storage requirements and sets up
#     # data structures for the symbolic and numerical factorization.
# #
# Input parameters: solver object
# #
# The "output" is the modified solver object.
function _symbolicfactor!(s::_SparseBase{IT, FT}) where {IT, FT}

    if (s.n == 0)
        error("An empty problem. No symbolic factorization done.")
        return false
    end

    s.colcnt = zeros(IT, s.n)
    s.snode = zeros(IT, s.n)
    s.xsuper = zeros(IT, s.n + 1)

# -  -  -  -  -  -  -  -  -
#       Compute elimination tree
# -  -
    _getetree!(s.g, s.order, s.t)
    _getpostorder!(s.t, s.order)

# -
#       Compute row and column factor nonzero counts.
# -
    _findcolumncounts!(s.g.nv, s.g.xadj, s.g.adj, s.order.rperm, s.order.rinvp, s.t.parent, s.colcnt, s.nnzl)
    _getpostorder!(s.t, s.order, s.colcnt)

#-  -    -
#       Find supernodes. Split them so none are larger than maxBlockSize
# -  -  -
    s.nsub, s.nsuper = _findsupernodes!(s.g.nv, s.t.parent, s.colcnt, s.nsub, s.nsuper, s.xsuper, s.snode, s.maxblocksize)
    s.xsuper = __extend(s.xsuper, s.nsuper + 1)

    s.lindx = zeros(IT, s.nsub)
    s.xlindx = zeros(IT, s.nsuper + 1)

# -
#       setup for symbolic factorization.
# -
    s.xlnz = zeros(IT, s.n + 1)
    s.xunz = zeros(IT, s.n + 1)
    s.ipiv = zeros(IT, s.n)

# -
#       Set up the data structure for the Cholesky factor.
# -
    findnonzeroindexs(s.n, s.colcnt, s.nsuper, s.xsuper, s.xlnz, s.xunz, s.tempsizeneed)
    
    _symbolicfact!(s.g.nv, s.g.xadj, s.g.adj, s.order.rperm, s.order.rinvp, s.colcnt, s.nsuper, s.xsuper, s.snode, s.nsub, s.xlindx, s.lindx)

# -
#       We now know how many elements we need, so allocate for it.
# -
    s.lnz = zeros(FT, s.xlnz[s.n + 1] - 1)
    s.unz = zeros(FT, s.xunz[s.n + 1] - 1)


    s.lnz[1:s.xlnz[s.n + 1] - 1] .= zero(FT)
    s.unz[1:s.xunz[s.n + 1] - 1] .= zero(FT)
    s.ipiv[1:s.n] .= zero(IT)

    return true
end

function findnonzeroindexs(n, colcnt, nsuper, xsuper, xlnz, xunz, maxtemp)
# """
#    This routine inserts the index offsets for the arrays xlnz and xunz.
# """
#
        # integer :: nsuper, maxtemp, n
        # integer :: xsuper(*)
        # integer :: colcnt(*), xlnz(*), xunz(*)
        # integer :: fstcol, ksup, lstcol, point, width, nnzinsuper
        # integer :: upoint, jcol

    upoint = 1; point = 1; nnzinsuper = 0

    for ksup in 1:nsuper
        fstcol = xsuper[ksup]; lstcol = xsuper[ksup + 1] - 1
        maxtemp = max(maxtemp, nnzinsuper)
        nnzinsuper = 0
        width = lstcol - fstcol + 1
        for jcol in fstcol:lstcol
            xlnz[jcol] = point
            xunz[jcol] = upoint
            nnzinsuper = nnzinsuper + colcnt[fstcol]
            point = point + colcnt[fstcol]
            upoint = upoint + colcnt[fstcol] - width
        end
        nnzinsuper = nnzinsuper + colcnt[fstcol]
    end

    xlnz[n + 1] = point; point = 1
    xunz[n + 1] = upoint

end


#     This subroutine retrieves a matrix from a problem object p and
#     inserts its elements into the data structure for the Cholesky
#     factor L. The data structure involves the arrays xlindx, lindx,
#     xlnz, lnz, xunz and unz as described in the comments at the
#     beginning of this module.
#     The components of the problem object are decribed in the
#     comments at the beginning of the SpkProblem module.
#     Note that the Cholesky factor L corresponds to the matrix
#     problem after it has had its rows and columns permuted.
#     Thus, a reordering is applied to its elements before they are
#     inserted into the data structure.
# 
# Input parameters: problem and solver objects
# The "output" is the modified solver object.

function _inmatrix!(s::_SparseBase{IT, FT}, p::Problem{IT, FT}) where {IT, FT}
    if (s.n == 0)
        error("An empty problem. No matrix.")
        return false
    end

    s.lnz .= zero(FT)
    s.unz .= zero(FT)
    s.ipiv .= zero(IT)

    function doit(ncols, link, head, rinvp, cinvp, rowsubs, snode, xsuper, xlindx, lindx, values, xlnz, lnz, xunz, unz)
        for i in 1:ncols
            ptr = head[i]
            while (ptr > 0)  # scan column i ....
                inew = rinvp[rowsubs[ptr]];
                jnew = cinvp[i]
                value = values[ptr];

                if (inew >= xsuper[snode[jnew]])
#               Lies in L.  get pointers and lengths needed to search
#               column jnew of L for location l(inew, jnew).
                    jsup = snode[jnew];
                    fstcol = xsuper[jsup]
                    fstsub = xlindx[jsup]
                    lstsub = xlindx[jsup + 1] - 1
                    nnzloc = 0;
                    for nxtsub in fstsub:lstsub
                        irow = lindx[nxtsub]
                        if  (irow > inew)
                            error("No space for matrix element ($(inew), $(jnew)).")
                            return false
                        end
                        if  (irow == inew)
#                       find a proper offset into lnz and increment by value
                            _p = xlnz[jnew] + nnzloc
                            lnz[_p] += value
                            break
                        end
                        nnzloc = nnzloc + 1
                    end
                else
#               Lies in U
                    jsup = snode[inew]
                    fstcol = xsuper[jsup]
                    lstcol = xsuper[jsup + 1] - 1
                    width = lstcol - fstcol + 1
                    lstsub = xlindx[jsup + 1] - 1
                    fstsub = xlindx[jsup] + width
                    nnzloc = 0;
                    for nxtsub in fstsub:lstsub
                        irow = lindx[nxtsub]
                        if  (irow > jnew)
                            error("No space for matrix element ($(inew), $(jnew)).")
                            return false
                        end
                        if  (irow == jnew)
#                       find a proper offset into unz and increment by value
                            _p = xunz[inew] + nnzloc
                            unz[_p] += value
                            break
                        end
                        nnzloc = nnzloc + 1
                    end
                end
                ptr = link[ptr]
            end
        end
        return true
    end
    return doit(p.ncols, p.link, p.head, s.order.rinvp, s.order.cinvp, p.rowsubs, s.snode, s.xsuper, s.xlindx, s.lindx, p.values, s.xlnz, s.lnz, s.xunz, s.unz)
end

# This routine calls the lower - level routine LUFactor which
# computes and L U factorization of the matrix stored in the
# solver object s. The components of the solver object are described
#  in the comments at the beginning of this module.
function _factor!(s::_SparseBase{IT, FT}) where {IT, FT}
    if (s.n == 0)
        error("An empty problem. No matrix.")
        return false
    end

    s.errflag = _lufactor!(s.n, s.nsuper, s.xsuper, s.snode, s.xlindx, s.lindx, s.xlnz, s.lnz, s.xunz, s.unz, s.ipiv)

    if (s.errflag != 0)
        error("An empty problem. No matrix.")
        return false
    end
    return true
end


# This routine calls the lower - level routine LUSolve which
# solves L U x = rhs, given L, U and rhs. The solution is placed in
# the array rhs. Note that the factorization is of a permuted form of
# the problem, and it is assumed that the user provides the rhs in
# the original order. Thus, the permutation "hidden" in the solver
#  object is applied as appropriate.
function _triangularsolve!(s::_SparseBase{IT, FT}, solution::AbstractVector{FT}) where {IT, FT}
    if (s.n == 0)
        error("An empty problem. No solution.")
        return false
    end

    rhs = zeros(FT, s.n)
    rhs .= solution[s.order.rperm]

    _lulsolve!(s.nsuper, s.xsuper, s.xlindx, s.lindx, s.xlnz, s.lnz, s.ipiv, rhs)

    _luusolve!(s.n, s.nsuper, s.xsuper, s.xlindx, s.lindx, s.xlnz, s.lnz, s.xunz, s.unz, rhs)

    solution .= rhs[s.order.rinvp]

    return true
end

end

module SpkLDLtFactor

using ..SpkSpdMMops: _ldindx!, _trsm!, _igathr!, _gemm!, _assmb!, _mmpyi!

#
#  LDLtFactor ..... BLOCK GENERAL SPARSE CHOL   ^^^^^^
# *
# *
# """
#  purpose:
#      this subroutine computes an LDL^t factorization of a sparse
#      matrix with symmetric structure.  the computation is
#      organized around kernels that perform supernode - to - supernode
#      updates.  level - 3 blas routines used whenever possible.
#      each supernode is a dense trapezoidal submatrix stored in
#      a rectangular array.
##
#  input parameters:
#      nsuper - number of supernode.
#      xsuper - supernode partition.
#      snode - maps each column to the supernode containing it.
#      (xlindx, lindx) - row indices for each supernode (including
#                          the diagonal elements).
#      (xnz, lnz) - on input, contains matrix to be factored.
##
#  output parameters:
#      lnz - on output, contains cholesky factor.
#      iflag - error flag.
#                              0: successful factorization.
#- 1: zero diagonal encountered,
#                                 matrix is (numerically) singular
##
#  local variables:
#      link - a linked list that stores the supernode
#                          modification list.  if link(jsup) = k,
#                          supernodes k, link(k), link(link(k)), ... all
#                          modify supernode jsup.
#      length - length of the active portion of each supernode.
#                          ie. the length that hasn"t effected a diagonal
#                          block yet.
#      map - vector of size n into which the global
#                          indices are scattered.  This array holds the
#                          distance of row k from the bottom of the
#                          supernode if it were compressed.
#      relind - maps locations in the updating columns to
#                          the corresponding locations in the updated
#                          columns.  (relind is gathered from map).
#                          more specifically, this is an array of length
#                          length(ksup), and only stores the elements
#                          from map coresponding to the union of row indxes
#                          of jsup and ksup.
#      temp - real vector for accumulating updates.  must
#                          accomodate all columns of a supernode.
#      temp2 - real vector for storing the DL^t computation.
#
# *
# """
function _ldltfactor!(n::IT, nsuper::IT, xsuper::Vector{IT}, snode::Vector{IT}, 
    xlindx::Vector{IT}, lindx::Vector{IT}, xlnz::Vector{IT}, lnz::Vector{FT}) where {FT, IT}
    @assert length(xsuper) == (nsuper + 1)
    @assert length(snode) == n
    @assert length(xlindx) == (nsuper + 1)
    @assert length(xlnz) == (n + 1)

    ONE = one(FT)
    ZERO = zero(FT)

    link = zeros(IT, nsuper)
    lngth = zeros(IT, nsuper)

    iflag = 0;   width = 0;   maxwidth = 0; tmpsiz = 0

#       initialize empty row lists in link(*).
    for i  in  1: nsuper
        link[i] = 0;   lngth[i] = xlindx[i + 1] - xlindx[i]
        width = xsuper[i + 1] - xsuper[i]
        need = width * (xlnz[xsuper[i] + 1] - xlnz[xsuper[i]])
        if (need > tmpsiz) tmpsiz = need; end
        maxwidth = max(maxwidth, width)
    end

    map = zeros(IT, n)
    relind = zeros(IT, n)
    diag = zeros(FT, maxwidth)
    temp = zeros(FT, tmpsiz)
    temp2 = zeros(FT, maxwidth * maxwidth)


#      for each supernode jsup ...
       for jj  in  1: nsuper
          jsup = jj
#         [f / l]j ...  first / last column of jsup.
#         nj     ...  number of columns in jsup.
#         jlen   ...  length of jsup.
#         jxpnt  ...  pointer to index of first nonzero in
#                     jsup.
#         jlpnt  ...  pointer to location of first nonzero
#                     in column fj.
          fj    = xsuper[jsup]; lj = xsuper[jsup + 1] - 1
          nj    = lj - fj + 1
          jlen  = xlnz[fj + 1] - xlnz[fj]
          jxpnt = xlindx[jsup]
          jlpnt = xlnz[fj]
#         set up map(*) to map the entries in update columns
#         to their corresponding positions in updated columns,
#         relative to the bottom of each updated column.
          _ldindx!(jlen, view(lindx, jxpnt:length(lindx)), map)
#         for every supernode ksup in row(jsup) ...
          while (true)
#            take out the first item in the list.  MUST BE DONE
#            atomically
            ksup = link[jsup]
            if (ksup != 0)
#                  remove the head of the list.
                link[jsup] = link[ksup]
                link[ksup] = 0
            end
            if (ksup == 0) break; end
#            get info about the cmod(jsup, ksup) update.
#
#            [f / l]k   ...  first / last column of ksup.
#            nk       ...  number of columns in ksup.
#            ksuplen  ...  length of ksup.
#            klen     ...  length of active portion of ksup.
#            kxpnt    ...  pointer to index of first nonzero in
#                          active portion of ksup.
#            klpnt    ...  pointer to location of first nonzero in
#                          active portion of column fk.
             fk  = xsuper[ksup]
             lk  = xsuper[ksup + 1] - 1
             nk = lk - fk + 1
             ksuplen  = xlnz[fk + 1] - xlnz[fk]
             klen   = lngth[ksup]
             kxpnt  = xlindx[ksup + 1] - klen
             klpnt = xlnz[fk + 1] - klen

             _loaddiag!(view(lnz, xlnz[fk]:length(lnz)), ksuplen, nk, diag)
#            perform cmod(jsup, ksup), with special cases
#            handled differently.
#            nups  ...  number of rows / columns updated.
             if (klen == jlen)
#               dense cmod(jsup, ksup).
#               jsup and ksup have identical structure.
                _matrixdiagmm!(view(lnz, klpnt:length(lnz)), nj, nk, ksuplen, diag, temp2)
                _gemm!('n', 't', jlen, nj, nk, -ONE, view(lnz, klpnt:length(lnz)), ksuplen, temp2, nj, 
                    ONE, view(lnz, jlpnt:length(lnz)), jlen)
                nups = nj
                if  (klen > nj)
                    nxt = lindx[jxpnt + nj]
                end
            else
#               sparse cmod(jsup, ksup).
#               determine the number of rows / columns
#               to be updated.
                nups = klen
                for i  in  0:1:(klen - 1)
                    nxt = lindx[kxpnt + i]
                    if  (nxt > lj)
                        nups = i
                        break
                    end
                end
                if (nk == 1)
#                  updating target supernode by a trivial
#                  supernode (with one column).
                    _mmpyi!(klen, nups, view(lindx, kxpnt:length(lindx)), 
                        view(lindx, kxpnt:length(lindx)), view(lnz, klpnt:length(lnz)), 
                        view(lnz, klpnt:length(lnz)), xlnz, lnz, map, lnz[xlnz[fk]])

                else
#                  kfirst ...  first index of active portion of
#                              supernode Ksup (first column
#                              to be updated).
#                  klast  ...  last index of active portion of
#                              supernode Ksup.
                    kfirst = lindx[kxpnt]
                    klast  = lindx[kxpnt + klen - 1]
                    inddif = map[kfirst] - map[klast]
                    if  (inddif < klen)
#                     dense cmod(Jsup, Ksup).
#
#                     ilpnt  ...  pointer to first nonzero in
#                                 column kfirst.
                        ilpnt = xlnz[kfirst] + (kfirst - fj)
                        width = nups
                        _matrixdiagmm!(view(lnz, klpnt:length(lnz)), width, nk, ksuplen, diag, temp2)

                        _gemm!('n', 't', klen, nups, nk, -ONE, view(lnz, klpnt:length(lnz)), ksuplen, 
                            temp2, width, ONE, view(lnz, ilpnt:length(lnz)), jlen)
                    else
#                     general sparse cmod(Jsup, Ksup).
#                     compute cmod(Jsup, Ksup) update
#                     in work storage.
                        store = klen * nups
                        if  (store > tmpsiz)
                            iflag = - 2
                            error("Insufficient storage: $store > $tmpsiz")
                        end
#                     gather indices of ksup relative to jsup.
                        _igathr!(klen, view(lindx, kxpnt:length(lindx)), map, relind)
                        width = nups
                        _matrixdiagmm!(view(lnz, klpnt:length(lnz)), width, nk, ksuplen, 
                            diag, temp2)

                        _gemm!('n', 't', klen, nups, nk, -ONE, view(lnz, klpnt:length(lnz)), ksuplen,
                             temp2, width, ZERO, temp, klen)
#                     incorporate the cmod(Jsup, Ksup) block
#                     update into the appropriate columns of l.
                        _assmb!(klen, nups, temp, view(relind, 1:length(relind)), view(relind, 1:length(relind)), 
                            view(xlnz, fj:length(xlnz)), lnz, jlen)
                    end
                end
            end
#            link Ksup into linked list of the next
#            supernode
#            it will update and decrement ksup"s active
#            length.
            if (klen > nups)
                nxtsup = snode[nxt]
                link[ksup] = link[nxtsup]
                link[nxtsup] = ksup
                lngth[ksup] = klen - nups
            else
                lngth[ksup] = 0
            end
        end
#         Apply partial LDLt to the supernode
        _pchole!(view(lnz, xlnz[fj]:length(lnz)), nj, jlen)
#         insert Jsup into linked list of first
#         supernode it will update.
        if  (jlen > nj)
            nxt = lindx[jxpnt + nj]
            nxtsup = snode[nxt]
            link[jsup] = link[nxtsup]
            link[nxtsup] = jsup
            lngth[jsup] = jlen - nj
        else
            lngth[jsup] = 0
        end
#
#         decrement the counter on all depending supernodes
#
    end

    return iflag
end

#
#
# *     LDLtSolve ... block triangular solutions ^^^^^^^^^^ *
#
# """   Purpose:
#      Given the L D L^T factorization of a sparse symmetric
#      positive definite matrix, this subroutine performs the
#      triangular solution.  It uses output from LDLtFactor.
#  Input parameters:
#      nsuper - number of supernodes.
#      xsuper - supernode partition.
#      (xlindx, lindx) - row indices for each supernode.
#      (xlnz, lnz) - Cholesky factor.
#  Updated parameters:
#      rhs - on input, contains the right hand side.  on
#                          output, contains the solution.
"""
"""
function _ldltsolve!(nsuper, xsuper, xlindx, lindx, xlnz, lnz, rhs)
#    forward substitution ...
     for jsup  in  1: nsuper
        fjcol = xsuper[jsup];   ljcol = xsuper[jsup + 1] - 1;
        fsub = xlindx[jsup];   lsub = xlindx[jsup + 1] - 1;
        for jcol  in  fjcol: ljcol
            ofst = jcol - fjcol
            nzf = xlnz[jcol] + 1 + ofst;   nzl = xlnz[jcol + 1] - 1;
            fsub = fsub + 1;   t = rhs[jcol];
            rhs[lindx[fsub:lsub]] = rhs[lindx[fsub:lsub]] - t * lnz[nzf:nzl]
        end
    end
#    backward substitution ...
    for jsup  in  nsuper:-1:1
        fjcol = xsuper[jsup];   ljcol = xsuper[jsup + 1] - 1;
        fsub = xlindx[jsup] + ljcol - fjcol;
        for jcol  in  ljcol:-1:fjcol
            ofst = jcol - fjcol
            nzf = xlnz[jcol] + ofst;   m = xlnz[jcol + 1] - nzf - 1;
            t = rhs[jcol] / lnz[nzf]
            for k  in  1: m
                t = t - lnz[nzf + k] * rhs[lindx[fsub + k]]
            end
            rhs[jcol] = t;   fsub = fsub - 1
        end
    end
    return true
end

#       This routine will perform matrix multiplication by a diagonal
#       matrix.  The diagonal matrix is stored as a vector, and will
#       scale the rows of the output matrix
#
#   INPUT PARAMETERS -
#       lnz - pointer to the first non - diagonal, non - zero in the
#                 supernode
#       klen - length of the section to copy into temp, and the length
#                 of temp
#       nk - width of the supernode and temp
#       ksuplen - length of each column of the supernode
#       diag - a vector representation of a diagonal matrix
#
#   UPDATED PARAMETERS -
#       temp - On output, temp is the result of the multiplication

@inline function _twod_access(nr, i, j)
    (j-1)*nr + i
end

function _matrixdiagmm!(lnz, klen, nk, ksuplen, diag, temp)
    # The two dimensional arrays are being passed in as 1d views. The two
    # dimensional access needs to be faked.
    # real(double) :: lnz(ksuplen,nk), temp(klen,nk), diag(nk)
    for  j  in  1: nk
        diagonal = diag[j]
        for r in 1:klen
            temp[_twod_access(klen, r, j)] = diagonal*lnz[_twod_access(klen, r, j)]
        end
    end
end


function _loaddiag!(lnz::AbstractVector{FT}, ksuplen::IT, nk::IT, diag::AbstractVector{FT}) where {FT, IT}
    # real(double) :: lnz(ksuplen,nk), diag(*)
    for j in 1:nk
        diag[j] = lnz[_twod_access(ksuplen, j, j)]
    end
end


# !       this routine will apply the partial cholesky factorization to
# !       a supernode through a left looking algorithm.
# !       This algorithm assumes that supernodes are rectangular, rather
# !       than trapezoidal.
# !
# !   INPUT PARAMETERS -
# !       lnz     - on input, contains the matrix starting at the
# !                 supernode.
# !        nj     - number of column in this supernode
# !        lda    - the number of rows in the supernode
# !
function _pchole!(lnz::AbstractVector{FT}, nj, lda) where {FT}
    ONE = one(FT)

# real(double) :: lnz(lda, *) the 2d access needs to be faked
    for colnum  in  1: nj
#       factor the diagonal block.
        for i = 1: colnum - 1
            for r in colnum:nj
                lnz[_twod_access(lda, r, colnum)] +=  - lnz[_twod_access(lda, colnum, i)] * lnz[_twod_access(lda, i, i)] * lnz[_twod_access(lda, r, i)]
            end
            diag = lnz[_twod_access(lda, colnum, colnum)]
            for r in colnum + 1:nj
                lnz[_twod_access(lda, r, colnum)] /= diag
            end
        end
    end

# -  -  -  -  -
#    factor the lower block.
#
    _trsm!('r', 'l', 't', 'u', lda - nj, nj, ONE, lnz, lda, view(lnz, nj + 1:length(lnz)), lda)

# -
#    scale back each column by the diagonal.
# -
    for colnum  in  1: nj
        diag = lnz[_twod_access(lda, colnum, colnum)]
        for r in nj + 1:lda
            lnz[_twod_access(lda, r, colnum)] /= diag
        end
    end
end
#
end # module spkldltfactor

module m_simpletest
using Test
using Sparspak
using Random, SparseArrays, LinearAlgebra
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkSparseSolver

#
# This is so far the simplest test problem occuring
#
function simpletest(;n=4)
    A = sparse(Diagonal(ones(n)))
    A[2,1]=-0.1
    pr = SpkProblem.Problem(n,n, 10)
    @test SpkProblem.insparse!(pr, A)
    
    s = SpkSparseSolver.SparseSolver(pr)
    @test SpkSparseSolver.findorder!(s)
end

simpletest()
end

module m_simpletest1
using Test
using Sparspak
using Random, SparseArrays, LinearAlgebra
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!,  triangularsolve!

function test()
    p = SpkProblem.Problem(4, 4)
    inaij!(p, 1, 1, 1.21883);   
    inaij!(p, 2, 1, 0.0243952);
    inaij!(p, 4, 1, 0.340938);
    inaij!(p, 2, 2, 1.0);
    inaij!(p, 3, 3, 1.53656);
    inaij!(p, 1, 4, 0.942235);
    inaij!(p, 4, 4, 1.0);
    inbi!(p, 1, 1.0)
    A = outsparse(p)
    # @show   Matrix(A)
    # @show p.rhs
    x1 = A \ p.rhs
    s = SpkSparseSolver.SparseSolver(p)
    solve!(s)

    A = outsparse(p)
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6
    @test norm(p.x - x1) / norm(x1) < 1.0e-6
end

test()
end

module m_inconsistency_data_structure_symm
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!,  triangularsolve!

function makeaproblem()
    # Matrix is not symmetric, but it does have a symmetric structure.
    n = 4
    A = [1.21883    -0.02432  0.0     0.942235;
        0.0243952    1.0      0.0      0.0;
        0.0          0.0      1.53656  0.0;
        0.340938     0.0      0.0      1.0]

    p = SpkProblem.Problem(n, n)
    for i in 1:n, j in 1:n
        if A[i, j] != 0.0
            inaij!(p, i, j, A[i, j])
        end
    end
    inbi!(p, 1, 1.0)
    
    return p
end

function _test()
    p = makeaproblem()
    
    s = SparseSolver(p)
    
    solve!(s)

    A = outsparse(p)
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
end # module

module m_inconsistency_data_structure_unsymm
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkOrdering
using Sparspak.SpkProblem
using Sparspak.SpkProblem: inaij!, inbi!, outsparse
using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!,  triangularsolve!

function makeaproblem()
    # Matrix is not symmetric, and it does not have a symmetric structure.
    n = 4
    A = [1.21883    -0.02432  0.0      0.0;
        0.0          1.0      0.0      0.0;
        0.0          0.0      1.53656  0.0;
        0.340938     0.0      0.0      1.0]

    p = SpkProblem.Problem(n, n)
    for i in 1:n, j in 1:n
        if A[i, j] != 0.0
            inaij!(p, i, j, A[i, j])
        end
    end
    inbi!(p, 1, 1.0)
    
    return p
end

function _test()
    p = makeaproblem()
    
    s = SparseSolver(p)
    
    solve!(s)

    A = outsparse(p)
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6

    return true
end

_test()
end # module

module GenericBlasLapackFragments

#
# This module provides generic implementations of those parts of the BLAS/LAPACK
# API which are used in Sparspak.jl. 
# 
# With the exception of  ggetrf!, the implementations are rewrites of the corresponding routines
# from LAPACK 3.10.1 published on  https://netlib.org/lapack/explore-html/.
# As they are not used "in the wild", but rather in the controlled environment of this package,
# input consistency tests and bound checks have been removed in favor of performance. Any
# generalization for wider use should consider removal the @inbounds macros.
#
# They metods are  tested against
# the implementations in Sparspak.SpkSpdMMops which call into BLAS/LAPACK.


using LinearAlgebra


# As  Sparspak passes all matrix data as vectors, we create wrapper structs
# to organize 2D indexing which conforms to the usage in the BLAS routines.
# These are _not_ coforming to the abstract matrix interface as they miss
# the size() method. A proper size() method would have to take into account
# transposed and non-transposed cases etc.
# In the routines, the compiler will optimize them away, or rather place
# them on the stack as immutable objects, so this approach leaves no
# trace in the allocation statistics.
#
# The @inbounds macros in the accessor methods are the only ones in this
# package (besides of glawsp)

# Previously `StridedReshape{Tv,Ti}` constrained the underlying buffer to be a
# `Vector{Tv}` or a `SubArray` over a `UnitRange{Ti}`, which forced the index
# integer type of the slice to match the `lda` integer type. That fails when
# `lda` is `Int32` (derived from a `SparseMatrixCSC{Float64,Int32}`) but the
# slice was materialized with `Int` ranges. The buffer and the `lda` integer
# type are now independent type parameters so the wrapper accepts mixed-index
# views without copying.
struct StridedReshape{Tv,Ti<:Integer,V<:AbstractVector{Tv}}
    v::V
    lda::Ti
end

@inline idx(A::StridedReshape, i,j)= (j-1)*A.lda+i
Base.getindex(A::StridedReshape,i,j)= @inbounds A.v[idx(A,i,j)]
Base.setindex!(A::StridedReshape,v,i,j)= @inbounds A.v[idx(A,i,j)]=v

Base.getindex(A::StridedReshape,i)= @inbounds A.v[i]
Base.setindex!(A::StridedReshape,v,i)= @inbounds A.v[i]=v


#
# LU factorization adapted from generic_lufact! (https://github.com/JuliaLang/LinearAlgebra.jl/blob/main/src/lu.jl).
# Originally it is (like many other LA operators) defined for StridedMatrix which is a union and not an abstract type,
# so we cannot use that code directly. See https://github.com/JuliaLang/julia/issues/2345 for some discussion about this.
#
# Modifications:
# - Use ipiv passed instead of creating one
# - No need to return LU object 
# - Remove unused parameters - always do pivoting anyway
#
#
function ggetrf!(m,n,a::AbstractVector{FT},lda,ipiv) where FT

    minmn = min(m,n)
    A=StridedReshape(a,lda)
    
    begin
        for k = 1:minmn
            # find index max
            kp = k
            if k < m #   pivot === RowMaximum() &&
                amax = abs(A[k,k])
                for i = k+1:m
                    absi = abs(A[i,k])
                    if absi > amax
                        kp = i
                        amax = absi
                    end
                end
            end
            ipiv[k] = kp
            if !iszero(A[kp,k])
                if k != kp
                    # Interchange
                    for i = 1:n
                        tmp = A[k,i]
                        A[k,i] = A[kp,i]
                        A[kp,i] = tmp
                    end
                end
                # Scale first column
                Akkinv = inv(A[k,k])
                for i = k+1:m
                    A[i,k] *= Akkinv
                end
            end
            # Update the rest
            for j = k+1:n
                for i = k+1:m
                    A[i,j] -= A[i,k]*A[k,j]
                end
            end
        end
    end
    0
end




#
# C=alpha*transA(A)*transB(B) + beta*C
#
function ggemm!(transA,transB,m,n,k,alpha,a::AbstractVector{T},lda,b::AbstractVector{T},ldb,beta,c::AbstractVector{T},ldc) where T
    oneT=one(T)
    zeroT=zero(T)
    nota= (transA=='n')
    notb= (transB=='n')

    A=StridedReshape(a,lda)
    B=StridedReshape(b,ldb)
    C=StridedReshape(c,ldc)
    
    
    # skip the iput tests
    
    
    if m==0 || n==0 || ( (iszero(alpha) || k==0) && isone(beta))
        return
    end
    
    if iszero(alpha)
        if iszero(beta)
            for i=1:n*m
                C[i]=zeroT
            end
        else
            for i=1:n*m
                C[i]*=beta*C[i]
            end
        end
        return 
    end
    
    if notb
        if nota
            #  C := alpha*A*B + beta*C.
            for j = 1:n # DO 90
                if iszero(beta)
                    for i=1:m
                        C[i,j] = zeroT
                    end
                elseif !isone(beta)
                    for i=1:m
                        C[i,j] *= beta
                    end
                end
                for l=1:k
                    temp = alpha*B[l,j]
                    for i=1:m
                        C[i,j] += temp*A[i,l]
                    end
                end
            end
        else
            #   C := alpha*A**T*B + beta*C
            for j=1:n
                for i=1:m
                    temp=zeroT
                    for l=1:k
                        temp += A[l,i]*B[l,j]
                    end
                    if beta==zeroT
                        C[i,j] = alpha*temp
                    else
                        C[i,j] = alpha*temp + beta*C[i,j]
                    end
                end
            end
        end
    else
        if nota
            #   C := alpha*A*B**T + beta*C
            for j=1:n
                if iszero(beta)
                    for i=1:m
                        C[i,j] = zeroT
                    end
                elseif !isone(beta)
                    for i=1:m
                        C[i,j] = beta*C[i,j]
                    end
                end
                for l=1:k
                    temp = alpha*B[j,l]
                    for i=1:m
                        C[i,j] += temp*A[i,l]
                    end
                end
            end
        else
            #   C := alpha*A**T*B**T + beta*C
            for j=1:n
                for i=1:m
                    temp=zeroT
                    for l=1:k
                        temp +=  A[l,i]*B[j,l]
                    end
                    if iszero(beta)
                        C[i,j] = alpha*temp
                    else
                        C[i,j] = alpha*temp + beta*C[i,j]
                    end
                end
            end
        end
    end
end



#
# Y=alpha*transA(A)*X + beta*Y
#
function ggemv!(transA,m,n,alpha,a::AbstractVector{T},lda,X,beta,Y) where T
    if m==0 || n==0
        return
    end
    
    A=StridedReshape(a,lda)
    
    if transA=='n'
        for i=1:m
            Y[i]*=beta
        end
        ii0=1
        for j=1:n # DO 60
            ii=ii0
            alphax=alpha*X[j]
            for i=1:m # DO 50
                Y[i]+=alphax*A[ii]
                ii+=1
            end
            ii0+=lda
        end
    else
        ii0=1
        for j=1:n # DO 120
            Y[j]*=beta
            temp=zero(T)
            ii=ii0
            for i=1:m # DO 110
                temp+=A[ii]*X[i]
                ii+=1
            end
            Y[j]+=alpha*temp
            ii0+=lda
        end
    end
    true
end





#
# Triangular solve
#
function gtrsm!(side,uplo,transA,diag, m,n,alpha,a::AbstractVector{T}, lda, b::AbstractVector{T}, ldb) where T

    if m==0 || n==0
        return
    end
    
    lside = (side=='l')
    nounit = (diag=='n')
    upper = (uplo=='u')
    
    # dimsA = (lda, lside ? m : n)
    # A=StridedReshape(view(a, 1:prod(dimsA)), lda)
    # dimsB = (ldb, n)
    # B=StridedReshape(view(b, 1:prod(dimsB)), ldb)

    A=StridedReshape(a,lda)
    B=StridedReshape(b,ldb)

    oneT=one(T)
    zeroT=zero(T)

    
    # println("A[1:$(dimsA[1]), 1:$(dimsA[2])] = ")
    # for r in 1:(dimsA[1])
    #     for c in 1:(dimsA[2])
    #         print(A[r,c], ", ")  
    #     end
    #     println()
    # end

    # println("B[1:$(dimsB[1]), 1:$(dimsB[2])] = ")
    # for r in 1:(dimsB[1])
    #     for c in 1:(dimsB[2])
    #         print(B[r,c], ", ")  
    #     end
    #     println()
    # end

    oneT=one(T)
    zeroT=zero(T)
    
    # skip input check
    
    if iszero(alpha)
        for i=1:m*n
            B[i]=zeroT
        end
        return
    end
    
    if lside
        if transA== 'n'
            # form  B := alpha*inv( A )*B.
            if upper
                for j=1:n
                    if !isone(alpha)
                        for i=1:m
                            B[i,j] *= alpha
                        end
                    end
                    for k=m:-1:1
                        if !iszero(B[k,j])
                            if nounit
                                B[k,j] /= A[k,k]
                            end
                            for i=1:k-1
                                B[i,j] -= B[k,j]*A[i,k]
                            end
                        end
                    end
                end
            else # !upper
                for j=1:n
                    if !isone(alpha)
                        for i=1:m
                            B[i,j] *= alpha
                        end
                    end
                    for k=1:m
                        if !iszero(B[k,j])
                            if nounit
                                B[k,j] /= A[k,k]
                            end
                            for i=k+1:m
                                B[i,j] -=  B[k,j]*A[i,k]
                            end
                        end
                    end
                end
            end
        else # transa=='t'
            #  form  B := alpha*inv( A**T )*B.
            if upper
                for j=1:n
                    for i=1:m
                        temp = alpha*B[i,j]
                        for k=1:i-1
                            temp -=  A[k,i]*B[k,j]
                        end
                        B[i,j] = temp
                        if nounit
                            temp /= A[i,i]
                        end
                        B[i,j]=temp
                    end
                end
            else #!upper
                for j=1:n
                    for i=m:-1:1
                        temp = alpha*B[i,j]
                        for k=i+1:m
                            temp -= A[k,i]*B[k,j]
                        end
                        if nounit
                            temp /= A[i,i]
                        end
                        B[i,j] = temp
                    end
                end
            end
        end
    else # !lside
        if transA== 'n'
            #    form  B := alpha*B*inv( A ).
            if upper
                for j=1:n
                    if !isone(alpha)
                        for i=1:m
                            B[i,j] = alpha*B[i,j]
                        end
                    end
                    for k=1:j-1
                        if !iszero(A[k,j])
                            for i=1:m
                                B[i,j] -= A[k,j]*B[i,k]
                            end
                        end
                    end
                    if nounit
                        temp=oneT/A[j,j]
                        for i=1:m
                            B[i,j] *= temp
                        end
                    end
                end
            else #!upper
                for j=n:-1:1
                    if !isone(alpha)
                        for i=1:m
                            B[i,j] *= alpha
                        end
                    end
                    for k=j+1:n
                        if !iszero(A[k,j])
                            for i=1:m
                                B[i,j] -= A[k,j]*B[i,k]
                            end
                        end
                    end
                    if nounit
                        temp = oneT/A[j,j]
                        for i=1:m
                            B[i,j] *= temp
                        end
                    end
                end
            end
        else
            # form  B := alpha*B*inv( A**T ).
            if upper
                for k=n:-1:1
                    if nounit
                        temp = oneT/A[k,k]
                        for i=1:m
                            B[i,k] *= temp
                        end
                    end
                    for j=1:k-1
                        if !iszero(A[j,k])
                            temp = A[j,k]
                            for i=1:m
                                B[i,j] -= temp*B[i,k]
                            end
                        end
                    end
                    if !isone(alpha)
                        for i=1:m
                            B[i,k] *= alpha
                        end
                    end
                end
            else #!upper
                for k=1:n
                    if nounit
                        temp = oneT/A[k,k]
                        for i=1:m
                            B[i,k] *= temp
                        end
                    end
                    for j=k+1:n
                        if !iszero(A[j,k])
                            temp = A[j,k]
                            for i=1:m
                                B[i,j] -=  temp*B[i,k]
                            end
                        end
                    end
                    if !isone(alpha)
                        for i=1:m
                            B[i,k] *= alpha
                        end
                    end
                end
            end
        end
    end
end


#
# Vector entry swap according to ipiv
#
function glaswp!(a,lda,k1,k2,ipiv)
    @inbounds for i=k1:k2
        ip=ipiv[i]
        if ip!=i
            temp=a[i]
            a[i]=a[ip]
            a[ip]=temp
        end
    end
end


end

using Test
using Logging: disable_logging, global_logger, ConsoleLogger, BelowMinLevel, min_enabled_level

# # disable_logging(BelowMinLevel)
# # global_logger(ConsoleLogger(stderr, BelowMinLevel))

# # @show min_enabled_level(global_logger())

# module mspdsprs001
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkProblem
# using Sparspak.SpkSparseSpdBase

# function _test()
#     # Matrix from Figure 3.1.3
#     M, N = 6, 6
#     I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
#     J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
#     V = [1.0 for _ in I]
#     spm = sparse(I, J, V, M, N)
#     p = SpkProblem.Problem(M, N)
#     SpkProblem.insparse!(p, spm)
#     s = SpkSparseSpdBase._SparseSpdBase(p)
#     return true
# end

# _test()
# end # module

# module mspdsprs002
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkProblem
# using Sparspak.SpkSparseSpdSolver: SpkSparseSpdSolver, findorder!, symbolicfactor!, inmatrix!

# function _test()
#     # Matrix from Figure 3.1.3
#     M, N = 6, 6
#     I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
#     J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
#     V = [1.0 for _ in I]
#     spm = sparse(I, J, V, M, N)
#     p = SpkProblem.Problem(M, N)
#     SpkProblem.insparse!(p, spm)
#     s = SpkSparseSpdSolver.SparseSpdSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)
#     # inmatrix!(s)
#     # @show s
#     return true
# end

# _test()
# end # module

# module mspdsprs003
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkProblem
# using Sparspak.SpkSparseSpdSolver: SpkSparseSpdSolver, findorder!, symbolicfactor!, inmatrix!, factor!

# function _test()
#     # Matrix from Figure 3.1.3
#     M, N = 6, 6
#     I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
#     J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
#     V = [1.0 for _ in I]
#     spm = sparse(I, J, V, M, N)
#     p = SpkProblem.Problem(M, N)
#     SpkProblem.insparse!(p, spm)
#     s = SpkSparseSpdSolver.SparseSpdSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)
#     inmatrix!(s)
#     factor!(s)
#     return true
# end

# _test()
# end # module


module mspdsprs004
using Test
using LinearAlgebra
using SparseArrays
using Sparspak.SpkProblem
using Sparspak.SpkProblem: outsparse
using Sparspak.SpkSparseSpdSolver: SpkSparseSpdSolver, findorder!, symbolicfactor!, inmatrix!, solve!

function _test()
    # Matrix from Figure 3.1.3
    M, N = 4, 4
    J = [1, 1, 2, 2, 2, 3, 3, 3, 4, 4]
    I = [1, 2, 1, 2, 3, 2, 3, 4, 3, 4]
    V = [4.0, -1.0, -1.0, 4.0, -1.0, -1.0, 4.0, -1.0, -1.0, 4.0]
    spm = sparse(I, J, V, M, N)
    rhs = [2.0, 4.0, 6.0, 13.0]
    @show spm, (x = spm \ rhs)
    p = SpkProblem.Problem(M, N)
    SpkProblem.insparse!(p, spm)
    SpkProblem.infullrhs!(p, rhs)
    s = SpkSparseSpdSolver.SparseSpdSolver(p)
    findorder!(s)
    symbolicfactor!(s)
    inmatrix!(s)
    solve!(s)
    
    A = Float64.(outsparse(p)) # no generic method for sparse...
    x = A \ p.rhs
    @test norm(p.x - x) / norm(x) < 1.0e-6
    return true
end

_test()
end # module

# module mspdsprs004
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: outsparse
# using Sparspak.SpkSparseSpdSolver: SpkSparseSpdSolver, findorder!, symbolicfactor!, inmatrix!, solve!

# function _test()
#     # Matrix from Figure 3.1.3
#     M, N = 6, 6
#     I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 6]
#     J = [1, 2, 6, 1, 2, 3, 4, 2, 3, 5, 2, 4, 3, 5, 6, 1, 5, 6]
#     V = [1.0 for _ in I]
#     spm = sparse(I, J, V, M, N)
#     @show spm, (x = spm \ [1.0, 2.0, 3.0, 4.0, 5.0, 6.0])
#     p = SpkProblem.Problem(M, N)
#     SpkProblem.insparse!(p, spm)
#     SpkProblem.infullrhs!(p, [1.0, 2.0, 3.0, 4.0, 5.0, 6.0])
#     s = SpkSparseSpdSolver.SparseSpdSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)
#     inmatrix!(s)
#     solve!(s)
    
#     A = Float64.(outsparse(p)) # no generic method for sparse...
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6
#     return true
# end

# _test()
# end # module

# module mspdsprs004
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkOrdering
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: inaij!, inbi!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!

# function maketridiagproblem(n)
#     p = SpkProblem.Problem(n, n)
#     for i in 1:(n-1)
#         inaij!(p, i + 1, i, -1.0)
#         inaij!(p, i, i, 4.0)
#         inaij!(p, i, i + 1, -1.0)
#         inbi!(p, i, 2.0 * i)
#     end
#     inaij!(p, n, n, 4.0)
#     inbi!(p, n, 3.0 * n + 1.0)

#     return p
# end

# function _test()
#     p = maketridiagproblem(11)
#     # @show outsparse(p)
#     s = SparseSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)

#     @test s.slvr.xlnz == [1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21, 23]
#     @test s.slvr.xunz == [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10]
    
#     @test s.slvr.xlindx == [1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21]
#     @test s.slvr.lindx == [1, 2, 2, 3, 3, 4, 4, 5, 5, 11, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11]
      
#     return true
# end

# _test()
# end # module


# module mspdsprs005
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkOrdering
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: inaij!, inbi!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!
# using MultiFloats

# function maketridiagproblem(n,T=Float64)
#     p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
#     for i in 1:(n-1)
#         inaij!(p, i + 1, i, T(-1.0))
#         inaij!(p, i, i, T(4.0))
#         inaij!(p, i, i + 1, T(-1.0))
#         inbi!(p, i, T(2.0 * i))
#     end
#     inaij!(p, n, n, T(4.0))
#     inbi!(p, n, 3.0 * n + T(1.0))

#     return p
# end

# function _test(T=Float64)
#     p = maketridiagproblem(11,T)
#     # @show outsparse(p)
#     s = SparseSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)
#     inmatrix!(s)
    
#    @test s.slvr.unz  == vec(T[-1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0])
#    @test s.slvr.lnz  == vec(T[4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0,  4.0, -1.0, -1.0,  4.0])
#    @test s.slvr.xunz == vec([1           2           3           4        5           6           7           8           9          10          10            10])
#      @test s.slvr.xlnz == vec([1           3           5           7           9          11          13          15          17          19          21          23])
#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module


# module mspdsprs006
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkOrdering
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: inaij!, inbi!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!

# using MultiFloats

# function maketridiagproblem(n,T=Float64)
#     p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
#     for i in 1:(n-1)
#         inaij!(p, i + 1, i, T(-1.0))
#         inaij!(p, i, i, T(4.0))
#         inaij!(p, i, i + 1, T(-1.0))
#         inbi!(p, i, T(2.0 * i))
#     end
#     inaij!(p, n, n, T(4.0))
#     inbi!(p, n, 3.0 * n + T(1.0))

#     return p
# end


# function _test(T=Float64)
#     p = maketridiagproblem(11,T)
#     # @show outsparse(p)
#     s = SparseSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)
#     inmatrix!(s)
#     factor!(s)
#     s_xlnz = vec([ 1           3           5           7           9          11          13          15          17          19          21          23])
#     s_xunz = vec([ 1           2           3           4           5           6           7           8           9          10          10          10 ])
#     @test s.slvr.xlnz == s_xlnz
#     @test s.slvr.xunz == s_xunz
#     s_lnz  = T[  4.0, -0.25000000000000000, 3.7500000000000000, -0.26666666666666666, 3.7333333333333334, -0.26785714285714285, 3.7321428571428572
# , -0.26794258373205743, 3.7320574162679425, -0.26794871794871794, 4.0, -0.25000000000000000, 3.7500000000000000, -0.26666666666666666, 3.7333333333333334, -0.26785714285714285, 3.7321428571428572, -0.26794258373205743, 3.7320574162679425, -0.26794871794871794, -1.0000000000000000, 3.4641025641025642     ]
#     s_unz = T[ -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0]
#     @test norm(s.slvr.lnz - s_lnz) / norm(s_lnz) < 1e-6
#     @test norm(s.slvr.unz - s_unz) / norm(s_unz) < 1e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module


# module mspdsprs007
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkOrdering
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: inaij!, inbi!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!

# using MultiFloats

# function maketridiagproblem(n,T=Float64)
#     p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
#     for i in 1:(n-1)
#         inaij!(p, i + 1, i, T(-1.0))
#         inaij!(p, i, i, T(4.0))
#         inaij!(p, i, i + 1, T(-1.0))
#         inbi!(p, i, T(2.0 * i))
#     end
#     inaij!(p, n, n, T(4.0))
#     inbi!(p, n, 3.0 * n + T(1.0))

#     return p
# end


# function _test(T=Float64)
#     p = maketridiagproblem(11,T)
    
#     s = SparseSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)
#     inmatrix!(s)
#     factor!(s)
#     solve!(s)
#     A = Float64.(outsparse(p)) # no generic method for sparse...
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module


# module mspdsprs008
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkOrdering
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: inaij!, inbi!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!

# using MultiFloats
# function maketridiagproblem(n,T=Float64)
#     p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
#     for i in 1:(n-1)
#         inaij!(p, i + 1, i, T(-1.0))
#         inaij!(p, i, i, T(4.0))
#         inaij!(p, i, i + 1, T(-1.0))
#         inbi!(p, i, T(2.0 * i))
#     end
#     inaij!(p, n, n, T(4.0))
#     inbi!(p, n, 3.0 * n + T(1.0))

#     return p
# end

# function _test(T=Float64)
#     p = maketridiagproblem(11000,T)
    
#     s = SparseSolver(p)
#     findorder!(s)
#     symbolicfactor!(s)
#     inmatrix!(s)
#     factor!(s)
#     # before  LULSolve
#     # rhs = 34.0, 20.0, 18.0, 16.0, 14.0, 2.00, 4.00, 6.00, 8.00, 10.0, 12.0
#     # after  LULSolve
#     # rhs = 34.0, 28.5, 25.6, 22.857142857142858, 20.124401913875598, 2.00, 4.50, 7.2, 9.9285714285714288, 12.660287081339714, 20.784615384615385
#     solve!(s)
#     A = Float64.(outsparse(p))
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module


# module mspdsprs009
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkOrdering
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: inaij!, inbi!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver,  solve!

# using MultiFloats

# function maketridiagproblem(n,T=Float64)
#     p = SpkProblem.Problem(n, n, 2*(n-1)+1, zero(T))
#     for i in 1:(n-1)
#         inaij!(p, i + 1, i, T(-1.0))
#         inaij!(p, i, i, T(4.0))
#         inaij!(p, i, i + 1, T(-1.0))
#         inbi!(p, i, T(2.0 * i))
#     end
#     inaij!(p, n, n, T(4.0))
#     inbi!(p, n, 3.0 * n + T(1.0))

#     return p
# end

# function _test(T=Float64)
#     p = maketridiagproblem(1101)

#     s = SparseSolver(p)
#     solve!(s)
#     A = Float64.(outsparse(p))
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module


# module mspdsprs010
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak
# using Sparspak.SpkProblem: insparse!, outsparse, infullrhs!
# using Sparspak.SpkSparseSolver: SparseSolver, solve!

# using MultiFloats

# function makerandomproblem(n,T=Float64)
    
#     spm = sparse([1, 2, 10, 25, 27, 3, 18, 29, 4, 5, 27, 4, 5, 10, 6, 22, 7, 8,
#     20, 9, 16, 19, 2, 5, 10, 16, 22, 26, 11, 21, 12, 28, 13, 31, 14, 15, 14, 15, 9, 10, 16, 22, 17, 21, 23, 24, 3, 18, 23, 25, 9, 19, 8, 20, 11, 17, 21, 31, 6, 10, 16, 22, 23, 17, 18, 22, 23, 17, 24, 26, 27, 2, 18, 25, 28, 10, 24, 26, 2, 4, 24, 27, 12, 25, 28, 29, 3, 28, 29, 30, 29, 30, 13, 21, 31], [1, 2,
#     2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 7, 8, 8, 9, 9, 9, 10, 10, 10, 10,
#     10, 10, 11, 11, 12, 12, 13, 13, 14, 14, 15, 15, 16, 16, 16, 16, 17, 17, 17,
#     17, 18, 18, 18, 18, 19, 19, 20, 20, 21, 21, 21, 21, 22, 22, 22, 22, 22, 23,
#     23, 23, 23, 24, 24, 24, 24, 25, 25, 25, 25, 26, 26, 26, 27, 27, 27, 27, 28,
#     28, 28, 28, 29, 29, 29, 29, 30, 30, 31, 31, 31], T[20.0, 20.0, -0.47048158392539896, -0.40373736633011315, -0.29904858543128643, 20.0, -0.8929708555328307, -0.25537381390842373, 20.0, -0.517204141985797, -0.4252150843692021, -0.517204141985797, 20.0, -0.007891864303108176, 20.0, -0.11187965399280864, 20.0, 20.0, -0.8431376173205444, 20.0, -0.867243409546438, -0.4387621276975887, -0.47048158392539896, -0.007891864303108176, 20.0, -0.5439984352593679, -0.7864685314415719, -0.6207822487609463, 20.0, -0.6015829471856056, 20.0, -0.958084621680583, 20.0, -0.21766891770662522, 20.0, -0.5616538599777784, -0.5616538599777784, 20.0, -0.867243409546438, -0.5439984352593679, 20.0, -0.48381531848154047, 20.0, -0.9600900246453297, -0.6481282913652262, -0.4940551331266394, -0.8929708555328307, 20.0, -0.6974069191376576, -0.9476414447186581, -0.4387621276975887, 20.0, -0.8431376173205444, 20.0, -0.6015829471856056,
#     -0.9600900246453297, 20.0, -0.9160515550545547, -0.11187965399280864, -0.7864685314415719, -0.48381531848154047, 20.0, -0.47566304294326156, -0.6481282913652262, -0.6974069191376576, -0.47566304294326156, 20.0, -0.4940551331266394, 20.0, -0.5220628570371777, -0.6929780200563616, -0.40373736633011315, -0.9476414447186581, 20.0, -0.013202153574752407, -0.6207822487609463, -0.5220628570371777, 20.0, -0.29904858543128643, -0.4252150843692021, -0.6929780200563616, 20.0, -0.958084621680583, -0.013202153574752407, 20.0, -0.14134601702703786, -0.25537381390842373, -0.14134601702703786, 20.0, -0.43870135287699785, -0.43870135287699785, 20.0, -0.21766891770662522, -0.9160515550545547,
#     20.0], 31, 31)
    
#     p = Sparspak.SpkProblem.Problem(n, n, nnz(spm))
#     Sparspak.SpkProblem.insparse!(p, spm);
#     Sparspak.SpkProblem.infullrhs!(p, 1:n)
#     return p
# end

# function _test(T=Float64)
#     p = makerandomproblem(31)
    
#     s = SparseSolver(p)
#     solve!(s)
    
#     A = Matrix(outsparse(p))
    
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module

# module mspdsprs011
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak
# using Sparspak.SpkProblem: insparse!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver
# using MultiFloats

# function _test(T=Float64)
#     n = 31
#     spm = sprand(T, n, n, 1/n)
#     spm = -spm - spm' + 20 * LinearAlgebra.I

#     p = Sparspak.SpkProblem.Problem(n, n, nnz(spm), zero(T))
#     Sparspak.SpkProblem.insparse!(p, spm);
#     A = outsparse(p)
#     @test A - spm == sparse(Int64[], Int64[], T[], 31, 31)


#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module


# module mspdsprs012
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak
# using Sparspak.SpkProblem: insparse!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, solve!
# using MultiFloats

# function makerandomproblem(n,T=Float64)
#     spm = sprand(T, n, n, 1/n)
#     spm = -spm - spm' + n * LinearAlgebra.I
    
#     p = Sparspak.SpkProblem.Problem(n, n,nnz(spm), zero(T))
#     Sparspak.SpkProblem.insparse!(p, spm);
#     Sparspak.SpkProblem.infullrhs!(p, 1:n);
#     return p
# end

# function _test(T=Float64)

#     p = makerandomproblem(301,T)

#     s = SparseSolver(p)
#     solve!(s)
#     A = Matrix(outsparse(p))
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module


# # module mspdsprs013
# # using Test
# # using LinearAlgebra
# # using SparseArrays
# # using DataDrop
# # using Sparspak
# # using Sparspak.Problem: Problem, insparse, outsparse
# # using Sparspak.SparseSolver: SparseSolver, findorder, symbolicfactor, inmatrix, factor, solve
# # # using ProfileView
# # # using InteractiveUtils

# # function _test()
# #     K = DataDrop.retrieve_matrix("K63070.h5")
# #     # K = DataDrop.retrieve_matrix("K28782.h5")
# #     @show size(K)
# #     I, J, V = findnz(K)

# #     p = Problem(size(K)...)
# #     insparse(p, I, J, V);
# #     s = Sparspak.SpkSparseSolver.SparseSolver(p);
# #     @time findorder(s)
# #     symbolicfactor(s)
# #     inmatrix(s, p)
# #     @time factor(s)
# #     # @time factor(s)
# #     # @profview factor(s)
# #     @time solve(s, p);

# #     @info "$(@__FILE__): Now lu"
# #     @time lu(K)

# #     @info "$(@__FILE__): Now cholesky"
# #     @time cholesky(K)

# #     return true
# # end

# # _test()
# # end # module


# # module mspdsprs014
# # using Test
# # using LinearAlgebra
# # using SparseArrays
# # using Sparspak
# # using Sparspak.SpkProblem: insparse, outsparse
# # using Sparspak.SpkSparseSolver: SparseSolver, findorder, symbolicfactor, inmatrix, factor, solve
# # using Printf

# # function makerandomproblem(n)
# #     p = Sparspak.SpkProblem.Problem(n, n)
# #     spm = sprand(n, n, 1/n)
# #     spm = -spm - spm' + 20 * LinearAlgebra.I
    
# #     Sparspak.SpkProblem.insparse(p, spm);
# #     Sparspak.SpkProblem.infullrhs(p, 1:n);

# #     matrix = "matrix$(n).txt"
# #     I, J, V = findnz(spm)
# #     @show

# #     f = open(matrix, "w")
# #     @printf(f, "%d %d\n", size(spm, 1), size(spm, 2))
# #     @printf(f, "%d\n", length(I))
# #     for i in eachindex(I)
# #         @printf(f, "%d\n", I[i])
# #     end
# #     for i in eachindex(J)
# #         @printf(f, "%d\n", J[i])
# #     end
# #     for i in eachindex(V)
# #         @printf(f, "%f\n", V[i])
# #     end
# #     close(f)

# #     return p
# # end

# # function _test()
# #     p = makerandomproblem(11)
    
# #     s = SparseSolver(p)
# #     solve(s, p)
# #     A = outsparse(p)
# #     x = A \ p.rhs
# #     @test norm(p.x - x) / norm(x) < 1.0e-6

# #     return true
# # end

# # _test()
# # end # module


# module mspdsprs015
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak
# using Sparspak.Problem: Problem, insparse!, outsparse, infullrhs!
# using Sparspak.SparseSolver: SparseSolver, solve!

# using MultiFloats
# function _test(T=Float64)
#     n = 357
#     A = sprand(T, n, n, 1/n)
#     A = -A - A' + 20 * LinearAlgebra.I
    
#     p = Problem(n, n, nnz(A), zero(T))
#     insparse!(p, A);
#     infullrhs!(p, 1:n);
    
#     s = SparseSolver(p)
#     solve!(s)
#     A = Float64.(outsparse(p))
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module

# module mspdsprs016
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.Problem: Problem, insparse!, outsparse, infullrhs!
# using Sparspak.SparseSolver: SparseSolver, solve!

# using MultiFloats
# function _test(T=Float64)
#     n = 1357
#     A = sprand(T, n, n, 1/n)
#     A = -A - A' + 20 * LinearAlgebra.I

#     p = Problem(n, n, nnz(A), zero(T))
#     insparse!(p, A);
#     infullrhs!(p, 1:n);

#     s = SparseSolver(p)
#     solve!(s)
#     A = Float64.(outsparse(p))
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# _test(Float64x1)
# _test(Float64x2)
# end # module

# module mspdsprs017
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak
# using Sparspak.SpkProblem: outsparse, makegridproblem, infullrhs!
# using Sparspak.SpkSparseSolver: SparseSolver, solve!
# using Printf

# function _test()
#     p = makegridproblem(5, 3)
#     infullrhs!(p, 1:p.nrows);
    
#     s = SparseSolver(p)
#     A = outsparse(p)
#     solve!(s)
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# end # module

# module mspdsprs018
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak
# using Sparspak.SpkProblem: outsparse, makegridproblem, makerhs!
# using Sparspak.SpkSparseSolver: SparseSolver, solve!
# using Printf

# function _test()
#     p = makegridproblem(5, 3)
#     makerhs!(p, Float64[]);
    
#     s = SparseSolver(p)
#     A = outsparse(p)
#     solve!(s)
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# end # module

# module mspdsprs019
# using Test
# using LinearAlgebra
# using SparseArrays
# using Sparspak.SpkOrdering
# using Sparspak.SpkProblem
# using Sparspak.SpkProblem: inaij!, inbi!, outsparse
# using Sparspak.SpkSparseSolver: SparseSolver, findorder!, symbolicfactor!, inmatrix!, factor!, solve!,  triangularsolve!

# function maketridiagproblem(n)
#     p = SpkProblem.Problem(n, n)
#     for i in 1:(n-1)
#         inaij!(p, i + 1, i, -1.0)
#         inaij!(p, i, i, 4.0)
#         inaij!(p, i, i + 1, -1.0)
#         inbi!(p, i, 2.0 * i)
#     end
#     inaij!(p, n, n, 4.0)
#     inbi!(p, n, 3.0 * n + 1.0)

#     return p
# end

# function _test()
#     p = maketridiagproblem(11)
    
#     s = SparseSolver(p)
#     # The actions are purposefully mixed up
#     @test_throws ErrorException symbolicfactor!(s) == false # ordering not done
    
    
#     findorder!(s)
#     @test_throws ErrorException inmatrix!(s) == false

#     findorder!(s)
#     symbolicfactor!(s)
#     @test_throws ErrorException factor!(s) == false

#     findorder!(s)
#     symbolicfactor!(s)
#     inmatrix!(s)
#     @test_throws ErrorException triangularsolve!(s) == false
    
#     solve!(s)

#     A = outsparse(p)
#     x = A \ p.rhs
#     @test norm(p.x - x) / norm(x) < 1.0e-6

#     return true
# end

# _test()
# end # module

module SpkGraph

using ..SpkUtilities: __extend
using ..SpkProblem: Problem

"""
    Graph{IT}

- `nv` - the number of vertices in the graph.
- `(xadj, adj)` - array pair storing the adjacency lists of the vertices.

The adjacency lists of the graph are stored in consecutive locations
in the array adj. The adjacency list for the `i` - th vertex in the graph
is stored in positions `adj[k]`, `k = xadj[i], .... xadj[i + 1] - 1`.

When the graph is symmetric, if vertex `i` is in vertex `j`'s adjacency
vertex `j` is in vertex `i`'s list. Using the representation above
each edge in the graph is stored twice.

There are no self - loops (no "diagonal elements") by default. If
diagonal elements are required, just input "diagonal" or "diag".

For convenience in accessing the lists, `xadj` is of length `nv + 1`, with
`xadj[nV + 1] = nEdges + 1`. Thus, accessing vertex `nv`'s list is the
same as for any other of the vertices.

Graphs are created from Problem objects, which have a certain number
of rows (`nrows`) and columns (`ncols`). These numbers are captured
and stored in Graph objects as `nrows` and `ncols` as well.
"""
mutable struct Graph{IT}
    # nv - the number of vertices in the graph.
    nv::IT
    nedges::IT
    nrows::IT
    ncols::IT
    # (xadj, adj) - array pair storing the adjacency lists of the vertices.
    xadj::Vector{IT}
    adj::Vector{IT}
end

"""
    Graph(p::Problem{IT}, diagonal=false) where {IT}

Construct a graph from a problem object.

It does not check that the problem object contains a structurally
symmetric matrix, since sometimes only the lower or upper triangle of
a symmetric matrix may be stored. There are routines in this module to
make a given graph object structurally symmetric.

Input:
- `p` - the problem object, used to create the graph
- `diagonal` - indicates that the diagonal elements are included. If
    diagonal is not given, the adjacency structure does not include
    the diagonal elements.
"""
function Graph(p::Problem{IT}, diagonal=false) where {IT}
    nv = p.ncols
    nrows = p.nrows
    ncols = p.ncols
    if (diagonal)
        nedges = p.nedges
    else
        nedges = p.nedges - p.dedges
    end
    xadj = zeros(IT, nv + 1)
    adj = zeros(IT, nedges)
    
    k = 1
    for i in 1:p.ncols
        ptr = p.head[i]
        xadj[i] = k
        while (ptr > 0)
            j = p.rowsubs[ptr]
            if (i != j || diagonal)
                adj[k] = j
                k = k + 1
            end
            ptr = p.link[ptr]
        end
    end
    
    xadj[p.ncols+1] = k
    
    return Graph(nv, nedges, nrows, ncols, xadj, adj)
end

"""
    makestructuresymmetric(g::Graph{IT}) where {IT}

Make the graph structure symmetric.
"""
function makestructuresymmetric(g::Graph{IT}) where {IT}
    if (isstructuresymmetric(g))
        return true
    end

    h = deepcopy(g)
    h.nv = g.nv
    h.nedges = g.nedges
    h.nrows = g.nrows
    h.ncols = g.ncols
    #   -  -  -
    #       The array c contains the edge counts for the symmetrized graph.
    #       These have to be determined in order to allocate space for the
    #       new (symmetrized) graph "h".
    #       The array "first" is a work vector; it marks the first element
    #       in each vertex list that has not yet been processed. Since it is
    #       assumed that the lists are in order, we can "march" through them,
    #       looking at each element only once. The complexity of this
    #       code is O(nEdges).
    # 
    c = zeros(IT, g.nv)
    first = zeros(IT, g.nv)
    c .= 0
    first .= g.xadj[1:g.nv]

    for i in 1:g.nv       # For each "column" list ...
        for j in first[i]:(g.xadj[i+1]-1)
            k = g.adj[j]
            c[i] = c[i] + 1

            if (k < i)             # "above" the diagonal ... end
                c[k] = c[k] + 1         # no element (i, k)
                h.nedges = h.nedges + 1 # in the lower triangle
            else                        # below the diagonal ...
                while (first[k] <= g.xadj[k+1])
                    if (first[k] == g.xadj[k+1])
                        # -  -  -  
                        #                           list is exhausted; no element (i, k)
                        #                           in the upper triangle.
                        # 
                        c[k] = c[k] + 1
                        h.nedges = h.nedges + 1
                        break
                    end
                    m = g.adj[first[k]]   # row number in column k
                    if (m < i)
                        #   end
                        #                           element is above i; no element (k, m)
                        #                           in the lower triangle. Update both counts
                        #                           and proceed to next element in the column.
                        # 
                        c[m] = c[m] + 1
                        h.nedges = h.nedges + 1
                        c[k] = c[k] + 1
                        first[k] = first[k] + 1
                    elseif (m == i)
                        #   end
                        #                           symmetric elements present; update column
                        #                           count for column k; no update for lower
                        #                           triangle needed; already recorded earlier.
                        #                           Suspend scan of column.
                        # 
                        c[k] = c[k] + 1
                        first[k] = first[k] + 1
                        break
                    else
                        # 
                        #                           element is below i; no element (i, k)
                        #                           in the upper triangle. Update column
                        #                           count; no count update for lower
                        #                           triangle needed; already recorded earlier.
                        #                           Suspend scan of column.
                        # 
                        c[k] = c[k] + 1
                        h.nedges = h.nedges + 1
                        break
                    end
                end # while
            end
        end
    end
    # 
    #       Allocate space for h now that nEdges is known.
    #       Compute xadj for h, and reset first for second pass through
    #       the original graph g.
    # 
    h.xadj = __extend(h.xadj, h.nv + 1)
    h.adj = __extend(h.adj, h.nedges)
    h.xadj[1] = 1

    for i in 1:g.nv
        first[i] = g.xadj[i]
        h.xadj[i+1] = h.xadj[i] + c[i]
        c[i] = h.xadj[i]
    end
    # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    #       Second pass ... is essentially identical to the first pass
    #       above, except we now have space to record the new edges,
    #       rather than just counting them.
    # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    for i in 1:g.nv       # For each "column" list ...
        for j = first[i]:(g.xadj[i+1]-1)
            k = g.adj[j]           # Add k to new list i
            h.adj[c[i]] = k
            c[i] = c[i] + 1
            if (k < i)        # "above" the diagonal ... 
                h.adj[c[k]] = i    # add i to new list k
                c[k] = c[k] + 1
            else                   # "below" the diagonal ...
                while (first[k] <= g.xadj[k+1])
                    if (first[k] == g.xadj[k+1])
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                        #                           list is exhausted; missing element in
                        #                           the upper triangle. Add i to new list k.
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                        h.adj[c[k]] = i
                        c[k] = c[k] + 1
                        break
                    end
                    m = g.adj[first[k]]  # row number in column k
                    if (m < i)
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  end
                        #                           element is above i; missing element in
                        #                           the lower triangle. Update both new lists
                        #                           and proceed to next element in the column.
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                        h.adj[c[m]] = k
                        c[m] = c[m] + 1
                        h.adj[c[k]] = m
                        c[k] = c[k] + 1
                        first[k] = first[k] + 1
                    elseif (m == i)
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  end
                        #                           symmetric elements present; add i to new
                        #                           list k; no change in the lower
                        #                           triangle needed; already recorded earlier.
                        #                           Suspend scan of column.
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                        h.adj[c[k]] = m
                        c[k] = c[k] + 1
                        first[k] = first[k] + 1
                        break
                    else
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                        #                           element is below i; no element (i, k)
                        #                           in the upper triangle. Update new list k.
                        #                           no adjustment for lower
                        #                           triangle needed; already recorded earlier.
                        #                           Suspend scan of column.
                        # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
                        h.adj[c[k]] = i
                        c[k] = c[k] + 1
                        break
                    end
                end
            end
        end
    end
    # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    #       Release storage for g, and  assign h to g.
    # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    g.nv = h.nv
    g.nedges = h.nedges
    g.nrows = h.nrows
    g.ncols = h.ncols
    g.xadj = h.xadj
    g.adj = h.adj
    # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    #       Sort the edges of the new graph in increasing order.
    #       By convention, graphs are maintained in this state for
    #       efficiency reasons.
    # -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
    sortgraph!(g)
    return true
end
 
"""
    sortgraph!(g::Graph{IT}) where {IT}

Sort the adjacency lists of the graph.

Important assumption:
This works only for graphs that are symmetric.
"""
function sortgraph!(g::Graph{IT}) where {IT}
    xadj = deepcopy(g.xadj)
    adj = zeros(IT, g.nedges)   
    for i in 1: g.nv
        for j in g.xadj[i]:(g.xadj[i + 1] - 1)
            k = g.adj[j];   adj[xadj[k]] = i
            xadj[k] = xadj[k] + 1
        end
    end
    g.adj .= adj
    return true
end

"""
    isstructuresymmetric(g::Graph{IT}) where {IT}

Determines if a graph is structurally symmetric.

Output: either true or false
"""
function isstructuresymmetric(g::Graph{IT}) where {IT}
    function findentry(i, j)
        for k = g.xadj[i]:g.xadj[i+1]-1
            if g.adj[k]==j
                return true
            end
        end
        return false
    end
    for i in 1: g.nv
        for k = g.xadj[i]:g.xadj[i+1]-1
            j = g.adj[k]
            if !findentry(j, i)
                return false
            end
        end
    end
    return true
end

end

"""
This module contains utility routines used by Sparspak90.
See the comments below in the interface section of the module.
"""
module SpkUtilities

_BIGGY() = typemax(Float64)


#     __extend(v::Vector, newlen::Integer, flagval=zero(eltype(v)))
# Change the size (smaller or larger).    
# - The contents of the vectors / arrays are preserved.
# - The changes in size may be positive or negative.
# - flagval is the initialization value of the new parts of the arrays.
#     If it is absent,  the default is zero (for numerical arrays).
function __extend(v::Vector, newlen::Integer, flagval=zero(eltype(v)))
    len = length(v)
    v = resize!(v, newlen)
    if newlen > len
        for i in len+1:newlen
            v[i] = flagval
        end
    end
    return v
end


#     __extend(v::Matrix, newrow::Integer, newcol::Integer, flagval=zero(eltype(v)))
# Change the size of a matrix (smaller or larger).
function __extend(v::Matrix, newrow::Integer, newcol::Integer, flagval=zero(eltype(v)))
    tempv = zeros(eltype(v), newrow, newcol)
    lencol = size(v, 2)
    lenrow = size(v, 1); 

    r = min(lenrow, newrow);
    c = min(lencol, newcol); 
    tempv[1:r, 1:c] .= @view v[1:r, 1:c]
    if (r < newrow)  tempv[r + 1:newrow, 1:newcol] .= flagval end
    if (c < newcol)  tempv[1:newrow, c + 1:newcol] .= flagval end

    return tempv
end

end # module 

# How-to guide

## How to install


The latest release of Sparspak can be installed from the Julia REPL prompt with

```julia
julia> ]add Sparspak
```

The closing square bracket switches to the package manager interface and the `add`
commands installs Sparspak and any missing dependencies.  To return to the Julia
REPL hit the `delete` key.



## How to solve a random problem

This code makes up a random-coefficient (but diagonally dominant) sparse matrix
and a simple right hand side vector. The sparse linear algebraic equation
problem is then solved with the LU factorization. The solution is tested
against the solution with the built-in solver.
```
using LinearAlgebra
using SparseArrays
using Sparspak.Problem: Problem, insparse!, outsparse, infullrhs!
using Sparspak.SparseSolver: SparseSolver, solve!

function _test()
    n = 1357
    A = sprand(n, n, 1/n)
    A = -A - A' + 20 * LinearAlgebra.I
    
    p = Problem(n, n)
    insparse!(p, A);
    infullrhs!(p, 1:n);
    
    s = SparseSolver(p)
    solve!(s)
    A = outsparse(p)
    x = A \ p.rhs
    @show norm(p.x - x) / norm(x) 

    return true
end

_test()
```
For more details see the file `test/test_sparse_method.jl`, module `msprs016`.

## How to improve performance

Use `MKL`:

```
using LinearAlgebra
using SparseArrays
using MKL # <------------- Notice we put this before referencing Sparspak
using Sparspak.Problem: Problem, insparse!, outsparse, infullrhs!
using Sparspak.SparseSolver: SparseSolver, solve!

function _test()
    n = 1357
    A = sprand(n, n, 1/n)
    A = -A - A' + 20 * LinearAlgebra.I
    
    p = Problem(n, n)
    insparse!(p, A);
    infullrhs!(p, 1:n);
    
    s = SparseSolver(p)
    solve!(s)
    A = outsparse(p)
    x = A \ p.rhs
    @show norm(p.x - x) / norm(x) 

    return true
end

_test()
```

# Functions

## Problem
```@meta
CurrentModule = Sparspak.SpkProblem
```


```@docs
Problem(nrows::IT, ncols::IT, nnz::IT=2500, z::FT=0.0, info = "") where {IT<:BlasInt, FT}
inaij!(p::Problem{IT,FT}, rnum, cnum, aij=zero(FT)) where {IT<:BlasInt,FT}
inbi!(p::Problem{IT, FT}, rnum::IT, bi::FT) where {IT<:BlasInt, FT}
insparse!(p::Problem{IT,FT}, spm) where {IT<:BlasInt,FT}
infullrhs!
outsparse
computeresidual
makerhs!
makegridproblem
```

## Sparse LU Solver

```@meta
CurrentModule = Sparspak.SpkSparseSolver
```

### Main interface

```@docs
SparseSolver
SparseSolver(p::Problem)
solve!
```

### Fine-granularity actions

```@docs
findorder!
findorderperm!
symbolicfactor!
inmatrix!
factor!
triangularsolve!
```
## LU Factorization API 

```@meta
CurrentModule = Sparspak.SparseCSCInterface
```

```@docs
sparspaklu
sparspaklu!
```

## Multiple minimum degree (MMD) ordering.

```@meta
CurrentModule = Sparspak.SpkMmd
```

```@docs
mmd!(g::Graph, order::Ordering)
```

## Graphs

```@meta
CurrentModule = Sparspak.SpkGraph
```

```@docs
Graph(p::Problem{IT}, diagonal=false) where {IT}
makestructuresymmetric(g::Graph{IT}) where {IT}
sortgraph!(g::Graph{IT}) where {IT}
isstructuresymmetric(g::Graph{IT}) where {IT}
```

## Grid

```@meta
CurrentModule = Sparspak.SpkGrid
```

```@docs
Grid(h::IT, k::IT) where {IT}
```

# Types

## Problem

```@meta
CurrentModule = Sparspak.SpkProblem
```

```@docs
Problem{IT, FT}
```

## Sparse LU Solver

```@meta
CurrentModule = Sparspak.SpkSparseSolver
```

```@docs
SparseSolver{IT, FT}
```

## Elimination Trees

```@meta
CurrentModule = Sparspak.SpkETree
```

```@docs
ETree{IT}
```

## Graphs

```@meta
CurrentModule = Sparspak.SpkGraph
```

```@docs
Graph{IT}
```

## Ordering

```@meta
CurrentModule = Sparspak.SpkOrdering
```

```@docs
Ordering{IT}
```

## Grid

```@meta
CurrentModule = Sparspak.SpkGrid
```

```@docs
Grid{IT}
```

# Concepts

## Performance

To compare the sparse LU factorization we can consider the UMFPACK `lu`
factorization from SuiteSparse, and the general LU sparse matrix factorization
of Sparspak. The former is a multi-frontal algorithm, the latter is a
super-nodal algorithm. Both rely quite heavily on dense algebra subroutines.

Some preliminary data was collected for one particular sparse matrix system, 
with a symmetric matrix,  63070 equations, 4.22 million non-zeros.

On a Surface Pro 7 with 16 GB of RAM, i7-1065G7 @ 1.30 GHz, the following results were gathered under Windows 10.


|         | UMFPACK | Sparspak |
| :---: | :---: | :---: |
| Without MKL [sec] | 22   |    31    |
| With MKL [sec] |    19   |   21 |

On the same machine with Windows Subsystem for Linux, WSL 2, running Ubuntu 22.04, the results were as


|         | UMFPACK | Sparspak |
| :---: | :---: | :---: |
| Without MKL  [sec] | 19   |    39    |
| With MKL  [sec] |    16   |   19 |

Clearly, MKL can make a huge difference 

Issues:

 
-- DOCUMENTER_KEY
```                                    
using Pkg; Pkg.add("DocumenterTools");                                 
using DocumenterTools                                                  
DocumenterTools.genkeys(user="PetrKryslUCSD", repo="git@github.com:PetrKryslUCSD/Sparspak.jl.git")                                                  
using Pkg; Pkg.rm("DocumenterTools");  
```

$ wsl --set-default-version 2
For information on key differences with WSL 2 please visit https://aka.ms/wsl2             
The operation completed successfully.                                                      

pkonl@Hedwig MINGW64 ~/Documents/00WIP/Sparspak.jl (main)                                  
$ wsl -l -v
  NAME            STATE           VERSION                                                  
* Ubuntu-22.04    Stopped         1                                                        
  Ubuntu-18.04    Stopped         1                                                        

pkonl@Hedwig MINGW64 ~/Documents/00WIP/Sparspak.jl (main)                                  
$ wsl --set-version Ubuntu-22.04 2  

# Sparspak Documentation


## Package features

- Solves systems of coupled linear algebraic equations with a sparse coefficient matrix.
- Reorderings of various kinds are supported, including the Multiple Minimum Degree (MMD).
- Factorizations of various kinds are supported.
- Solutions with multiple right hand sides, and solutions with preserved structure but changed matrix coefficients are supported. 
- Support of generic floating point types like those defined by [MultiFloats.jl](https://github.com/dzhang314/MultiFloats.jl), 
  [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl) (dual numbers), [IntervalArithmetic.jl](https://github.com/JuliaIntervals/IntervalArithmetic.jl),
  [Measuremets.jl](https://github.com/JuliaPhysics/Measurements.jl)

## Documentation

|          | Learning    |   Working   |
|:---: | :---: | :---: | 
| Practical    | [Tutorials](tutorials/tutorials.md) | [How to](howto/howto.md) |
| Theoretical    | [Concepts](concepts/concepts.md) | [Reference](man/man.md) |
